(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



Plot[UnitStep[x]//N,{x,-10,10},PlotStyle->Thick]


bipolarStep[x_]:= 2.UnitStep[x]-1.;
Plot[bipolarStep[x],{x,-10,10},PlotStyle->Thick]


Plot[x,{x,-10,10},PlotStyle->Thick]


sigmoid[x_,\[Alpha]_]:=1/(1+E^(-\[Alpha] x))//N;
sigmoid[x_] :=sigmoid[x,1.];
Manipulate[Plot[sigmoid[x,\[Alpha]],{x,-10,10},PlotStyle->Thick],{{\[Alpha],1},0,5,Appearance->"Labeled"}]


Plot[Tanh[x],{x,-10,10},PlotStyle->Thick]


Plot[ArcTan[x]/(\[Pi]/2),{x,-10,10},PlotStyle->Thick, PlotRange->{{-10,10},{-1,1}}]


perceptron[X_List,W_List]:=
bipolarStep[{1.}~Join~X.W] (* Subscript[x, 0]=1 for bias *)


data={{{-1,-1},-1},{{-1,1},-1},{{1,-1},-1},{{1,1},1}}; (* AND *)


dataLists[data_]:=Map[Map[First,#]&,GatherBy[data,#[[2]]<0&]]


perceptron[#[[1]],{0,0,0}]&/@data


applyPatternMP[W_,pattern_]:=
Module[{d,y,s,X},
y=perceptron[pattern[[1]],W]; (*perceptron output with weights W*)
d=pattern[[2]]; (*desired output*)
\[Mu]=0.3; (*learning rate*)
X = {1.}~Join~pattern[[1]]; (*input vector - Subscript[x, 0] set to 1 for threshold *)
s=X.W; (*perceptron inner potential*)
W+\[Mu] (d-y)X (* MP-perceptron *)
(*W+\[Mu] (d-s)X*) (* ADALINE *)
]


applyAllPaterns[W_,data_]:=Fold[applyPatternMP,W,data]


learn[W_,data_]:=FixedPointList[applyAllPaterns[#,data]&,W,30]


showClassification[W_,data_]:=
Show[
RegionPlot[W[[1]]+x W[[2]] + y W[[3]] <= 0,{x,-1.5,1.5},{y,-1.5,1.5}],
ListPlot[dataLists[data],AspectRatio->1,PlotStyle->PointSize[Large]],
Graphics[Inset[Grid[{{"\!\(\*SubscriptBox[\"w\", \"0\"]\) =",W[[1]]},{"\!\(\*SubscriptBox[\"w\", \"1\"]\) = ",W[[2]]},{"\!\(\*SubscriptBox[\"w\", \"2\"]\) = ",W[[3]]}},Frame->Center],{0,0}]]
]


dataXOR={{{-1,-1},-1},{{-1,1},1},{{1,-1},1},{{1,1},-1}}; (* XOR *)


ADALINEs={1+2x  +3 y ,1+3x  +1 y ,1+1x  -1 y} (* list of three MADALINEs with "random" weights and threshold *)


lineEquations=Reduce[#==0,{x,y}]&/@ADALINEs



