(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    631975,      11342]
NotebookOptionsPosition[    627478,      11185]
NotebookOutlinePosition[    627892,      11203]
CellTagsIndexPosition[    627849,      11200]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Activation (transfer) functions", "Section",
 CellChangeTimes->{{3.475739585837519*^9, 3.475739606660898*^9}, {
  3.475745552112119*^9, 3.475745557010164*^9}}],

Cell[CellGroupData[{

Cell["Step function", "Subsection",
 CellChangeTimes->{{3.475745521641923*^9, 3.475745559200262*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"UnitStep", "[", "x", "]"}], "//", "N"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475740080815694*^9, 3.475740088659282*^9}, {
   3.475744758162083*^9, 3.475744758656256*^9}, 3.475745518394735*^9}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], Thickness[Large], LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAmIQXfvc99P//8oHGKDgWbXY19t/EHw/gfvft/9E8BUs
C/7mf0bwD3VN4njwDMHn0Lsud+Asgj+lJMG7YTaCv5qxeAmDOYLPmupuJBmr
BOcL3zias2iiIpwfdHhWsuYpBTi/+r1tzoTH8nD+jvJZWev95RDunRSq8G+m
DJzvPnevn8cbKTh/2fHKa8XRknB+XMsU0fMrxOH8ugTmddzCYnA+g678fudW
ETj/VvfM9tVXheB8Ga6MlV+cBOH8bFMt1tsy/HB+svm9FYcPc8P5WhVW//OW
cMD5C+8GH6l0ZIXznzeK2rhLMMH5u6ZquL4I+7sfxjd4efOL/txvcL7Lrtuc
f8M+wPkFK9f/EBR+jFDPl9fs9OARnP+xSIeveC2CX2SzUvmKO4Jfen6R37Sa
h3D+51fanqZn7sP5bM0/FrgV3YTz231Kty3nQfA5xD6d5lh+A87nWvn626nb
1+F8/vP3fPxdr8H5EtJHf4RLXIbzw9KUF16qOQnndxUWd0zaegLO31tzOD/o
3XE4X2Vyst2l+GNw/qf9i29fdDoM58sZe+gsEtwF57d6vvil2LwDzn8T33Fy
4ZdtcP6unhNpC69vhvPXnpno5Gi9Gs6v/nnxvoPcCjjfU02o1oFxKZx/+r9K
fn3fXDg/I3LpyrqQ6XA+y2bVJ7VSE+F8B0kf218HWuH8jmO/LkTIV8H5AD7C
9l8=
      "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAWIQ3XHs14UI+Sp7BjD4YK83K/m4iFk9nH9PcuM7bv4e
OD/Y+MaeNscpcD7vgdfKR6IWwPmFadkvj0xZBufPiTS1Sm7ZCOczMGz9n7xv
O5yfohZ11EjyEJx//MzNLuPgE3B+zoLyqbJrbsL5VroHNwVMfwznM5WJ3kmR
/ADns/MENCa9+wbnNz+45ly0+C+cv2F2W0DdJ0YHGD9/UYrAkzBWOD8ua5Zs
eyMHnN8ZWGZpPIcbzmcRmfqs/hcfnH/9dOuHFn5BOD+0Osls1mEhOD+H+7XS
uSgROF9+9bFpbK9E4fzqHc7B/LPF4fyCZTnbzPQl4XweJvMkvadScL5rbshU
rckycL7ETtl8VxU5OH9SUcdEg+vycH5Qm7/u3G0KcL5WdEvoklpFOP/aM85F
k0OV4PxzSU8dheSV4Xy1pZJSnf0Ifu1z30///yP4APoNphE=
      "]]}, {}}, {{}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-10, 10}, {0., 1.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.475739842194702*^9, 3.475740089307933*^9, {3.475743251567914*^9, 
   3.475743252451032*^9}, {3.475743834616334*^9, 3.475743835492747*^9}, 
   3.4757438946534758`*^9, 3.475743925275352*^9, 3.475743963709462*^9, 
   3.475744002814473*^9, 3.475744759390786*^9, 3.475744829090854*^9, 
   3.475848818505299*^9, 3.475906054800818*^9, 3.475933101563484*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bipolar step function", "Subsection",
 CellChangeTimes->{{3.475745542423392*^9, 3.475745545828592*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"bipolarStep", "[", "x_", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"2.", 
     RowBox[{"UnitStep", "[", "x", "]"}]}], "-", "1."}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"bipolarStep", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475740238159812*^9, 3.475740308804851*^9}, {
  3.475744765744229*^9, 3.475744769590065*^9}, {3.47574551073783*^9, 
  3.475745511673202*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], Thickness[Large], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBWIQXfvc99P//8oHGMDgw/4pJQneDbMR/NWMxUsYzBF8
1lR3I8lYJThf+MbRnEUTFeH8oMOzkjVPKcD51e9tcyY8lofzd5TPylrvLwfn
+00KVfg3UwbOd5+718/jjRScv+x45bXiaEk4P65liuj5FeJwfl0C8zpuYTE4
n0FXfr9zqwicf6t7Zvvqq0JwvgxXxsovToJwfrapFuttGX44P9n83orDh7nh
fK0Kq/95Szjg/IV3g49UOrLC+c8bRW3cJZjg/F1TNVxfhP3dD+MbvLz5RX/u
NzjfZddtzr9hH+D8gpXrfwgKP4bz2Zp/LHArugnnh6UpL7xUcxLOlzP20Fkk
uAvO7zj260KEfBWcDwDWkaRk
      "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAWIQ3XHs14UI+Sp7BjD4YK83K/m4iFk9nH9PcuM7bv4e
OD/Y+MaeNscpcD7vgdfKR6IWwPmFadkvj0xZBufPiTS1Sm7ZCOczMGz9n7xv
O5yfohZ11EjyEJx//MzNLuPgE3B+zoLyqbJrbsL5VroHNwVMfwznM5WJ3kmR
/ADns/MENCa9+wbnNz+45ly0+C+cv2F2W0DdJ0YHGD9/UYrAkzBWOD8ua5Zs
eyMHnN8ZWGZpPIcbzmcRmfqs/hcfnH/9dOuHFn5BOD+0Osls1mEhOD+H+7XS
uSgROF9+9bFpbK9E4fzqHc7B/LPF4fyCZTnbzPQl4XweJvMkvadScL5rbshU
rckycL7ETtl8VxU5OH9SUcdEg+vycH5Qm7/u3G0KcL5WdEvoklpFOP/aM85F
k0OV4PxzSU8dheSV4Xy1pZJSnf0Ifu1z30///yP4APoNphE=
      "]]}, {}}, {{}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-10, 10}, {-1., 1.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.475740310109782*^9, 3.47574325174633*^9, 3.475743834773749*^9, 
   3.47574389487682*^9, 3.475743925467111*^9, 3.475743963938675*^9, 
   3.475744003093882*^9, 3.475744770533098*^9, 3.475744829347895*^9, 
   3.47584881868918*^9, {3.475906054963509*^9, 3.475906055769109*^9}, 
   3.475933101719294*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztWl1IVFkcP851mnWLkvZxQWxJR3rYCZag2axEQSVntLaHqDVtkEC3bTW1
6GkfyofFSCiJPgiMMkuDxZJil2U32YRYg2S3p2hZMiIjyZnVihmbmd+erx3H
OOdem6DGuhfuuff+z//8P889v3MOxx9ord+5O9DaUBfILWsONNU31LXkljY2
U5KRQUhGPSHkQS5h76CvsuBXAyvkh+L9Kn8YM/z0q9+y6hx/LEZ0Yhj9x7/D
8qV5aDzej+GJqGCcGkbtqhoMTwHh+z1o3LYHPxxtR3N1E3pGw5l6yd2iCggN
oii3CIMhEAenZQHRIEZ+HkFw+gn6/Z+j5kYIcVr171AtPP4reBLjLXWis6To
S31/wbfhDLtJBy8N+Er34xOniJuDlwaIswDeUsHnSObL4nSSyWku+Mq+x6cL
8/BFSReXW1GyC0sXeVFYxluwdtycZ88iKnPOd49g/dqT7CYneGlgvbcF2R/l
w+M9SdUwmiuZJvi9e+h3AecxGMXJtPw4W3gkEsXkZJjdVDgrDUw+/AVrc9bh
2sMwFc5oLkyODWFL/pc4+/cLzh+6143V+VsxOMZbsHbch3hcna3g9US2RHJd
QGwcA1UrUTvEshRH6EYNPJWWWRJdK5N2rZs4d2A7PO5y/B6Ck5OdiDzow94d
e3H42CG0bG/GxdEIMelOqXXvt17Fa9LQrjSpssNjx+BDCY8Y/5ZAAZuCMQGt
MUwMtWFLRT3aOjtx8JsdaLv+FFGYDq9n+SObjs5aDJ3B2WgE97v2of3PKc4z
PXoCqz2tuPMCJhpOiSqB4NnJkPoxVcwxQjryB7a516BvLMY/Y2N9WFPwNZsz
LJAi4uMDKPysHNRG4VMyxAlPXFxP8bIi/BaUcoO/omhZMcciYeYCTD8aQEfv
bYw/f4pbHcXI91/Ao5dmXiSk03BXFxTi0uP/reylVlYzK6V0J6b/6UJd92X0
dLbj8OmfcO953AyTEqKtAZKqu4LAkbsIczcsOo0ZOtLGwUGU5+Qgz+2G270C
hU23QadnJjFIkz/ig/n17RjY4Um9Skz5F2rXZApAIT7ehg5F0INJpUJl1Rza
+VKwRwxGFChE06RFoLj0oEUqEiZpQUu4wj2pmgO3PwUrxFKVKOHPSIY/yamQ
rodFUiJSYSlbgs8s/FSlcbOCT+u1iV0Oi7SZILToJVqEVlm90byJ1gETK6wc
MJkECAfUk4AqrfVq/soU9L9q+sxKXHZW/STDJ9OfPMnYpDV5Nt/GFPRJU7Nk
H31lhe+QgVHNYfwy5Zo5jFkv0TTxvb4RcnBKk+HeEF/02smKjORuMLvB4jSi
LUkjW94VTczj7VTNA5pJqr5S0DbPkU9Fe/uq0mQgs+fudgzs8NgxeG82QGe2
DvUrJu0Op4XIN9zrVO6f2juc6V713vzbdnjsGNjheZOqeXnyRiU6cUzEcl/R
wLe7LnOx7CBMrzwiQ2kJNc45qLHc/Uuo4Rf3oydFXZaIah6leXiYhn8ojpeR
jP8AzLr/Cg==\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Linear", "Subsection",
 CellChangeTimes->{{3.47574568141941*^9, 3.475745682103787*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"x", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.475745696484527*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Thickness[Large], LineBox[CompressedData["
1:eJxF1OlPEnAcgHEkKRTLExVDOWyu2FCnS+fR0ozhVqJhUMtlhtKcUZg606GW
EzWtLRXRifLCI9KxsrWl5mpamJYWuZqY0WGReLXyQslJVFt8fy+eff6DhyYQ
c4VYDAaT8Ld/Fs8mrFit/oM2jRJPk34LyXH5vNH7C0mNyLaIV5FPq+vw00Yk
PnDSb/AVsj4v7cjVZqTaLrcDE47ECdkhpNN00P3dM1FbLQ3kahTp+0apoOTn
AVGNgQL2XVZkdSf6gZw6HvV3ExlkKx9z4r/7gKqRQl1uCglMldYTX3d6gSVp
2+4S3D1BDJMyEFfuAb6/3lSpnnADyY6ZXWuHXMHz+xk4PdkZTA//1KnREEBG
QaT1YgcebP2YPFQYiwNnS4nRbG8s2C/fy5rjWwZsBs9PrQUp18HD/XoHC38J
zO7qNru6G0D+Of/WN0UvwJGXU9Whyc8P2oxkPrmf1GgAsfnEDxmkJXCHU1Kp
4Mc6WDati8tpt4D3miuSSlbsYmyK2zJcvvFxYGqWwreyFA9WHcuPCG0hgPYe
cuOVzV3g5Fj5ktTZFeRJBGEKjRsoIizStac8QIp6uGH7AhGU9MUlOzd7gdkq
UU9YEAl0woYLAmd8QNaF43KGjAx6P/QVs/b4gXU512qDJykgtyKRqeyhgowU
Ka+jmAbqjA5tMh4d1ApmYt0o/uAX+9tmOR25psrsJgUgSYuLZBoTmZG7shEU
hdwss95JOIEMuEXyqbqJjGDrx51kyKPzLZU1DchLTKqpUYl89CBgXKVGcodD
K4ZGkMJMU3T8GLLAsXd1TItUciLPvp1Azulior8akJsF2FXhLHLn7qGu+QVk
yBm21/IykmXnoM0zIU+2j0rNZmQW60ZU0Rby/7fAPwoONb0=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-10, 10}, {-9.999999591836735, 9.999999591836735}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.4757457232368*^9, 3.475848818820627*^9, 
  3.47590605502301*^9, 3.475933101753656*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sigmoid (logistic function)", "Subsection",
 CellChangeTimes->{{3.475745583362891*^9, 3.475745584859834*^9}, {
  3.475746703607717*^9, 3.475746708339707*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sigmoid", "[", 
    RowBox[{"x_", ",", "\[Alpha]_"}], "]"}], ":=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[Alpha]"}], " ", "x"}]]}]], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sigmoid", "[", "x_", "]"}], " ", ":=", 
   RowBox[{"sigmoid", "[", 
    RowBox[{"x", ",", "1."}], "]"}]}], ";"}], "\n", 
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"sigmoid", "[", 
      RowBox[{"x", ",", "\[Alpha]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "1"}], "}"}], ",", "0", ",", "5", ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}]}], 
  "]"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4753855340122075`*^9, 3.475385547824354*^9}, {
   3.4753856451521034`*^9, 3.475385652714797*^9}, {3.4753857529361124`*^9, 
   3.4753857537798843`*^9}, {3.475739666796036*^9, 3.475739717200918*^9}, {
   3.475739860137268*^9, 3.475739949750598*^9}, {3.475740162375077*^9, 
   3.47574017349004*^9}, 3.475740215221316*^9, {3.475744737675943*^9, 
   3.475744750130767*^9}, {3.475745889863115*^9, 3.47574589630103*^9}, {
   3.475746129921138*^9, 3.475746225854386*^9}, 3.475746257298927*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`\[Alpha]$$ = 1, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`\[Alpha]$$], 1}, 0, 5}}, Typeset`size$$ = {
    360., {116., 120.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`\[Alpha]$716$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`\[Alpha]$$ = 1}, 
      "ControllerVariables" :> {
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$716$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Plot[
        $CellContext`sigmoid[$CellContext`x, $CellContext`\[Alpha]$$], \
{$CellContext`x, -10, 10}, PlotStyle -> Thick], 
      "Specifications" :> {{{$CellContext`\[Alpha]$$, 1}, 0, 5, Appearance -> 
         "Labeled"}}, "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{405., {160., 165.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{{3.475739891216146*^9, 3.475739957114039*^9}, {
   3.475740163774525*^9, 3.475740174200133*^9}, 3.475740216170953*^9, 
   3.475743252224813*^9, 3.475743835292911*^9, 3.475743895003396*^9, 
   3.475743925612651*^9, 3.475743964061699*^9, 3.475744003227681*^9, 
   3.475744751159943*^9, 3.47574482952221*^9, 3.47574589744705*^9, {
   3.475746172376226*^9, 3.475746227382807*^9}, 3.475746258432207*^9, {
   3.475848819032358*^9, 3.475848819871223*^9}, 3.475906055178687*^9, 
   3.475933101948058*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hyperbolic tangent (bipolar sigmoid)", "Subsection",
 CellChangeTimes->{{3.475745743699801*^9, 3.475745749140512*^9}, {
  3.475746413387665*^9, 3.475746418426011*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Note", ":", " ", 
   RowBox[{"2", " ", 
    RowBox[{"sigmoid", "[", "x", "]"}]}]}], " ", "=", " ", 
  RowBox[{"1", "+", 
   RowBox[{"tanh", 
    RowBox[{
     RowBox[{"(", 
      FractionBox["x", "2"], ")"}], "."}]}]}]}]], "Text",
 CellChangeTimes->{{3.475746352954364*^9, 3.475746387228005*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Tanh", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475745856958159*^9, 3.47574588325722*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Thickness[Large], LineBox[CompressedData["
1:eJwt23c8ld8fAHB7Z+95UVlRJCp0ThQpSjJKqKwKqSgZpUkqURkZhSTJKFRC
5TnJJmRFdva6197jd57v6/fXfb1f995nfM7nfD7neb3OI+tw0dyZgY6OToKR
jo78vDFoOrW+Lo9ELlasrq/TiIgrpw/dipNHN9nzV0in03sl02nLo7WMTcuk
j2+3G+WqlEPZCc8WSDM7G2mI2ckhpqlXM6TL6Qdv6SjLoU3GclOkQ+KDau3m
ZVE+szCNNNW9eY7aIYucfhwdJ22ms1n6VrEsqgD2o6Rz2L3386XLoqKnWsOk
BVpK3JOeyiKdfU0DpP2uJh766COLxrbo95H+x++vXHxKFjWmuvWQPphlyd5k
KIuU6w92/nc8021D/aqyKIi75S9p8VGOsjlBWWS/wvGH9J3g/jesKxSUaf+3
nrTWH3OhJzQKmoiKqSM9sgndE+2loOssujWkzX/GOipVUpB8wcYK0jEsP81e
f6Og3hHlUtLdxqN6Uh8oSKGc9SfpC3U6onwRFOR7Wfcb6U8CTsyPgigo3iEs
j/SSVcgUky8F0Rt9+EQ6uKO9esGOgvZ+OJhBesv6pZ87rCkoWHpDGulaCnOB
pxkFFW9Hb0kLO6m+HdPH36fOJZF+PXLjdrcCBR26Fx1N2pCL30dKloI61xoi
/7sf1RQPG3EK+nBn5RnpbZdrTjZyUVBdLP9j0v40PfcnvTLIds7gFulvDduc
JptlUGW7wA3Sa1/kbc0rZZC8c63vf/G7xW4imC2Dfh1h9SL9kK9JJTpABund
cnMiXT1bJr94WQblBjw4TZr7b4GEjbMMuvI+1Jb0s6RETkkTGVQlb2JBOna7
+2iCmAzawXdbn/TXN85nzQRk0CEvBUi6XeRUL90GGWRzqlSPtPTK0bYzdDLI
wnt8J+mkYu0q+UFpVDHboUb6nSVj+ttP0ohhUF2MdGXZyubj76VRsZyl8H/x
2DWXxJYqjaQOXBT4L97Sw7Hn46RRfdv9DaSzBmoeqtyRRu+GDOlJ512Ldf1w
RBrZufQMrGHLOV1+03JAGn1OF+sl/djsQDe9vjT6Or6vi7SD0pylhaY0Yv3k
9Yc0Z9vRvYui0mhcV7WMtP0edlGDf1KI8Wf/a9Llyt3m7m1SaLOXdgJpDZEv
jyMbpdB2Ft9Y0qwTToxDpVLo8lzlE9JZrxA1JF0KfS98fZ00I7NPSfMVKcRg
PmNG2mPyMB2dhxSi+SseIt3SsUlH6awU6s0+sJ90Rm5Dlv8JKaSpZrKLtNW5
rS8oe6SQc5o1hXRq1YCnK6sUUnkERlax+fO+Z4bTSaHnm/l7Sd9Ijhj6tiiJ
Zrmq20ib39C35xmTRCrOM9Wkl9XijT/VSSKRzA3vSR9+ZklZi5FER2l8bqT9
NHiMjcIl0a47xx1Ip9SXX34SIokGYm6fIL3Gr/tT7qYk+lHma0Q6M1zOxchJ
Eqn3zcmS5oqkpT9Rk0TMpSV1K9g7d7xrbFWQRA6TDKWknZocVuVkJVEEIfGV
9Deh5sOfBSSRtXVnMmm3qG+TrQsSSOdFjDfpyucPtOV/SqAv4lf4Sc9pG5x2
/yaBZDepMZOWa1kJ/vxZAklbfp1fJq9f9NJfo1QJdL/EpJ20UozVDffHEuht
4+7XpINj5X9+tpZAApRPCqQ/7e4YXTOTQC79FiKku/9GCR44KIEyrAtZSO+U
4HD5qyuBKiyG+pawh+Im2NZlJdCRV3fjSRu9/H74wJg4iriymYX0xOP2FaYB
ceRubT69SM6fgOW0H13i6M6gfjfpsVO7WHUaxJGX7MV80s/kPhOqBdgLnedI
d77N2CYQLI5kKO5fF8jrja7qrL0tjixXApNJqz8YCQnxF0eZOdaPSd9zVRxm
viiOPknJ2JNWVk1+tWApjnjtN67MY3vnxPF3youjWScNJdKU1wUoVkocbZw7
voF0RXirh7WIOHpRrjA5hy15VaSqjkMcbWnP/0K6SDv87s9JMWSU+gSS5v7+
cCaVEEPhLkxwlpx/me+SnPPF0PPPm6RJn4kvN5P7KIa6TNuXZ8j43mTJjEsR
Q5pCTLmkbfTvOIc+FkPb1EU3kU4p8232OimGmPqExqfI+q3hbfDOQgzt1ndG
pENeemZ1moohvw6JcNKeXm4PjaEY8ozL1SKtJ2O3R2aTGGo9edZ7ErvRG6ZU
UkVR+0RpEw27rEdXgG5IFF1yC4wnXWCy69aOHlG0kfm+C+lEOQ2bxAZRVOFt
PEMl869Gnts7TxR1h91hIc2wmdVb9o4oyos4wziGPfuEsdfKXxQJpPEQo2Q+
LK8fCbkiinK0Gn1J1/xeUJp3EUWMGhFjI+T93BjpqD4kiibyI0uHyfre9Gu/
j5AoGj6eZjyILQ8rczK5RRHFSn12gOwf6aUyvayiiC3ieQLplVvEoumSCCo5
PjXRT97PluxM+S4RRFd5ObCPrFf3IoRqU0UQ54eJyz3k+cEcq0+SCEoK9+Ml
DZatlygvRND2mF+Z3eT4e0p0eYaJoMTrRF8X2a9PJaUKe4ugRilHg05sF50s
HXsDERTSxoD+YjfP8amx6omgvHZ1Y9JGOV6ULC0RFNjTX9eKraikzcygLILS
GCvbWsj6LVxY84ZXBBV/XOpsJuvdVNWZ8Q5hdG71QVQ9md+ZqhZRf4TR0X1Z
zKSPnA8zBL+FEX0gm9dvMj7d5ipPi4XR27/aB+qwp361zmimC6MfwmNtv8h8
fjd4/7qPMNpkofe6HHvAydhvk6cwco1OmSrDtqaku9e4CSPxuHZAeudzj6OU
U8Jo28dnDSVkf783K168XxgdlLLrKsIOOM34nlNAGGlTq29/I+t3rVFoI5cw
Cvpe9v4rGZ89IR4vWYRRaJVaawHZv6WEtm5dEkLzR2Q35//XPzdnmfcIoVcS
WQmfseOPHcyJ+SCEHCs62d9j1xWFPnN4J4SuHXrJnknmk0aDp8prIdSbsJsl
g4w3r+3271FCSCJgZPYdttqvC5+6bwihhADm92+wCcOnuQomQoj31NS1F2Q8
PjdFTewXQnsMi2Ac9sZN4tfygRC6alDCHEvWC8bX2oe2C6FTjZr3nmOboU95
HuJCyM7Z6egzsr7tain4PCSIaMlNsvfJ/vFOMi7gnyByj5l4G4i9T/SMv1G7
IGoQ9VC6R/abuWGd1lpBtKvJSvo29qWPy99WcgVRJR+s8cOmU5UhDAIFUQxo
33kB+7rwXvvAAEGk/Crb0A17ft1htfSaIDphPGZ6Hptan6Jz0FUQxflpH3DG
bvNRyzM7IogudccP22LnFutl24kJIr1/VysPkv32/SmzBH5B9Nr2kuMBst88
v03r5hRE0aEGM/uxk11LVJ3WBNAubuZVSNZTXtM0114BdO1081st7Au2tq+v
ZQqg4p/+ByjkfN0foJ+fIoCSJzWOSpH9aGtiz1KCAOo3bj0iTtYnhj6ZgGcC
qNnJVU0Q+0Cq24t71wSQHWOJOysZ7xm/yKd7BdDJlvVfo2u4fnS80GzYLYB4
eOM3DmFLlBU2CGoKIG6JWo8+bP5YBv7ozQJIwxN2tGOvg4eh8ZwCSL43QeoX
9t9HMffTm/jRm4enmNKxG0ooGadr+dHwYY5fKdjV62/rhCr4kfc/2+Ak7EKv
XLFb3/hRI4tZcwx20smGdIvX/OhY7PvK+9iuKhvqVi/xowsDt8dPYzs6R8zk
uPKjzp+ZVSexbRMkxM454eM5xsVYYR8WUHaot+ZH+9+PM5pgaywbzqTs4Ueq
TSlcWtjLlbdEzbj40WDSyncW7BkmNj1mFn6keLUggA6buifsTME6HxLryVFZ
WsX5lfMybeM0H2IKOm48jl0cW6C72MqH4rZ7hNRjh7jOnE56y4e6B+vmorED
k/0DrV/xoYROOdun2AGdDGlccdi7nd49wL5kzjftHcqHhFLvLvliW+xWCzx0
lQ/NZb3xOIEtyXHu3Yw+H6qzzrcSwLYvrA6R0+VDnFv6TNixX3mqXzLbwYes
rsdR1ldoxOa2Ja0MBT7ksrPJfgR7a8bjYkcuPuTWKadEYOsf/thV38SLzj8R
DjyDfY9B9CddLS9KkmcSs8Quy72eolbOi240m905gG0iY3jhYQEv4ir9Vq+G
bTXRsrQ3gRdp9TraLC7TiPPP1oSyz/EimGbiF4idYei42HmGF738qCjhjU1d
KmvnOsmLXNQM77tgezo+fX3OlBddfHCx0BD7uuZGdYoGLyqaEo1gwpbODI+W
nudBzCrG6leX8POFkN0pv2EeVN06ouKArRiweXNzGw+Kjj7Yfxhb/Uj+x8eI
BznaFj1RwN432Vmz8oAHna88md20iPvdDmXmNkkeFHFPfP9GbE/m/LfePDwo
+U+18gZsvyajg/wMPEhq8VPR7AJ+nrjqHGY8yI2uunIxl2KnfU4Uy8vmRiDC
LtcBe3iHiFqkITeKLK9peDSP10PMKXXbdnGjB5wnbS5iLzRpelWrcCPxHM7b
5ths3uZ5jHzcyOxu9TsRbMXcx/qebRvQ09Hr+17O0YizWkzWRy5tQB9FfS9E
zOJ+whK+OOKwAd1meWR5Gdu7WfZFkOUGtPnUrTJT7CBv0PN99wb0RLZdnxk7
JdfPbQvzBuTyIdHVY4ZG9GtN3mSP5UJpqQksitN4PcZyS+5NCBfaZT1VujKF
87uZuwTe5EJ1kj9m67CZrm3h8HHiQrdNlZ5fw9745WzEgBoXytgpnPN9Es8v
7c7Unz85kVVwpa/KBK7nqdpWhl84UWODdtUiDc9HsaeMFWmcyNGk+1YZ9qVl
A/uap5xIQwPwncG+TrwTaD3FiaJuuoWFUPHzvtHVAOoyBwpWzdP6OUYjnufV
qFymcSBjzc7WIOxYJcXW6X8cyJbyhzDGTuRs275YwYFG8lcO/hrF9bEWDjNG
cyBX3pcSVSM0otSay0JMkwM5TkX4Jgzh9V65M/0LBQ50SsF8oxV29S7ivbQE
B6L3tRnmxK6X8GTfyMCBDDdyf7kySCO6uv4UqtWxo3vup3l1BvD4nX2ttM+d
HV2MThKJ7sX1oWWlufQU/v7ZGgPAXjO2umd8jB3xpwb86fuH47eFvevwbnbU
5WKsporNN+ERcYIN/77kgHpWN16v+uxe90hmQ7kTiTbXO2gE6jis3BvFhnoM
v02yYFsZOFpaP2BDVi6Hl8La8fMtd0g68GBDK+P5B1+20YjW5A5r3p34/2zL
ZsmtuP/9vpWVXcWKAn2DFuyb8HzRjmzbVMiKDpreYa1pxOvRF+9YYrNYUc9D
OhUd7O6z9bZ3IlmR/JHgSJ4GGqG9Js9+7BQryvMS3ZNYh9cXymVnZqZYkCGr
yHebKjxeT9pCzvWzoLm5xda3lbi+z9G+tP9hQY56LDFTFTRizw9R7pJvLEgd
pHbcKqcRkdauBZFBLMjuUFTczRI8/+5tENAWZ0EnSzoc1gpx/R+W3ZPOxYJe
fq5Kk8W+dETrvMw6M0o2PcWm/51GxImfIlj7mNG7BZ0O36+4/2dlubVkMiOB
dNbG4i+4vnUcK/bdy4wcjp/LK/yA63efxlKjJjMq88r/it7j+jvCt22bIjOS
v3wwgcjE9zNfGzfAzYycsiS7P6bj+PObeB1rZ0IF9ve2XX1LI3IM98mpXmNC
sd27B47G0wgDU/njwa5MqM2nQkzqJV5fH2MI7bVjQo9fyd7ti8PPY6fRYsw+
JjQRwlB+NoZG6Pjr/mbhZ0IsXN7leyLw+T9o3urOYERygVdi5B/QCMtcgVyd
REZ0o27dMuM+vp5vU6NR4YzI4Pcbv21BuB5UZlmb+jGibUYuP5Xv0gjTvi1b
C4wYUUORzdf+63g9KrqpM/wfA/o++nPh7EVcH2SYBGlNDMj2/l6NxAs4Pzf1
Gh+sYEDy37e317vRCPHtrz7TZTEgNxcRPYVzuD+YSj2+cIMB6aupGT88TSMG
bwvpGokyIPscxadKZjSC48YHWjgHA2J0cvj72xSvx3yMX3ev0CPfH3R6nodw
vfG4weHXQ4/on872xxrSCJaT/S0ZafTo1nW/1mBdXB80P1/l16NHFrdfFRdu
xuuHrUeUTm2lRxlJS7lt8jTCXXm4PV2WHjltHV2kUnA+UqT27WehR9sraFPz
4jjeGwL5fWrpkMMRYtMTbhrhMGDxoeMMHVLWaOr/Ok0lgnqoDsoWdOjR5wwd
tQkqkdYeLHzNkA6BvW/yI8aoxFT9txu8KnToMYNBpF4/lWC4aRwdNLROHGk2
DVxqohJAffj30Q3rxNyupejVT/h4ClK7RifXiG7wMDYhi0rUSB1NvNe8RsSH
LKpsz6AS9hz5Hl8S1ojWxDtGaq+pxPXeYE4pjTXiXNiawcUnVKIgUnH/kNUq
kbD3U9bkWSrBdnLQkV53ldgXf8/kgwOVsKKk3BGXXSU+KBxksLXD15cmj0xG
V4hrNTzU2+ZUQglJ62TfXCFWK5XYl3SoRPSIoLpf6jLRHqYY68ZJJQY+NBwJ
f7xM5GzTf0nPTCU0rz7zyPBcJuxbfffdXRsnatd5Mjp1l4nFrRtDD0yOEyxC
nAoGv5eIl1osVo1N48RVQC/FtbRIzH0XY82PHSeKmJDOpq5Fgq2npGH02TjB
Wxlgs6d4kVBy/qHD8micyLBYeX4pdJFYFgoonfAbJ/rOz/M3yS0SMQljDJEn
xgnziHG2+EMLxICbzHwr3ziReCJD4cu2BWIPc+RNJ7ZxgirtZlgntEDkmCvQ
1a+NEQ/fDd1l6J4n1svi0i1Gx4gfhb1rLlfmCTlPiRZa0Rixbbh1ZuvLOeLH
0sKSpvsYcWVCVUnk3hxRXUr3+/GZMSJv/rbdmuscUTdT01puNUbsZVEurd45
R2ReaHLsg2OEubzf8/ONs4TE7nDHdwJjxFU78d2vOWcJltAwSeWPo0SBk4fH
w6kZQrPb9dndlFFiza0o6XLrDHFbbTq0IGaUCPJz5YRvZwhm6299xM1RIvp5
QXu7/gyhHqp8UeYg/v9vm5vCftPEqpqd39ifEWKt5f3H1dPTRO7SxKHF8hFC
v5thqM9omlA/vC21M3+EqKKmmX0UmibEC2wK1ONGiHbOZVmz7Cmi+9rvoxMn
R4j1/XHFD4YmicO/jNzuNw0T+wra2FetJggBixTJrpQh4n3am11lOhPENSaz
S0lPhgjRuIvnn1ImiKpVx3MqfkNE8zzLs0O4bgvwxRaEmAwRm/yteF8uUYnN
O66AO9RBouj2LBc0GifSu7N3DWweJKIcHrg38o4Tf1vqN/7hGiTOG0hVn/s7
RtwK8Bm+PzVA8DLvf/T0whgRAYVyFL4PEKeCI9h7w0cJdWaty9ZHBoiV0O0s
Qd3DhPAnRS2ts/1E3cUyZ/G0YYI+bb6UzrifeG12suS91zDBm2mYE6TcTxzk
v3vvD8swcVhtPu/nWB8RE1nPoKQ6RMSdd+tfudBHaL24vF7lO0D4v/562dCx
l7j07sMCn0AvwfuWxzZGtIfYxu1xV7/7HxH33atCZaabmPTcwu2V+Y/4ubQn
/1ZtN+Gp+06+0egf4ZU99sIzsJu4Wpt0OOp6D8GDxNdm2ruI6REV4x3VXcSB
e1OWD1w7CJa7C4mGnq1ElP+JkbNbWwgrF/lX9dcrCP0SuEpVqCDKqlsfbj9W
DrJTYLkpezk45/O37KRKBag7mtwb3loO2Da2Md1jrARV9PFxR99VgIP+7QGN
H6vAopxxuLxRFahW6vK8KlgLyk36ZXP8a8A5A8/MtpF6kJuzxh7hUA/cE69F
SmW0AobyG+6jp1uA7tz8R3XRv4B3ydxO6HsL4DLxqd9/7y8w6PU7WCbaCjLn
fXg8bNvA8WzPzMKaVkA97PegkKsDFP/tvtSp2QbyAgoLP2h1g7O7t1MFhjvA
btUfOWbPe8HWAwIbD3j3gB2NzVGFFb3g2GeJI+ExPWCb/5jflpVeUB/249ar
bz1gc4WIAduZPpBhN1HIwvAPCDh7NBDK/UCT8cyb6Qf/wNgLiRm1wgFwP0py
1Sq0FwwaqLe8mBgAmldsp+sye8G/EcNvHPKDYC5FVY77Vy9o3el5b+D+IGCu
db5bz9EHShvLBeOPDgHm8hjtoLt9IIHLe8eG/mGw39U1Kvd8P4j9+EjMX2QE
9Dt9uuMZ2A+ibF6tDhmPgMGqw73Tif0gJLW6pPj9CHi29KrC6E8/8Nknb3Xd
ZxRkFzRN7to7AMyv13mPco4Dj/OMEn4cg4DBW6jdSWwC9P58YbfjyhCwOZ1W
n6c5AXILijMbHw6BnIOggstsAmhyVLLsejUEHGTO534KmgCmdD0u5r+GQFH5
tydMMxOgey6TpUFuGNyVcNqfXDMJagVeXnX5OQzamRd1FoYnQdnrjMig5mGg
OfFYw4R5CgyHlOt5Dg+DvuIvMjM6U6DgTXFNJvcI2OfBuWTwbgqcTeYO/2E1
Aph+5LzvvTsN6Fz/BuV1jADbdKM32gnToMS8qL9ofAR8imyPe1QwDRwOObsm
rI4AJ1eWB9snpwFHa3JQneQoKBGwcbxrPwP09q66SJ8YBUEu9KLyu2ZBYsrT
u0UVo6DTLIr7msUsUM5ovCPzZxRo6agwV12cBT5C3cyWfaNggMdyyjNlFlRd
apU5tDYKDPNTq4sE5oAFNUvfY9sYYOUyu+1AnQOh+3hu9D4eA8cVbJAW+zwY
vMepXhQ9BtL0ndY5Ns4DIyuGO7dej4HDvj43Pp6YB7Ul10xe5o2BqIFEX6aS
ebDq8yH+dM8Y2Pxj8nJK3AKg3jimZKk6Dnzal7P8chdAF50Yh4XWOKicZ544
/HsBlH3PeKgN8DiqiXvMsywC7VrF55lm4yA3Tt/1gOciSBuQpNl5joP93uEO
IweWwJShphp39jiIevryVaHjElCVEpnyyRsHQxlvu58FLIHTSa+JamIchPR+
tdf5tARiveCNbTXjoNGszyZEZhkcddIMpg2PAyeVHcfU5pbBp/JAyh0pKsg1
BM8Y+FbA54NL1Fh5KmBzMP7drLIC6O1QTKISFWRE2x25eWYFjL9gdPbaQQUz
zEGH6qpXwBn7kRZdEyq4291s4Pl6FTzVKkh+7E0FnfmHLvh8WwWjly82aftT
we5wFBXQtAqmb73UbLxJBRP704Yfsq6B30eCxfqCqcA+/UbYa7c1kN10N8Up
Fv/ee2Nb4/Z14PFJu4vtKxVEHYlhajNZB3pV0WcGC6lgUpFbrcd5HTAG3LYo
KKKC1Lb5W+PP10GWjjDvnkoqEN5btZllZR3sPVl6DrVQwSLzrnwJBzqoNj3d
UzVNBSme07/iPeigeyiTLt08FVh0Zf6T9aeDd5PeTCovUUFWnhyXYgQd/BHo
3+VIRwMublynNEvp4IebesUuXDTQWNfFZKpMD3/y0OeXydHAHb1YsTotevji
XISZxyYa2JZmoXbMgB4qRDv841KkgUd3K6xP2NLDaMcBcw1VGtDX+pjmHEoP
67a2jVG0aSArLsgsYIoeUlsvnE40poEqgaBBHjoGOGDKto3OhAYGHgUGvNrA
AC9Vb9py/DANSF6/l1GsyACH825yT5rTQLDtHTbOUwzwWjqjSsVJGjgtFYCe
VzHAz9MLBxXcacA/8oa1Uiv+//IXPiEPGojacINaMMAA7yYuX125SAPVq/6S
nfSMMGxD0/k8LxrY2enrs3EnI/z+W1Zz0I8GeBOubstOZoQNT89qqAfTgIrI
1TL9HEY448PBWPSABgzDrtg3EoyQju5MoukjGrh+0ytk/i/2bY5Ay1AaGDp1
eUiPjwnW1VWUKEXQAKJcSKy8wQSlo7rnJ+NpoC3aXdv2EROsYIqT1E6kgTle
95rxaCao7unE4vOKBrbQu63wfmKCijVpp8df00B0z7nj1iNMUFOHNf1tKg1c
THLi7bNihiqWrr3O2TQQ6hvzItSRGRrvDxO0zaGB92Y1irsuMUOnG7sMj3yk
Aeqa9t7QB8xQ8Sl73ZbPNOB+ktNz5zdmGOG55FuSRwOugjkNIbIs0HPAL+cK
QQMPRwdOaauxwP6dBCtANJBWJDHWs5sFvlze2s/ygwaGLwUyaVuwQM27wtZh
RTRw7tfxHT1BLDBH13XwbgnOn6D1qB1jLPDBxT8z9FU0EGSnKd+9wALPmbqr
p2KnaJ7/8JCZFe6T3uJiUk0D/f/qy7qkWaEAtPod+osGnEDKwoOjrHCy+oDN
Si0NOCyY2HTmskLri79P3GzE+Vd7eyD4Jys85XS1n7WJBpJScj2317HCzqqE
klDsHgvKo+BhfHzt/dHPm3F+ZE9/1ZBkg5kOwYJRLTRg7xordf82G7ROf5Z8
sJ0GllvZayYfs8FDdSsRedjRxr4BtrFs8Py75O2bOmjgt+LxLvWPbDBfv/TR
Eva+QaFX7X1sUJLxhFBUFw0oOT3dqHGAHSKJb3/C/9FAaQNd0wsLdtiWhasD
toPBpUDWM+wwVeDHmlEvDbyQOzLQ7ssOXRJiWuaxuXu4Uu+ns0Pz3jmuQ/00
MGMXrNLBzQG1X/3dWjRIA09+zbcZSXDAezOPu7iGaEBV72xIjgIHdJ30f2eF
7SJpOH4fckDZfobng9itfxk/aHhywKmecvn1YRootL6pEdzEAb/vsdNnHaOB
k2XUf1M9HDDw5OWafdgLWvbhdlQO6HZS4OVtbHVhvRkNVk7Izc7HuYid3Lj0
uWMnJ5Ts/Xe2a5wGHhz13rX9BScMzfiw9ohGA8+qld0z3nHCa0nH1ouwXxh1
xW/6wgkHzxseWMTO0jvAJFrPCfNevPrmOEEDLUritSusXPDOX+1L2yZpQJGh
0KnUiwsa2gVMpU3RgMYNz+fgNhcMTXMJ+oOtu7C5Mi+UCx4yPR3IOE0DZtSw
renvuODnA/uqT2Bf+3tmKayLC7pYhuesY5fmMD85cWgDfHDojJfGLA3UqRYU
1R/fAM8d+Bhuhf031WP2kMsGmPzeWMcPmxr/x2bP7Q2QzebhZoQt/OjdJvkv
G2AGVSHacI4GnB1Nv47JcUPf7glVME8DHp30VOdt3JAo9bhii+1zIpfSpccN
TbbwnvDFDjkiE/T7ODfUsm+kz8H+pDNplhvKDVkjRWakF2iASTBy4OYSN2xn
WHYcwuanBnDzs/LAHq03wWvYsuXntJIFeGCyseY5wUUa2HNdN6h8Cw88fMb2
JMD27evdxHeKB5rkFyk+w6Z+0nBO+skDRyS28mxZooHVUMnHmnU8sCI1Ze8e
bK7zLJ9L23nggydHdcywlaT+Mo3O8kCPGcb7Xtg5RbBeTJAXdjp9fvYFe0x5
6LKDIS90LnXi1FrG+SjSEZhuwguDt0au78NeZqqPmTHnhWIcIiXHsDm6vv4I
OsULz/w7VnoJWyE8jC/dhxdGZqlnp2I7LGtlT6fxwgtrU/G8KzRwfkilRDeb
F2pJlwxJYl9qorQGfuGFX1p2cSlh3/zAQS9azAv/PBzqgdgvHDvNdDt4YaCm
aJMH9p+qwIl7PHwwzkpGtxg7Ys/L/ZbCfPBOCb1qLbZ59qfYTVJ88MmP7oVW
7Jqo3n2lynww5+x9eRp26Zm9MayGfFDi4I/fIqs0kDu/svfhdT6ooyo074B9
xVXwuc1dPhg/MVvjhq3RoTKm/JAP1juOBl/Bfl9kE1X1nA/+qHibHIid8jhv
hOsjHwyu3hiUgh0lfyU8bJgPqj1a1u/Ftoh6NHRqgg++tq04N4LNz/5ab9s8
H+wXOuc9iR1K/T1Yx8QPVxztD65jB+Vv1eWn8MO1zx0dYms04H1ktC/Cih+y
VBnOHsTWLGLY7WzHD1s6tb+ZYU9pioftcOKHgYUvLlphe4gb72q+zA/rAyte
nMF26U95LPKYHxq7fxK5hm3p76AV+5MffpAzKInHjnopyDJfgX9vR5N9jd1M
lDYdq+OH3Pm/L73FtmJSubqhgx/efD7Q/wH7+OPpj7fm+OGPd9PqCNsm4Z76
WSUBWFLLeLUTO/aHFn3xVgEoJWnP9g+7rXeojqIlADWbXJ/0Y9sqml76qy8A
WZiUb45h22ULfTC1FYB1W7jaFrFP/0zZohkmAH0/u7zjX6eBxP7jK08iBWBj
eP5zIeweVs7q8TgBOBpQfl0U28HkotvbVAGYtC9MRRrbsUk7TbxIAG7m7ZRW
wnYZLFegnxWAgzYmV/SwU9j95+2WBeDZf9ZtAHtQRbWsgF4Q3uSv2q2Pfe7S
U5cr3IJwSfFAryH2+cUTbwYVBOHjSeWOI9junKNyNTaCUDleMPg09qhvARPn
GUFoE3Te2wHbdejBgNFZQfhdpsjeCftsiWLaDy9BaOVQLnWOvN6bLuqfQwTh
2QQ564vYJ6Z7wItCQfjqwubS69gtZ7JlW4sFYcZ3mm0AtlXdLUbhKkEoJ1ZN
vYltkSlTFvZHELY3LjHexTY7a3f47oQgDLGumw3GNmxrsXWVE4K6eWWMEdgl
xql73ioKwa0Hg8wjsfflXaP0qQlB9x3aL6Ow90YK99npCEF7jaTNMdi6Ryzc
jloIwb9C0xzx2Bo/a313BglBs7B8+bfY2eoJJ6+GCMHv3lu1U7G3JXro5TwT
grF+R4zeYave2EC/JUEIDvN/sUvHVtQ+FCyTJwQztPc4fcCWSS+NYhkRgmdp
kd255P0k5OVXTghB2ZuWzV+wH4antYfOC8HLKm3ledgz/qFyIszC0ETAKbkA
u9LE6r0CRRi+aXymVYjtTe0vOWAlDP8mKtYVY2f8+zPEZScMYyP4n5eQ+dJc
wfnbURieYz99shTbhMg8euKyMFzwPNBehi335GrH+RBhGP9bD1Vi/1Jnnn1Y
JAxvBzWI1GEzbJ4XOVIhDMXLG/NI7xQf3i1QJwz7JvKsf2MnMfy6FdchDGeM
DcPqsX0aIrgyFoThrm1aA43YG69u3PhLTQRO2intasW2OS9s9HSHCIw47/+V
dJgdm6ulrgg84i+i+xd7af/Yhw5jEWj7ct/ONuw64U86VCcRyLqZR6oD2z/P
4BhPnAikxnK+7CbHx7Zu4tQrETgX9WCd9Mi6bWjWWxGoeLv+dA95PiPviqOf
ROBjnUaZf9i7m1NBxC8RaHdtLawXe2F6wxYxOlEo482gO4Cd9Ty24jyLKDSY
bg8hfU5H4WwBlygUzstvJ91yByadFBOF2TeDfAexv/B5icZriELrrz/eDpHj
sbWFSd5ZFIZJG7aOYKs1OCV5uYlC85I3EqPYA96ToPiyKKyS32FH2rKQw985
QBSqa413kNY01Zt8+1wUiu5max7DnnZN6thSKQoNeVeTqNhp3Fv9b9SJwn15
vq2kHXK+itY0i8J+p0M8NOz6xcZjF3tF4RuFOR/SOcGsldkrotD/XNK+CexL
Ke65WlvFYBsDBzGJ3VkrEcmtJQaNDK7TSJsuVnoN6Irh9YmxzBS2somSetRB
MRhZvH6ddN9kf/qssxispPKpT2Nb65169emFGDxREX5jBrvUhftWyGsxOLsr
J5m05pPv9k5pYlDi86Eq0ry9EpKCeWIwpXFOeJbM5+CWKK8GMXghyy6V9J7G
oyEaHOKQb+nvpzkyn1fp3Dj4xKGNxeVG0hIKWcb/RMThefMX06QXfLlZn20S
h1FDn7fNk/crU3V7EorDvJ3SKaQ3ue27lnVNHN7XGQlYwI6ImLYMDhCHXrlu
0aQZCpM0TweKw6xbUdmkO3npp3jCxWFpzNg/0tG5390vvheHgxsL9i5iczFo
O6j1i0OND+UTpPOvMR4bGBWHVc/omZfIejteaxA/hc+3OCdKGrWc28RNJwGd
6sUhaa8PsUPj4hJQ7aX9I9J/bdc8Ms0k4EpDiPAy9v36ylPO1hLwmMXkZtKa
B56bSdlLwBQZGW3Sodu3aTx2k4BbLrZakd7L4TDrHiQBn1q2h5NO/VLiv+Wb
BPy2+J5phcwv1WfufUUSMAEt8JFmeG1v96JCAhaoCcuQtg2d38P1RwKmH67Z
SZrHWYlhbFIC7rc0cCXtzf84OF1BEt7UyyshLR98wtdRTRJmV90g9/uButVN
rhI7JCH/WZk20srDhYce6UvCnNcLNNKdxAS3m50k3DXFI7qKvf+CRaRyuCSc
mtMg9xuCK8++0l2MkYQ6gidcSSd/kXP/mCAJ99Y5e5JmYJjU182QhOiU5h3S
KOrxhGmJJPy3/30i6d2o9NDleUnI6GfZSvp8v+qXz6uSsOUhWzfpaI5IuSVG
KchTmDJAet7CcfEOrxQsD30zTfrT8HpKhJIULPn5kWuNnK8CuxjyTkrBdGsj
HdJ2OxMvrJyRgntOVkDSIXasrfCcFDyovduQ9Ojbpg8VV6Rgm+kwud8TpOp6
2rU9loL2yXecScu7pOetEVKw1u3XI9Lmj/g3GpRKQZBsQe4fBXeyfMPuV0tB
g6JfEaS7l4xceFul4Bb7qJek48P6BOSmpOCmosD3pEXzpS7u3ygN22boakiv
Ob6V4FORhny/2OtJ93Grl7erY7MyN5POctonewVIw2zrhg7SRrxuDUk20rDA
pHGMtPfZPG26p9Iw5X0I2zqZD/z6fVXPpSHXSC0naf3vVU+ex0tDIMfGQ5pb
oGtYLUMa6kodFyKdUsj8wq5MGnZs9ZMl3SR0jO7rqjS0bezTJl2A2jOCmGQg
i37wbtKJbi4nzDllYHeZHLl/GLj/8M0ZFpWB9BF65H5jwHQh0UlUUwaO2G8w
Ia1ZPF5+1VUGbuVSsyctfvHa1b2XZaApMCP3MwM6cXq5DT4ysGaPmwPp6ouC
/smBMrCHMcSFtKOEjmpDogyc3e3vQfqZZ/DTbX9koCfjRnI/NXBQ+N3V3SsD
11mOk/utwfZ2MbWnEzKQbeHaXdIjSZb9C0wUGBt14wHpEK7B2yekKbCqIiOC
9IwL57vsjRTYfMz0+X/x+7G1jl2FAm+e7YghrertI12gTYFlJb/iSdd0sX8V
P0qB6xxL5P5xoLVb7Z+nNQUavZIl95eD+Ahz9io7CpT4okPuPwcXjeOs/V0p
8Gf2gSzSvB+3zLTdpcDzyTVfSHefvaof8oQCh61NvpLOlix8ovuSAmcb4gtJ
mwcdUX2ZS4HVZyuL/4t/Q33Chp8UeOBoTBnpcYoVf0AtBTbJGlaSDv5qO28/
RIFB7aCWdDNb9/naGQr8WB72m7S8lWM7oJeFja9+NpAunDj/gyIuCw/Zt5P7
+cGJR5dS6LfLQp/l8Lb/4rPp2qN/h2Th2LVp8n0AEIZuXPrpJAsXVxj+kVY+
ec8y+YYsvDJV0fff9XEJgaRoWbjKeneQtFDhG8XEj7Jw8OQc+T4CeHhRiz++
RhZuHVYe+2/8ZcuW44ZlIcPCZirp0btDNc9l5ODZlEeT/13/AHtSuKUcTNxy
iHw/AtQnz0+aF8hBLUXxhf/Gw6F/L7+MPCQm0pdIb34jJv4gTB7e6ntCvn8B
/v9+Bvz/+xngf0yW5GA=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-10, 10}, {-0.9999999958776894, 0.9999999958776894}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.475745858256857*^9, 3.475745870853409*^9}, 
   3.47584881926021*^9, 3.475906055317595*^9, 3.475933102035112*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Arc tangent (bipolar)", "Subsection",
 CellChangeTimes->{{3.475746478056225*^9, 3.47574648162997*^9}, {
  3.475746542672554*^9, 3.475746542854183*^9}, {3.475746674593803*^9, 
  3.475746677697225*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"ArcTan", "[", "x", "]"}], 
    FractionBox["\[Pi]", "2"]], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "Thick"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475746560895167*^9, 3.475746647626491*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Thickness[Large], LineBox[CompressedData["
1:eJwtmHkw1f/3x+37eiUh66WFSiWk1HnbRclSlLRaQj4pIruKlBLZi2RJkjWl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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-10, 10}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.475746584355428*^9, 3.475746600481353*^9}, {
   3.475746644422522*^9, 3.475746656724406*^9}, 3.47584881931008*^9, 
   3.475906055422598*^9, 3.475933102063611*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["MP - Perceptron", "Section",
 CellChangeTimes->{{3.475740396409342*^9, 3.47574040824817*^9}}],

Cell[CellGroupData[{

Cell["Definition", "Subsection",
 CellChangeTimes->{{3.475746800504829*^9, 3.475746802456083*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"perceptron", "[", 
   RowBox[{"X_List", ",", "W_List"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"bipolarStep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", "1.", "}"}], "~", "Join", "~", "X"}], ".", "W"}], "]"}], 
  " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    SubscriptBox["x", "0"], "=", 
    RowBox[{"1", " ", "for", " ", "bias"}]}], " ", "*)"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.47538462036994*^9, 3.475384746944824*^9}, {
   3.475384819255473*^9, 3.4753848395205793`*^9}, {3.4753850043515463`*^9, 
   3.475385004898435*^9}, {3.475386033336402*^9, 3.475386043836872*^9}, {
   3.475386238454966*^9, 3.475386295754408*^9}, {3.4753877797846937`*^9, 
   3.4753877850036106`*^9}, {3.475503823950312*^9, 3.475503827343865*^9}, {
   3.475504043155223*^9, 3.47550408003501*^9}, {3.475504114909236*^9, 
   3.475504177209405*^9}, {3.475504209612382*^9, 3.475504226932634*^9}, {
   3.475504314292355*^9, 3.475504330832078*^9}, {3.475504569977333*^9, 
   3.475504574438127*^9}, {3.475505477727248*^9, 3.4755054792771*^9}, 
   3.475740458302717*^9, {3.475740494883809*^9, 3.47574049808059*^9}, 
   3.475744779443448*^9, {3.475745630740008*^9, 3.475745675439365*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Perceptron with 2 inputs", "Subsection",
 CellChangeTimes->{{3.47574682656277*^9, 3.475746837836811*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Plot3D", "[", 
    RowBox[{
     RowBox[{"perceptron", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["x", "1"], ",", 
         SubscriptBox["x", "2"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"b", ",", 
         SubscriptBox["w", "1"], ",", 
         SubscriptBox["w", "2"]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "1"], ",", 
       RowBox[{"-", "5"}], ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "2"], ",", 
       RowBox[{"-", "5"}], ",", "5"}], "}"}], ",", 
     RowBox[{"PlotPoints", "\[Rule]", "30"}], ",", 
     RowBox[{"Mesh", "\[Rule]", "True"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["x", "1"], ",", 
        SubscriptBox["x", "2"]}], "}"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["w", "1"], ",", "0"}], "}"}], ",", 
     RowBox[{"-", "5"}], ",", "5", ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["w", "2"], ",", "0"}], "}"}], ",", 
     RowBox[{"-", "5"}], ",", "5", ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"b", ",", "0"}], "}"}], ",", 
     RowBox[{"-", "5"}], ",", "5", ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
   RowBox[{"ContinuousAction", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBWIQvVTj/b+jT1469muo/AfR09RuMh8D0u8WTeAB0eGz
V8iB6M+zleVB9KVLvpYg+k7oQSsQXfZivjOI/vCa0RVEv2666gOiX5gax4Ho
tG9aJSBa8ns6mBbgOlUNVs8pUgOinyts2wSiU1RvbQHRDY/PfCl6+tLxWbPt
TxD9xfyxTTGQXjxV2RFEu9vt9ygB0u+2zPcE0WevJ/qC6NR/c8H0lRk82SBa
JP4xmM6LD+8B0ex5m3tBdPonjWkgun6dDpgW1902H0SXTngDpg+J7fwCottS
V38D0dbqnoKlQDpZe4YoiA5+/l0BRPPdZlUE0dWL/6mA6Fcvz6mDaABZ8sYc

  "]],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`b$$ = 3., $CellContext`$1$$ = 
    1., $CellContext`$2$$ = 2., Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`$1$$], 0, 
       RawBoxes[
        TagBox[
         SubscriptBox["w", "1"], HoldForm]]}, -5, 5}, {{
       Hold[$CellContext`$2$$], 0, 
       RawBoxes[
        TagBox[
         SubscriptBox["w", "2"], HoldForm]]}, -5, 5}, {{
       Hold[$CellContext`b$$], 0}, -5, 5}}, Typeset`size$$ = {
    360., {144., 148.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`$1$879$$ = 
    0, $CellContext`$2$880$$ = 0, $CellContext`b$881$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`b$$ = 0, $CellContext`$1$$ = 
        0, $CellContext`$2$$ = 0}, "ControllerVariables" :> {
        Hold[$CellContext`$1$$, $CellContext`$1$879$$, 0], 
        Hold[$CellContext`$2$$, $CellContext`$2$880$$, 0], 
        Hold[$CellContext`b$$, $CellContext`b$881$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Plot3D[
        $CellContext`perceptron[{
          Subscript[$CellContext`x, 1], 
          
          Subscript[$CellContext`x, 
           2]}, {$CellContext`b$$, $CellContext`$1$$, $CellContext`$2$$}], {
         Subscript[$CellContext`x, 1], -5, 5}, {
         Subscript[$CellContext`x, 2], -5, 5}, PlotPoints -> 30, Mesh -> True,
         AxesLabel -> {
          Subscript[$CellContext`x, 1], 
          Subscript[$CellContext`x, 2]}], 
      "Specifications" :> {{{$CellContext`$1$$, 0, 
          RawBoxes[
           TagBox[
            SubscriptBox["w", "1"], HoldForm]]}, -5, 5, Appearance -> 
         "Labeled"}, {{$CellContext`$2$$, 0, 
          RawBoxes[
           TagBox[
            SubscriptBox["w", "2"], HoldForm]]}, -5, 5, Appearance -> 
         "Labeled"}, {{$CellContext`b$$, 0}, -5, 5, Appearance -> "Labeled"}},
       "Options" :> {ContinuousAction -> False}, "DefaultOptions" :> {}],
     ImageSizeCache->{405., {214., 219.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{{3.475849658714327*^9, 3.475849727354893*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AND dataset", "Subsection",
 CellChangeTimes->{{3.475746862542107*^9, 3.475746871499506*^9}, {
  3.475748704510656*^9, 3.475748719720257*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"data", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", "1"}], "}"}]}], "}"}]}], ";"}], 
  " ", 
  RowBox[{"(*", " ", "AND", " ", "*)"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475501593815835*^9, 3.475501687474803*^9}, {
   3.475505162283058*^9, 3.475505173395196*^9}, {3.475505403960305*^9, 
   3.475505411837414*^9}, 3.475509606611276*^9, {3.475514830097188*^9, 
   3.475514896464199*^9}, 3.475515026785462*^9, {3.47551610746383*^9, 
   3.475516107734338*^9}, 3.475516209669685*^9, {3.475745122132626*^9, 
   3.475745203103704*^9}, {3.475746516548525*^9, 3.475746516694583*^9}, {
   3.475748249632912*^9, 3.475748281324211*^9}}],

Cell["Generates two lists for outputs -1/1 :", "Text",
 CellChangeTimes->{{3.475748324954765*^9, 3.47574832820211*^9}, 
   3.475748459051703*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dataLists", "[", "data_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{"First", ",", "#"}], "]"}], "&"}], ",", 
    RowBox[{"GatherBy", "[", 
     RowBox[{"data", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        "<", "0"}], "&"}]}], "]"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475748232399044*^9, 3.475748251246823*^9}, {
  3.475748342657757*^9, 3.475748343175114*^9}, {3.475748396937162*^9, 
  3.475748401219676*^9}, {3.475748433881517*^9, 3.475748434463488*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"dataLists", "[", "data", "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", "Large", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.475503238168935*^9, 3.475503300937775*^9}, {
  3.475512123833643*^9, 3.47551214999443*^9}, {3.475512326845075*^9, 
  3.475512328449447*^9}, {3.475748333989379*^9, 3.475748335152931*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointSize[Large], 
    PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
    PointBox[{{1., 1.}}]}},
  AspectRatio->1,
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{{3.475503252727648*^9, 3.475503267985722*^9}, 
   3.475503301900576*^9, 3.475505177803545*^9, 3.47550541555852*^9, {
   3.475509593812786*^9, 3.475509609555326*^9}, 3.475512150786878*^9, 
   3.475512329463365*^9, 3.475514900457445*^9, 3.475515029512887*^9, 
   3.475748336239694*^9, 3.475748533116463*^9, {3.47584977344526*^9, 
   3.475849780145334*^9}, 3.475933318593693*^9}]
}, Open  ]],

Cell["Evaluates whole data set :", "Text",
 CellChangeTimes->{{3.475747414138071*^9, 3.475747438440516*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"perceptron", "[", 
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], "&"}], "/@", 
  "data"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.47550521452812*^9, 3.475505304068725*^9}, {
   3.475505652357462*^9, 3.475505675715187*^9}, {3.475510799648213*^9, 
   3.475510820081464*^9}, {3.475511419668626*^9, 3.475511434129602*^9}, {
   3.475511655247335*^9, 3.475511676176951*^9}, 3.47551172752285*^9, {
   3.475513154337915*^9, 3.475513154922981*^9}, 3.475745449963153*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.`", ",", "1.`", ",", "1.`", ",", "1.`"}], "}"}]], "Output",
 CellChangeTimes->{{3.47550526033861*^9, 3.475505304599218*^9}, 
   3.475505532189558*^9, {3.475505654504921*^9, 3.475505676309698*^9}, 
   3.475509674779231*^9, {3.475510800656089*^9, 3.475510821279975*^9}, {
   3.475511420267201*^9, 3.475511434504134*^9}, {3.475511658543226*^9, 
   3.475511676719109*^9}, 3.475511731278756*^9, 3.475513155726106*^9, 
   3.475514528131293*^9, 3.475745450670903*^9, 3.475747406011021*^9, 
   3.475848819426062*^9, 3.475849820351217*^9, 3.475906055578983*^9, 
   3.475933102245617*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Apply single pattern", "Subsection",
 CellChangeTimes->{{3.475747090905561*^9, 3.475747095252009*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"applyPatternMP", "[", 
   RowBox[{"W_", ",", "pattern_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"d", ",", "y", ",", "s", ",", "X"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"y", "=", 
      RowBox[{"perceptron", "[", 
       RowBox[{
        RowBox[{
        "pattern", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        ",", "W"}], "]"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{
      "perceptron", " ", "output", " ", "with", " ", "weights", " ", "W"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"d", "=", 
      RowBox[{
      "pattern", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
     ";", " ", 
     RowBox[{"(*", 
      RowBox[{"desired", " ", "output"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"\[Mu]", "=", "0.3"}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{"learning", " ", "rate"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"X", " ", "=", " ", 
      RowBox[{
       RowBox[{"{", "1.", "}"}], "~", "Join", "~", 
       RowBox[{
       "pattern", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
     ";", " ", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"input", " ", "vector"}], " ", "-", " ", 
       RowBox[{
        SubscriptBox["x", "0"], " ", "set", " ", "to", " ", "1", " ", "for", 
        " ", "threshold"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"s", "=", 
      RowBox[{"X", ".", "W"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{"perceptron", " ", "inner", " ", "potential"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"W", "+", 
      RowBox[{"\[Mu]", 
       RowBox[{"(", 
        RowBox[{"d", "-", "y"}], ")"}], "X"}]}]}]}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"MP", "-", "perceptron"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"W", "+", 
     RowBox[{"\[Mu]", 
      RowBox[{"(", 
       RowBox[{"d", "-", "s"}], ")"}], "X"}]}], "*)"}], " ", 
   RowBox[{"(*", " ", "ADALINE", " ", "*)"}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.47551426501123*^9, 3.475514369427668*^9}, {
   3.47551442675434*^9, 3.475514429238621*^9}, 3.475514462941724*^9, {
   3.475514521995646*^9, 3.475514522752442*^9}, {3.475514557360269*^9, 
   3.475514557477169*^9}, {3.475514589974524*^9, 3.475514619258134*^9}, 
   3.47551467486032*^9, {3.47551473113451*^9, 3.475514732095642*^9}, {
   3.475745332353403*^9, 3.475745357518421*^9}, 3.475745420165207*^9, {
   3.475747110786727*^9, 3.47574714781749*^9}, {3.47593318038934*^9, 
   3.475933203282893*^9}, {3.475933248474915*^9, 3.475933260660734*^9}, 
   3.475933357722689*^9, {3.475933398666853*^9, 3.475933465305018*^9}, {
   3.475933525062559*^9, 3.475933541128798*^9}, {3.475933629792693*^9, 
   3.475933660167537*^9}, {3.475933693211115*^9, 3.475933705158765*^9}, {
   3.475933739063799*^9, 3.475933870437955*^9}, {3.47593391258471*^9, 
   3.475933924804377*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Single epoch (apply all patterns)", "Subsection",
 CellChangeTimes->{{3.475747170512482*^9, 3.475747172697445*^9}, {
  3.475747312713709*^9, 3.475747327639262*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"applyAllPaterns", "[", 
   RowBox[{"W_", ",", "data_"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"applyPatternMP", ",", "W", ",", "data"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475510414105587*^9, 3.475510414841124*^9}, {
   3.475510465058057*^9, 3.475510490404172*^9}, {3.475510697771744*^9, 
   3.475510733100854*^9}, {3.475510781618676*^9, 3.475510782284606*^9}, {
   3.475510812644445*^9, 3.475510868141183*^9}, {3.4755113775134*^9, 
   3.475511395491315*^9}, 3.475511546342326*^9, {3.475514540305493*^9, 
   3.475514540373886*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Learning", "Subsection",
 CellChangeTimes->{{3.475747209585992*^9, 3.475747210624008*^9}}],

Cell["\<\
Update the weights till they stop changing (limit to at most 30 iterations). \
Better approach will be to stop when classification error = 0.\
\>", "Text",
 CellChangeTimes->{{3.475747530824559*^9, 3.47574759788692*^9}, {
  3.475933498273069*^9, 3.47593351612894*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"learn", "[", 
   RowBox[{"W_", ",", "data_"}], "]"}], ":=", 
  RowBox[{"FixedPointList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"applyAllPaterns", "[", 
      RowBox[{"#", ",", "data"}], "]"}], "&"}], ",", "W", ",", "30"}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475510879043703*^9, 3.475510879113143*^9}, {
  3.475511346906812*^9, 3.475511357248675*^9}, {3.475511425794039*^9, 
  3.475511442287464*^9}, {3.475511606287656*^9, 3.475511664158424*^9}, {
  3.475511703458128*^9, 3.47551171919556*^9}, {3.47551218000393*^9, 
  3.475512181865197*^9}, {3.475513352617819*^9, 3.475513372280772*^9}, {
  3.47551351099274*^9, 3.475513523595317*^9}, {3.475514936886984*^9, 
  3.475514941958239*^9}}],

Cell["Shows the learning process iteration by iteration :", "Text",
 CellChangeTimes->{{3.475747630900901*^9, 3.475747657567779*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"showClassification", "[", 
   RowBox[{"W_", ",", "data_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Show", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"RegionPlot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"W", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        "+", 
        RowBox[{"x", " ", 
         RowBox[{
         "W", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], " ", 
        "+", " ", 
        RowBox[{"y", " ", 
         RowBox[{
         "W", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]}], " ",
        "<=", " ", "0"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "1.5"}], ",", "1.5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "1.5"}], ",", "1.5"}], "}"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"dataLists", "[", "data", "]"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"PointSize", "[", "Large", "]"}]}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Graphics", "[", 
     RowBox[{"Inset", "[", 
      RowBox[{
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<\!\(\*SubscriptBox[\(w\), \(0\)]\) =\>\"", ",", 
             RowBox[{
             "W", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\"\<\!\(\*SubscriptBox[\(w\), \(1\)]\) = \>\"", ",", 
             RowBox[{
             "W", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\"\<\!\(\*SubscriptBox[\(w\), \(2\)]\) = \>\"", ",", 
             RowBox[{
             "W", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
            "}"}]}], "}"}], ",", 
         RowBox[{"Frame", "\[Rule]", "Center"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475512344322427*^9, 3.475512382843123*^9}, {
   3.475512420208626*^9, 3.475512432942957*^9}, {3.475512929029138*^9, 
   3.475513011861514*^9}, 3.475513138775802*^9, {3.475513560570511*^9, 
   3.47551358920607*^9}, {3.475513751575486*^9, 3.47551375859815*^9}, {
   3.475513803492517*^9, 3.475513819979231*^9}, {3.475513850557482*^9, 
   3.475513853624126*^9}, {3.47551509194844*^9, 3.47551512617991*^9}, {
   3.475515292598197*^9, 3.475515297553398*^9}, {3.47551546415158*^9, 
   3.475515572753247*^9}, {3.475515618075407*^9, 3.475515747046619*^9}, {
   3.475515811955811*^9, 3.475515836561985*^9}, {3.475515887772508*^9, 
   3.475515900813957*^9}, {3.475747772705582*^9, 3.475747778502645*^9}, {
   3.475748555527748*^9, 3.475748557888544*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"showClassification", "[", 
    RowBox[{"#", ",", "data"}], "]"}], "&"}], "/@", 
  RowBox[{"learn", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", 
      RowBox[{"-", "15"}]}], "}"}], ",", "data"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.475512387830399*^9, 3.475512409872686*^9}, {
   3.475513112583516*^9, 3.47551311625671*^9}, {3.475513214037697*^9, 
   3.475513214120564*^9}, {3.475513317255631*^9, 3.475513318257736*^9}, {
   3.475513397913365*^9, 3.475513417773339*^9}, 3.475513485554035*^9, {
   3.475513534428019*^9, 3.475513538958004*^9}, {3.47551361044526*^9, 
   3.475513639004709*^9}, {3.475513690688605*^9, 3.47551369877354*^9}, {
   3.475513900380529*^9, 3.475513925984318*^9}, {3.475515848115442*^9, 
   3.475515850322141*^9}, {3.475748025727256*^9, 3.475748027199225*^9}, 
   3.475849974157898*^9, 3.475933674080788*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJxll31YzOkaxwvrJeawrsWeudbRppitrMR427jXDsvx1oiz4TAcZCN7sXk5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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHnYlkUVxme0PvhkEUR2LEBTgdhERRY/2VEgVhEUlEU+ULYPSElJxSAX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            "]], PolygonBox[CompressedData["
1:eJwlk1lvjWEURvdujwvao9Q8FjVdqLnREFNNNVNzQ7RFizT1zzSIudRMpGlE
pIoaipr9AxfWk+di5axzvu+8e3xnt15o7CyJiNVQgMyIufAMvw8z8PUwiH+H
OXh1+lkRzuMjoQx/CUvwf3x2wwCs4nsRLuF3YCa+Ad7jP8OxSuBBOOYhfAQ8
xr/CWnwsXMF74Dg+GW7iT6ADHwXl+CvYhxfgEf4ZduKl8BD/BFX4RviA/4aT
+FS4hT9VH/AKuIzfhU7Vlq61H8bj86E33JNKfB3cC+c4Gq9L/1c1r8CXQRf+
Bsbga9K1KIZyPQBfwjmfw+tVE/4XDuKNcD38zkK8Hf7gL6AcX5nurWJMx8fB
u3BOW/Ft6dzVI529KT0rxdCslqdz08w0i+3wMTyTHXgDXA3/thffDdfwoXBv
96RdPT6Lz0rnrhzb0j1Xr3/BAvxM2vtgEb40vSsXw7UeTs9eNS9Ov6Nnr8O5
7ErPUjlNTPdEvdBMJ6Rj6GztmHLdn94F5VyL16TPegvT8Ga4Hd6BeXgLfMOf
w+n0zmpXf4Rnfyrt2gHt6lEYDu/sJLwpvZs34Bh+JO16R7NRDJ2tGbWm75ju
lmJOwU+kd1E7vhnfkt5t3bH/UhVzQQ==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0mk3FFAcB+AZhRYNES0SM8lSlgqTaENopgVTWuy0Eo3pO/AdtAllSc7p
fd+kz0I8Di+e87vnd889557/veGxZOJDMBAIfOUPu+sQEaLEGeIjs3ziM1/2
z3xjnu8ssMgSP/jJMiusssYv1vnNBnPMkGKQGA2E+cshFxqhkCHOMEwmg5ym
n1MMkEEfJ3nGC56TTi9PSfCExxykmx4e0sUjDnCfB9wjTow0SgmSIsx5IiQ5
yu5AL9FJB1McYZKLtHOX9xxmgkraaGWcEt7xlgoKaKGYN7ymnHzucI5XvKSM
E9ymiDFGuUAeZ5kO7j32LXK5wXFusm2rWeZwnWya+K9vlCGiHOMaW/p6mcUV
6rjKpr5WXqaKGqpp4N/+f9sB6t40Lw==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", "3"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", "1"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "15"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJxlmHtYlMUex1GJ1EAISXGt5CgamdcOmPpgPxRDHx9F9Jilp4PlhczFNO+r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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHnclkUVhmcQhA/UDz72zdgUWQU10VBDRQW3cMEABZV9FVAREGRzRVBA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            "]], PolygonBox[CompressedData["
1:eJwtk+dqVlEQRWeMPoA+QGJQ7L0kGuwVxQJRbKlGEmJL7MReECtiexWV2Csi
EkREROw1NqxY/2Vttj8W3+J+95xzz8ye4rrm8qZOETEOOkN9RgyC0/gFGIUv
gAf4W2jEh8AZ/CKU4YvgEf4OpuCz4Qb+CybhK+El/gMm4ivgBf4NJuNH4Sfe
DdbiPeEK/hpm4T3gcnjPJnxd+r9WGIMvgSf4BxiNL4SHeDvU4d3Td3mme+L7
4DPeBcbjM+E6/gVa8BI4h1+FGnxZeu0pmIEXwfnwmmn4lvRZf2AgPhduhb/p
CN4vfbf7sA3vD73CNTuM94Wu+D1Ymj5TZz2FKrwa2v73pwKvhNt4QbhWG+BN
uGZ78T7pu2nNHrx3eq3W6Ntr03vrDhPwYfAcvwRD8eVpV48H4w3pXisTG/H1
cDZ8pnrTDK/CPZqOb01n4R+swlen7647rkn3UL3TmpH4pnStteehdGaUle8w
Dz+Y9ruwI91z9fp9uNY74WO45rvTNVJtPsEufGza9c4AfA7cxB+HfXt6Lz1T
LcrhTrgmw9PfoLOV2RH4/HSvlOlSfDNcC2dG2VKmlCVl7EA688r61/De+9Ou
M06ma6Za/Q1n90TaleHj6YwpW79hanomNYs6U7OjmdOsaYY0q8fS72pmC/HF
6bvyEx2z+4sw
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0ss3FAAUB+CZTat29tWkyKMUkWco0YMZKSpChgjVhJpR0QOlkEexVSkR
KvyFvjlZfOf+Vvfec88NRWMNj4OBQGCZQ0IyHyCFdEqI0EmCab7yje+s8IOf
rPKLNdb5zQabbPGHv/xjmx1292dPESdKmGIOWiYtuYOaxQi3KeYlNXzhM7co
4gXVLDBPE4VcYinZj+ecI0EBwxwnTj5DPOMpxxhgkOShnhAjlVrqqGKOi1xj
lkw+0cgjHjJDBtPc5Cz9XGCKj9wgjz4q+cAkDeRSwSJH6eUMPZzmASG6yaGL
U9znCFE6aaeDexzmClcp5z3nucw7TjDBddpoZZx0xqjnLi28pYw3vCbCSZop
5RWjhMnmTvD/z+0BBd0+8g==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", "2.4`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", "1.6`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "13.200000000000001`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJxlmHlUVEcWh4FMEJVGBzHBPi6JKHZww4ntNuo1tNugkNbMiImxjUaNiuM6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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXnclkUVhp9hkZ3vg082Q1bZFAVRFEQMBEGQXVARRZaQTRZZRUR2BDeI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            "]], PolygonBox[CompressedData["
1:eJwtk1lvTlEUhtcSF/UD6oaKNk3VPJWQmuchhFZFamiUIoYWMRMEQSpIb/wU
UiGGGlqUiIhII6YaawrCrefN6+L5zvPtc/Y+Z7177eL6pqrGXhExGXrDvIwo
gpv4A5iJX4ACuMr/hVyL4Q7eCbPxpfAI/wuz8Bb4g5dDP7wWXuFcYgY/u+Ez
XgbT8Gb4ifeFXfj4/++6B5vx0XAZvwtr8eFwCW+DNfiAtL+B9fgmeI+3whK8
DO6Hv3EqvhU+4t9hI16SXltzFuGl0IE/hDn4XLiBK6dJ+Droxr/CdHxx+tlf
0D+dobLTnAn4CngRrvkQXp5e6zGcxoeka++Co/hg6IM/hUp8JLzFb4X3ZhW8
Du/RanwlXAyPnceHprN/CXvwvWkfBCPw+vRaylC1bodP4Zq1tw3wLrzHG9KZ
KkuN7cCb4Ep4zhh8C7SH92gb3piupRDG4TvTe6k5U/Cx8CE8R9mcgd/hjM7h
Z9PfqjH1hjJWtuqR+fgCuB3OaBhelc5SPTYw3aPqTT2j7KrhSThDvbsGnoW/
QdnVpXtHGY7Cl6Wz1x7r2WPwLTzneLqH1DsaO4WfTNf6I9z7OhM6CzoDy/ET
6XvPYSJ+EK7j18K9uR96wj16AN+XvqexivQamquePZLuQfXel3Bth9OuGnVW
dcZ0tnRm/wGo9oRA
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0lkzFQAYBuBjuvMHuihJRSlUKtlL2VI4RJZs6RxLhTZrkYqEI5Jct4hk
K/oB/TSP0cUz8958M++888W19lR2RwUCgW8cEvbyAaI5SCI5VBBmkBm+/r/5
zhI/WGaFn6zyizXW2WCTLX7zh212+MsXIgwQIkg2/zip1AsyGGCIQRIIUkEB
H8mnnDnOMEsd/fQxwwciTFNLOr1cY5HrXOYZaTwnnqdcoocnPOYEpZSRxxRX
ucUkp3lPDXtDd/GOCcYZ4w4XecQV3vKGai6Qy2eO85BUOjnPA47RTgch2ggT
x02OskAOJdzgNYmMUsU57pPNK0a4zVmy+EQsraTQQjL3OEITzdylkQZiKOYw
82RSRCHDnOIllSRRH7X/g7tJkEC5
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "1.7999999999999998`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", "2.2`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "11.400000000000002`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mXlUU1cexxFwqZqp+xIdVATMKFPUY6ri8qum2taCZPRojyJxw9aRWq1a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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHkcVkUVhueyCajs+yogu6CQiIoIKpuKRiihgoKIBkKgEiAam4Agq4iA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            "]], PolygonBox[CompressedData["
1:eJwtlFdrFWEURc8RQR+TH+BDnk1QomJvMViwR7GhYo3Ekij2hiVWFBUrig1F
n/QPBBGDYOy9IiIiYq8RxUJ0bXYe1p11586c+805+5uiaTUV1S0iogxawtiM
OAuFUM/3VRxXw3O8FQzDp8I9/Cf0xxfDK/wLTMQnwSVcdYfja+E9XgAj8cPw
Cy+EKXg7uBKu2Q9fBC/xj9AXXwgvwjWK8clwN/wfg/Al8Br/CtV4DTzB70Av
fAE8w99BD3w+PMXfwFD8IPzAW8N0vD1cxe9DFd4JbuEPYQ3eG86F11yBz0hf
+xt24APgYviebXh5cy9vwgj8DBQ01xjPcXa69j/YiG+Fz/gFaIsvTa+VQ4zj
4wQ04SWwBe+Yrq17ZuEd4Ab+AMbg29OzKQ73rgQawj3Us2ummqV6oLVpZpqV
1rgPhsB3vjeGe7k37eqpai2Ht+GaPfGVcBmvgxX4srTrmpl4JVzH20Bpes1a
q87NweemZ9cHNqd7ol58Cj/bprTrGWvxdXAe/wCj0hlSdq6FZ7k+/ZtmOjid
CWVBayzDN6SvVY15eBd4jD+CzulzcmXqON493XtlXlnaBd/CmVK2lQllQRnf
g+9O7wVdMyGdWWX1NgzEd6ZdmVH2j8Cf8B44io+Gv+FzyvrJdBiU+QMcu6az
qz16CO+W3lvaM8qKMqZsKTPH0jNQ71XzNH4q3WvV3J/e89rrmrneBcqQsqN3
wn9JV5dz
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0tdWDwAABvB/x5XbHqBzXKeEhkopq6GUtKymFppoL4UmShpktHdREi/Q
O3icfh0ufud8V9/5Lr5TZfU5dUGBQGCDUOE4n+AkwYQQTjJ51NDFOMussMoa
6/97Ntlimx2+84Nd9vjJPr844Dd/WGKMTqrJ5ZC/XDCslhjqOR59jyc8ZpkV
llikmTTuskk070jlDSm8JYoaHnGHBQqpZp545njOdUbJZ5sCrjHMVUaIZJAh
XjHAa85TxTk2yKOSCr6Ry1e+8Iwr3Gads7zkMi/op48IynlIDp+5RRmzxPGJ
pyTTSxZbZJNEN5fo4QwllHKTj2RSzAyxTNNEF51MkcEkH2gkkRusEU4HCbTS
ThthFHGaVdJ5wH3eM8E4YzRwkZagfx89AmFSTnQ=
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "1.1999999999999997`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "2.8000000000000003`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "9.600000000000003`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJxlmHtYlNUWh0csFXVSPAo6oXlJmsqjmI4CZUucFJWUybti4wm1B6UwhdQx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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHn8l1MWx+9VinaUtO9KST8tIqQpjEhlCSGUpURFEpHIFlmyk9QUkez7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            "]], PolygonBox[CompressedData["
1:eJwtk1mrjWEYhp9nY5dDJxs5cuQXmLPRxpapbDLPZLZlziyZMmfKlDFCCKeG
khIp8zbPQ5JkliHDdXd/B9d6r+9b63vftZ77Xo1HTK6qLomICqgNWzOiB1zE
78ARvBM0w99DL3w9fMC/Q098Xfq9bzAMnwPP8L8wG28Dt8P3huIH4A9eD2bh
reEm/hS642vhHf4FuuFr4C3+OfysztDe2qMvPhUe4T9hCV4BD/CX0AUfDDfw
J1CJr4Y3+EcYiM9Mv1cXZuAt4Tr+GCbgp6AOVHK9i7U3XAmfMRFfmj6rlLUa
zkHD4jOjWM9A/WKmY1jPQgO4xPUG1s5wPnzmIPw0lBX3+rDuhh84S8znpW06
m+cwFj8KWWS0iLU93MNfwGh8ZzqbpjAFbw5XwzM7jB+CRvi/8OwPpl0Z7MOn
pbvxG8anO6Ds78MKvAO8xl/BDnxb8du+Qqt0xspWGbRIz1izvRbee3radcaQ
dObK+hYMT3dCXVCH1JVN8Cncmf14x3SX1JF+6YyVrX7jSnxV+rs9hM34RrgQ
3qMrviV9lu7NxedBTXgmykoz1OyU2QJYCHe5bgLl6UyUhZ5RFuOgpMhEWapj
6lZZ0b098Cvcwb14//RsdU9Zq9PqsjJXd0amz1KHjkEVXA6fcRJOFN2sxdou
3QFlr++ozy5OZ6Vn1I3t6WzUEXVbHS4tOq7/9vH0XvqPL2Ndnp7dgHC3J6Vd
Hf8P2OiaZw==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0llTDQAYBuBTM266dN1Nd/0CISlliRBRaZFESduhstOK9giVpbSgtJ1O
+37+QT/Db3DrOZOLZ+a9+uZ9Z76EsmBOXUwgEFjmiBDNf4nlEHEcJp5Eksik
iCDtDDPHPAuEWCTM0v/bK6yyxjobbLLFNjvsskeEWYZoo459/nBawU566KaL
IB28pZYI0VG5jHKd72TwmjfUsEw17YRZYpEQ77lGFduk00YOC9xnnkpameMs
s7zjKiNUsMc9rvCFb3zlFC2ksUU5zTRxh13uks0wl/lMKq84ySZlvOQFv5lh
min6ucRtNkjhGc8p5Re3eMpPzvCDPi5SwjonGCKLjwzyiWSecJw1bnKBxxSx
QzHnGSCTDxzjEUdZpZBGGpikgAnG6eUcN1ghiYfUk88YeTyIOfjhf76bWi4=

         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "0.5999999999999998`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "3.4000000000000004`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "7.800000000000004`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHlw1EUWxwMqSspRwKhsRDkSyYgBCSaAgHSsICogDqCui9aILFmQsJxF
yllFt1yIrIAHDiuLgAlQLJsKCcuxgA40hogkAkauwYAhx0wCIeaYkEPQZIf+
8emhOi7/dH16+tf93rffe/1I76lzJiZ3DAsLO94hLOzaOPODdafa2prlji4L
voosuCQrlk8bmuRq1MzvmbYO72V4KvTv8NRlD3+WFghoZn1G+Ifj7Dmlej3M
erj474Ff81PqNHMuzH4D7xwW7Uz6Qe8Hsx/MfjD7wdgJs//j3bKcXscxvT/M
/jD7w+wPsz+MHzDnwpwff/vhi76Enfp8mPNhzoc5H+Z8mPNhzoexA8aebhYL
7IGxB8YeGHtg7IGxB8YeGHtg7ILNEXtjre+0vTD2wtgLYy+MvTD2wtgLYy+M
vTB2wuaI/XZrX20/jP0w9sPYD2M/jP0w9sPYD2M/jP0wdsPmuM46TzP+MY9/
MP7B+AfjH4x/MP7B+AfjH4x/MP7B+Gf6AZvjZssezfjLPP7C+AvjL4y/MP7C
+AvjL4y/MP7C+AvjL4y/pl+wOeZY9mo+Z/mjGT1Yhx4wesDoAaMHjB4wesDo
AaMHjB4wesDoAaMHjB6m37A5ogc8xfJXM/qwDn1g9IHRB0YfGH1g9IHRB0Yf
GH1g9IHRB0YfGH3MODB1gM0RfWCfpYfm63qZLPkO/WD0g9EPRj8Y/WD0g9EP
Rj8Y/WD0g9EPRj8Y/WD0M+PG1Ak2R/SD0c9gyTr0g9EPRj8Y/WD0g9EPRj8Y
/WD0g9EPRj8Y/WD0g9EPRj8zrkydYHNEP4Ppm7R+MPrB6AcbfbYw+mhh9MHC
6FuF0UcKo48z+ySz7zDfafMdM+u4Wbfa5aUZZ6Zu/2eUQ5VdNTJa2XtZDlB2
XZTpyp562VfN+/T8Y2p9sZ6PUeNJPcaqMU+PYerffzyRFgvGntZ6PcZZ+2ru
Y+2v5/tZ5+v5eMtuzeste411l/W6fyk9mzTjH/dOfOAXI/dOPJh+cu+M+Mt9
m/6afRzz3Lfpr/nu4S/3bfpr5hn+dhj74wKvIyBnqXuvlKIg8UGXrV5eUOv8
etypvj8rp6n9y2SWsuu0jFfn5MvRar/9enxSnbtJrlF2fi+irHVik/WdYH6G
da44q3QuEdUfnp7vSau67keZ+OpbV26Cu0HP/23cPV3d3sti/sd3dnHZfhJb
rPvTcQiTx8Qx8Qlzb8xzbzB5bMYpTB53Hv9ctsPZLFMte+SVlU9vTXDXap3O
W37JjZa/WpcO1iieOrr91UBkk/6eeoU/Syx/ZZ3lv85HmO84D7/xg3XYwb4w
94p9+v9T1/Uw75k4h/GDEV3QK8qKBz2a8/hv+mPaZ57H9+QveQ5TB9GLvIXJ
b/TALxgdmOfetf/X85q8NEfz/ynME9dZll86D8lX2OzT+P1xKz913txmxZ9o
suJOEC/kM4xfB6180r+jOzrDxA/r+J14IM9h4oU44nfymryH8R+7rbrk14x/
vEvcL/6iA+8594t/1C3umXvDH+w289zMU7NOw9Rr6hoj86xnnnqXeFNxadud
7d+XmMpH+jnL/XL6r8kR7uaydu9LbO6nM70feaVzwzv2JNf+du9L4rZFndze
TP13jn/OcS3LiM8Tvpftg5P2nW73vkS+2DIjUFSo46zu4OKchGB83j5k5hjb
e1Xt3peecVP+nbK0TL8v4TM2j7MF4zGiV8lbHm/79yVuyKgHnBurxUOZz/l9
+5rk4B/u2OAYX6P/njX8p7s+d7TWyszR65PssknX5T2dy9727GyQ4RGdrmQ/
WSX/3HHgyKS4gFzZsyXRLi7IYWOfuc85KdiXnOjX3/moT04Mnz3e9sQF2WLr
s8TTr0TmXu18NHKYX7YNsq9OefqcHLG4wut7oVhGr1kx1zvwpJyn9jsuV6v9
Dsu1Bd+lekYflp5nD7xie/CAjLr/mp7xMurqN9dGkWatE9ktn67MiD0g/LGj
olz9j4v3re9El5Tu76UFdWudFt/NHbzviXvFYPuEELd2ccuEoX7hui1iR8K4
c+IDyw+xU+0XzIuRZYHsYL6vHNq6yBN8v/P8CwvabuBw28LdjoEBMd7yU7wQ
EdOSv6NBHGp981b3U1WiOKrHhBXBesc+c5v9nl03MPnT45MzW1PC6sTQ0oJA
/g39TtqSHUcjiy7rd4P6GFeVMc1bV6X/3vnwurZMx8iLclre4d/bGgPt+sHY
q/Exzk8q5XCld43Ox4YOXavzl1XpOOa7nr59tb5TJToPBg0YMsszulhufWd4
WM5XFe36ScueIpnY1GtCYHKxzuft9QtdnkOhPGZ+0BvTL+VfKtDzvUYV35zT
O0+OKVqVZEs+1q4fHaHWfyE3RlzjUboeRKt429/uXYtOnFDY1vaF2Jp9xRM5
sX0/Z3/l3I++xgKdRzHxx8t9q7xi/pQTNteEUD/710Fyvjf4HpCX9HGx6vsi
cWin2xn4jf6vx/0vZ6WcKQm9c72OVvj8fvG8ir9Q/3tsXfjHGcE6SZ5TRx9S
9lSKOmdjp5zf6BcHRInezoYqkfjql7O9Qxtl2Kyvnw+MqZalNedGJNUHZOzp
tdO9iRdl3i0HU71ZdfLHu6esShtWIf+0q9eApGcuyZrk0vNtj5TJLSf/WBD5
RYUcnD7Pnz+2WM5R+Vcm3SoPzshVL636NfuJM3KvvHIqsl+hHKzi4Jjsa5/U
nP9wntyk8myPzFP5uU2+VTF5ccaIPWJLXMJz9ke2iWpVt46Jon3pw5KC+i+3
9hXbVX4ViirLDrHCOkfcM2zIfa6gDuRtaffj37U9dUmkWHaJd3d/9k1CVp2Y
vD27IX94hVidMTp5flCfNcPn7kkI6mPlc6NYpPK5WvefCcq/Gl3HolS98ek4
7qX8CfURG29ScabvtVjZf1KcV/acFdOtOqXztGPytXriE8vvFp+mHKkWo2/9
5S73o+W634lQ/tSIiR+O2ZhypVG8ZCtZmjb+JxEzb7vd+WWo/u5YfEs/59VG
ubbPzDczxoX6zfjWza9506tl94otSzOONOo+LHzp6qmB1MvSb+kkm6L3d3NX
Nug+gX2px46wXZscx6rl+z3SOuXEleu60qclt9q3pEzee/Dqa9651bpfvdrp
7N2ury/KE91qJtv6l8rCxL6pns0XdP9H3FC/X6/ZV5U/9qysteqwfid7q3pS
KFsWjE32flSk+5A89R6ckjc9eu09OCJnzUlfkfHLcd1PUucZpzww7/MU+xax
4ecH4p1J6TrvI1S+Z4qy+pu/bWvbqvvdUmVHrnjXilNRrN7bQ7o/vXLO/65n
dr1smjEp0vV4pSy543d9k07Vyo5d1bsgi7YtfNG2q1x++3XxGNuTRfKQyqcS
eV7l02nZtP7ttWmDcuV6K+7lf9U5W+RJlQ/pcpaqJ6H4/zJ3Vhf3kFOiadPU
rq5nj4jBqt6H4j115vLdCXkXhSNnxF7HgFJhX9jl+zU3xPfhx+btcKReFlOt
PBaty3bP9L7dLCPufSPePqlWWu9PuchT70+R2PPB/hORs+vFgls2vOEZWSk+
+8cv5b5FzaKwQ80TthdqRXnMX37ObwjViyz13ofqwShVz0P53vG+Z18PZJaI
P1wau80x8rToEb2xu/NErdhvvevif0K3RnI=
      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHn81lMWx++NSLROfpWkX6VMRSmVqChl7KJCM8rQCJGyRWSLFjUTUaks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            "]], PolygonBox[CompressedData["
1:eJwtlFdrVVEQRvcksaCS+OhbuEQIiIr/QKMSSYiisRdUosSeWGPvHUVRFMUW
RBQTxYYNyw+wxoJi77F3ERHr+ph5WMza5+bce87MN8lUVJdXZaWUSiEH9lhK
I+EW/gJm44PhH/4IyvGJcBd/Db3wHfAd/w0T8KtQCBc5b6R2N7/3A8zBz0Eu
tOfcl7oTfuB/oAbfAO/xDAzCZ8HD5NcG4LvgJ/4XtuM94RX+DUbgS+E5/hmG
4vPhCf4RRuGr4SX+Nfm71cKv5O/YH58K9/G3sB7vCg/wdzAdPwktoA3nzdQe
8BT/BGPxesgSnPdSR8Od5M84Br8CbePaWmoXuIe/geX4DegUMxhPXWPe6yaw
Gx+mv0n+mwvx69Axrk2hNkA7uMx5hSoUQCXnrdRS89l+Sf4uM6BlvNNkWGf+
7q2hCj8CTfU555nUa9BBc+a8iHoJ8qE4+bMsCNcznYchuodzHvUsnInZt6IW
mfdYvVXPO5v3RL1QxobjW+AZfhOKzXuuXmum88xnrNk+hiXmGdDsdY9+e5P5
Z3qGEvMe6N2VkQp8GzTit2GaecaULc18knlGlU3NqMw8c8qaMrTKPFPKkr6j
t/lOaBcuQB2+P7KQYlf2mbt2ppv5jmg3lHFlZxxkR4YOQB/zXcqOXTkIObEz
J6jHI4vNYzeOmbt2RNk+bd5rZfww9VDMUt9xFPpFVprFrKvNXTPXrs41n11u
zF47mkmegYbIjLKizJ2CgZENZUr/C5RhZbcwsrjSvNcFkZ3F5rNVhrQblcpA
8h3RLiyL7Gon/gOTkqZ7
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0klXDgAUBuCv45w2rSwttbdpZ1UoGUqUBkMhQ2VqIBqoZEwyNpiiaEBp
oHmeB4nqF/V8h8Vz3ru795z7bs/MTbwaEggExlkmOG8hlDC2so1wdrCTWFLI
opgamulngEGGGGaEUcb+75hgkimmmWGWOeZZYJEl+mgiwlFP5AW5ShbnaeEc
rcTzjjiWqeIsj1jiIG/J5CG/ecAb7rHBfc7widN85gCv2c8idzlFJQvso4EM
7rBCBfWUsU456TRxkmZiqWMv89zmBLeYI4ZajjNOKWOU8IoRRhlmiI8co5hZ
onnJHmYoIo0X3GCNm6QySCEDXOc5ffTzkx98IIVrTLObZ+xiigKSeUoef8nn
KL3k0kOwbDV00c13OmkkiStMEhX8OZFMcJlEqrnIHy5xhA5y+EY2j/nCV9pp
4z2HOMwvEkL+9X0Ty01n6A==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "2.220446049250313`*^-16"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", "4.`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "6.000000000000005`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mH1c09Uex9GupsYMtai7K5pA3qWJYC4VtaNOydR0lo+oS7gQxLhRaNpM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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxVmHn8l1MWx59Llgj10yIp/drTgpRCqUirJVHJUsmepUgplTUKaRiFCoUW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            "]], PolygonBox[CompressedData["
1:eJwtlDdolmEUhb/7G2P+iIKgQxCHH3EI6ODgkCAhhBBExRJ7mTTqZGLvJfbe
e02iopM1kyiKCs72XmPB3hJL7M/h3uHh3PMOX7n33Dczpqq8MpUkSR/IggOW
JC+hL7zDD0VPQCv4gR+LroQm6hQ6CqrgE/4vTKN+CIVS/Dz0MRRJ8cvQ29AF
uuIr0NXwTe9HF8EtyEBnzsaha+Pd2egE2Ai/8bnoVbgC9/Bt0HNwHr7gG6CS
+pL5t32EidSn4Q/1B9hCfQfyoRo/Hl0PP6lz0KMwEBrxhs6Hm9AJOnI2G70B
edAePxm9Bu0gjT+M9ofP1P/gLPUZ82/RN2ynfgZl8Bq/H30BveEtfjf6HHrB
G/xmtAFK4RV+OnodOkBb/FL0KZRI8SfREfCLOh2zHAbNic/0Alw07917zo6h
g+ArdQt0FjyCnlLOqtEnUCzFH0eHwHfqlugOuAvdNKfEZz83elUUz5oZvdIz
R8IpaB0zPYg+gAK4jK9B70MPqMfv0ayhO9Th+5n3WL1VBgfEzCwyUG/eM/VK
79gQGcqNngw371E6Zr7GPHPZ8U/rzDOREz07Yj5jzTZBB5v3QP+uDK8w35FU
ZGaVecazoqfl5j1Wb7VDmvW++DfNfBKMNn+2MqNsbo1s5EdWtkVvyyILm8yz
WxqzX2K+WyUxq4Xmu1QcvT0Usy6IbO2KXipj2t2pkaXC6H2t+V2gGSjbU8x3
WxnXLi833zXttHZ3cWQvE1nYaZ5dZUK7syCyox1SdmdEtpRh7dIc87siL2a9
13wXNHPdTXWRDd1R/wEdOqkY
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt08lTDwAUB/CfmnEwDSc3l2a6du3c3YwlKklUskdaRMqSpZRCtiJZsi+V
pciWUNpL+4JCcvQ3+PxmOnzmvcv3zTu8F56aEbNnQSAQaCeEYB/KQhaxhKUs
I4JIoohmOfGkkUUhFdTSSAeddNFND7300c8AXxlkiGFGGGWMcSaYJMxii5kK
ZtRBWvnER9K5w3du08wt/lLLLm7yjRu8ooY5rrOTa8H5VPOSK/zhKjuoYpJK
mrjELJfZzkUmuEAjFfzmPC94znoGOMc2ztJPAs9YRx9n2Eo5vcTzlDh6KGML
p+kmlgbW0kUpaZTQyRrqiaGDU2ymmC+spo5VfKCF96RSxDgnecJxfnGCFI4x
RiGPOcJPjpLMYUY5xCPymaGATRxkhDwesp9pDrCRXIbZxwOy+UEOSWQxRCb3
2cBe2lnJPVbQRgaJfCZ4+G94yzvu8prd/Jv/h/8iJ3Vv
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "0.6000000000000002`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", "4.6`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "4.200000000000006`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mXlY1NUax8EWyRwEKspxKfdJDdMYRdP7qlPGpdTJW9cMG3PLZUxNjRhE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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxVmHv81/MVx99v9+5Sv6gUlWsXCt1dh4zkUpT7JSsiFdFEbiW3xdxaoci9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            "]], PolygonBox[CompressedData["
1:eJwtk+mLjmEUxu/zmhFiMo1MUuotaT4o82GafBnDWGZkHySJGDNkZMa+7yFr
iGzZsi8jRln+Azt/gISI7Pu+/q7O+fDrus79vO/znPss2ZrG6oZMSqkScmCY
pVQFn/Et0VVQDq+If8BW/AD4iP8LQ/H94QM+F90BA+ELsaFroA+8If4FZfhD
0BpyiWejN6EIaonXoWuhW/L/LMPfg57wjHgvus88t6fEM9Ab0BUqiBegd6EU
nhDXotegC7Qn3o3uMc/1MfE09Dpk45vr0b7wDv8bNuI3xLt1Ngt/B0rgEfFC
9BZ0h03Ey9HbUAxXiXeiEyL3r7DaPCfl8hN6RY1V25cwGV9t/kw1H4k/C4Vw
n7gfuhn+4N/DUfwxvQ96EG8xz1G56TdH8GMgP35TYX5H3e0t9I4eqTevk/dS
PVZv1dO5+HHwL3nPq6LHFjNSiW4zNTulT8hidDxkYga2m/dEvdBvBsEuaAHf
ODqMjoY8aAv74UA8ew4H8SOgDbSClTARcuA7z0+gJ6EAhhAfR8dChzhTr2bG
bJVEb1aYv7s47jYvctcdlfsS815l4luT4EXyb6qW081rlx+5TzWvXV58u9G8
N8phuPkdlLtmfgqcgo7R01HmNdDd28Xszo9ZKo2715jPhmrQDBehEzzg7Irm
DDrDw+S70BBeO6HdmmM+60Uxq4vMd0czq92oi9nSjmgX6uPd2ejV4Ki1enYB
zsesKYcmOBe5F3J2Bj0dXne8DJeiN8pRu7zUfDe00/8BxZGQqQ==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0klTDwAABfC/9eLk5mY6ubo6pFX2NkmLipKlpFIkS0ohJG2WUtmXKJLQ
Irtot0Yfwbfo14zDb+Yd38x7QZn58QfmBQKBIeYzlxezhKUsYzkrWMkqIogm
mWwKKaOGFjroZ4RRxhhngkmm+MZ3fvCTX/xmmj/8ZYZ/bFZqmJ3soJzPbOIK
G2mjletkcJJxyrjMcaY4QTpNbOATx0jjKB9ZTyPriKGFZrZTyhhHaOAwk5RQ
Tx1r+cAhUinmPVFcYg3RXOMqKRQxykFqKWCCQi5SQyTvyCeZezzgPv1c4AUv
6aWPVyQxN/IIeZzjPPt5SwTVhPOGXLZxm7vc4TlneUo3T+jhGYnk8JV9nOYM
exkijCpCec0etnKTBG7RRSeVdPCIh+zmMVvI5gu7OEU8WQwSQgWrGSCTONqJ
5QbBLPKnhSz4//dZxQxkgA==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "0.6000000000000002`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", "4.6`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "3.000000000000006`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHlUU8cex9G2Wq2pSD36jEtdUHOoigtxe+pog9aFarRWe1QiVlwwPvWB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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXn8l1MWx58riqJV9qVoSGlRItpUol+2JAwVKcvYsg2pVLZEIQqpQdTU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            "]], PolygonBox[CompressedData["
1:eJwt1PtrzmEYx/H7njHMbA6zGWZbJoSInEqtlPxEtsWWQ0wOYQcLOeaYY04x
jS1mjSk5n9JyNufT/AcOP0uSpMXeV9fnh1fX/X2+3+/zXPd1XfeTW1ZZWJEQ
QpiBRByLIXzAZEzBOnzS+h/3TxNPYRLrzsRt+IICfVZLLIx+rx8acBbV3OtO
LEMJkpGLM5gb/V5/HMI3TEcL7ywmFqELcrAF9zEGY3EV1zAYP3j+onK2XHsT
G1GFv1ynEE9iGX5y3YlYj1X4zXVXYh2KkYQMLMXm6M+m4wLOK7dU4h58xTTt
sYY4Cwnoi0WYiagcN+AzpiKF508Qj2sdiFdwOfq6D27jDvLQzsdNxPnRf3sg
1lguGIlROIBXmICJOIdS9EAWluMuhiAfN3FLvfjD968m3sMwDMcuPMU4jMd1
3FAvfgXf+169azVYi6PRa5+NldgZvbaZqkWNahOVywoMVU479E6melCiPWRp
ZuZoZmxWumGTepSumhephxmaGev1I82K9XwfsRIDVJMjytly7YUFaMYgpGFe
9JpbrXtiPS6pN/+Dz9Zb1dpmbHb0M2Czn6i9bdXa9miz9ly1tJmzs7NdtSzQ
by9ULpbDEuWUphmoxkHlMlp72R99tm1P5dit2ozAYzxRr/OD97Zc96zHL/BS
vS7lfivxmdbWc5vVjdHPls1sGz7ie/D/iId4oO+2M9miHC03m8l3eB99Nut5
5g3xtdY2o3bWD0efbTvzHTeleRg=
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt08c7FwAYB/Bf+9bNsYNL1645d+gmaRjZhZZUNDVQpKUUmqIhKrSTQlPT
aCgtmyb9C/l4ng6f5/0ev8/zvm9wUnr4mgmBQKCFiYznaUwniBnMZBYhzCGU
aFLIIJtCyqihkVa66aGXPvoZYJAhhvnOD37yi9/8YYRRZis0l7/yZfMSb3hL
B0W8YwPVxNPHYTI5RC9xVBHLUu5wmwwKGeIglVzkAD3EcIEldLOf9dxnHY20
08Z5XvGal+yjlbWcI5pv7CWdAr4SxVkiSeIWNxlfzB4GyaecCvL4QgRnWMxn
dpNGA6u5xwueU8ZTWnjCLp6xitMs4hO5rCSHLhZyigUkcoPrrCCbAXZygpPs
4CPhHGc+H9jOcupJ5S6PecQxmnlAE9t4SAqlhNFJFsls5T3zKCGUBK5xlWVs
oZ/NHKWYTdRQSx1HuMJG/rmvqUxhMpP+/8MYpch1gQ==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "1.2000000000000002`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "3.9999999999999996`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "2.400000000000006`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHlYU1caxtG6a1yoRZpRENfUURQEFdR+aqxVixLoqK1LXIYZlzi2Iy6N
ozOOPhNxqQsNrmMRpW5FUASrTsoxqAiMLIoSFZEtbLIIkaXWaor39j30OT74
z3l+N+Ge9/22c6Lbki8C/9LawcEhoZWDw5t1xe6j9+32Roa1ZFfQGLW+nvOS
nX88YrDZOD/ZbnuVoqvhfLF7sFmZWsH5rKLVtghTCeeITnv8VDEFnEd08x2g
VT/kPN4xSmvRpLOWdIgr9IChBww9YOgBQw8YesDQ01IcRB3iCj1g6AFDDxh6
wNADhh6wV5fkcqt3XIt5EeMi6hJX6ANDHxj6wNAHhj4w9LVUJ2KexDiJusQV
+sDQB4Y+MPSBoa+luhXrRsybGCdRl7hCHxj6wNAHhj6wo8zUUl+JdS3WlZhH
MW6iTnGFXjD0gqEXDL0t9b3Yd2Ldi3Um5lWMo6hTXKEXDL1g6G1pLolzQexL
sQ/EuhPzLMZR1Cmu0AuGXnFu4nvQK84JsS/FPhDrTsyrGDdRF1hcoRc8VP4+
Z+jH96AfDP1g6AdDv9gnYh2KeRbjKOoEiyv0g6Efz6EfDP1g6AdDPxj6wdAP
hn4w9ItxFXWCxRX6VfJ7uX4w9IOhHwz9YOgHQz8Y+sHQD4Z+MPSDoRssrvBz
VN6X+wHDDxh+wPADhh8w/IDhBww/YPgBww8YfsDwAYafk7IO7gcMP2D4AcMP
GH7A8AOGHzD8gOEHDD9g+AHDDxh+YmRd3A8YfsDwA4YfMPyA4QcMP2D4AcMP
GH7A8AOGHzDyBIa/x7Ju7g8Mf2D4A8MfGP7A8AeGPzD8geEPDH9g+APDHxj+
wPC3SPbB/YHhDwx/YPgDwx8Y/sDwB4Y/MPyB4Q8Mf2D4A8MfGP6ssi/uDwx/
YPgDwx8Y/sDwB4Y/MPyB4Q8Mf2D4A8MfGP7Awu8sEn7nkPC7goR7PAn3ZvFe
Kt77xHuVeG8R7wHiuSqeU+KcF+ekOGdoqPS+G+y09LyBgQdIax1zkP5dMI2R
9qnm7C7tU86U8vfJR/r8CefB0nqPM97rKj8nPAdj9ZDfQ/0ktnIeIu/Hn38r
+arlLK91nE/Jfvi+/B7yG4v3QNEv8gidyBNYvFeI/pAnsHgui36RF+hHv4FR
n/ge/E2R/j6B/cfPqYfRUsdaSd+PpJo92atNhqesv7RfCnnJK4uU/i6bDkvx
u0M5Uv3m0zIpPqW/7VNMU9JiF9qUDfw56gX7fSx/zt9/Qn4ffz+e431bZX08
Tsfk/PH4gz+S9TNKnTBQr6jl+Rgkx4HfO8H9ZT0UJMWrkOcHf4e4g+Eb+4AR
NzEvyBc4SqqLHB43PPeS+4P3G1jOYyE1hE495218xnVgLmDflXKcOaO/oA9x
wn44T6GjUs43Z/QL4o3+xXvAiMPPsj4eb/Qz4g1GvPPkfXi9o04RLzDihThA
P/oX8QLje+Pl/PO8lMl1xOBv9b5u3fWKKv454onPEZ8ye+szGu3Vt/o9Lm/f
LMWoOtbmn63/bPON5HO7fPilBTbfW7zfd5ffTlBOT3ur3z2/WlqRUpHKdO6b
rnnHNff7uECdl/qK5a1+f/LjMV91U5x+GWG4r1yZz/u4V9j1KarG5n7/l7rj
QtuGkrf6fVDftBJrcT0t39MqzZ5nYs4DD5ZY32lgfn1ufWp7dJtc2u9bbkrK
YPOidTqLs4VCNd2qUl6m0KrMjyerFpbQ1Or2BwzT6ymgb83eiN5m1q9zb1uK
ayOb8Cx0r8F2kBUn+HlqP6ll6vSKX6IjQmi1OVypvVjN9iqtK0ztGK3eFTtO
3bGIzZ377KBh1A2ae4VGqQKesKXXGzsa85IpvTRPb9qRzSZoNh8xJN4lr4R/
WK3eB9jpNep4zaosWlP9Zp8Q6traa78h8T6RrIMmFh2vjzY/JreJ8bfseXl0
6stvsq3v5VHZ/HvDtFlFtErel8r2mTvrNz2jWClvVsrue9apZ1O9NLzIuqBZ
VEy+7yW2jTn2nH5avHSiyqGMzyvjrQXj1D7X+fz3zBoyTDuyed4H7XhTL5v5
737U/9iqd8M1r5+x4zOuzVcMPM/7cVLokE4xbmZ+jmPebFiUpdA3xSNa+n4m
77urF/oN0P+uf9EvPScEZNrtZ2nZgsVZ9t+dB4WbTF31abm8L9Avrh6LzuhC
CinDsXquYlgB7+/vz+X/3fJlEb9/ou+6jr6Zb4+upVqpnkv5edGus8u3urLL
7OehrmlK93qWWZjmb1PGsK5Hp81RjH/OLn6h3xnhFcfm9yu6mNkUn0QtS1Km
nqbebU9m2jOesqE+gYstmVHkUrXgE8WrcvaT1a3UGh9PSVOjDBGVJSxuw+Ah
6u1plCSvzDy9zTqL8x3Kdfx3G2Pj/9jznQ4T1YcyaXW74CTvP5nZmj0D1puc
HlBqiG6+YlYm5cyK7an/2yNam2weqX7/AU29lPYyuik+Ey7OM3uPukcd7OZ5
ivh8Gvd++nrTpVKKHqobqK/PJ18Pp1fR28vo6ke+fqq8Agq9f8usPFxByVJd
ltBd1/oE79B62uj+2QpLXCm9flVbZN3aSE7+2f6KtaW0UOqbRn7eHY+8HF7R
VD+JHt7+quHX+P3oQcc1gbbDP7KMGevOawY1sFXS3NxDmKfGYaeVesUBSs7M
DtMdrGJaqX/CKcQjNVKTWMmOnHaaqhrdfF9CPznrnLcZmnjzocupyh1JVCTH
gZk+jbxjp1R+n5oZd2iXwfP/NDo3YbPp5F02W99jtNonm9+nWLduqcqn2VTZ
6U2ekyl1tlMX/Yw8XhfdwmbXRJvzKHTG0VhNtZWqPzgXGtE3nzIrz5zQ3Sim
SVKcm+9X6Le/1gVvGdfEG4a3WWJLtVKcXpFnP2WjTi7shO5yMb9/ua/bGKio
L6bcOZ3axByqI//tfT5T3ExkXT9cVmS908hKXrh4adXH+HnvKM2JU2xvWWyw
ZZmNeY+9E6i4+R0LaRU2QjvZxvbN9I/WaLexDSr/cMPhGlZyrcpFqzbx8/92
jz4KY68f6PnK/cd1i0pYatH6I7plV5vm4Wvm/YuVtZL8MuowtuG07kYhO9/v
64HarclUvHWOIaK3hW3pbWgX45HFz+XaumEdYibepXYLpbpnu6U43SPs0+ip
Oqib+pj3ZfDh3onKFTl8TX8aEOd9MId2jDKm21/mkPmAz0NrWC4Fpd3vGBNQ
QD7mkcGW84X8fjDr+xcjtJ0LaemF3O80gyrJ2PZmP/3aQhrXa12IYUcVmXIW
fR3Rt4gCizaFaxKfUXLAlTHqacXk6R6Z6L3xOQ3abnnHOCeq+f8xo+N7GXtd
oGBpLpfx83voS6/B2m9K2bI/2INsyov8vjEp7L+TVcMv8fMT9414qU7jWHc3
jyfWm4/4OVYgnRMFVDx344eqU+V8Trn3Jzft86e0rbL+ZcrOAn4fuXGk/AdN
dfPvf8yXyvoo1xdN88U5Y8NM26MMck7Z/9DObrLPt7iUW8Oa7ssjV1Va42N5
/78O8nI0Ns3HfFPdJJVrKXUc1f4D7c4G6lLz5lz5itU0LF5vCaxhF7oc3RPx
2Ey3pLlTwNYmLZ+sqMqljSPOf64oKKBpfuPfNYYXUXL56OW2SzX0KxxcrM8=

      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxVmHn8V1Max+8tW1qoKO3a90W0qNCoRJuEVIqmyFiTbIWUsqSGFtWElgkl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            "]], PolygonBox[CompressedData["
1:eJwt09lLEFEUx/F7zCyz1KxIWjGsDAUhCILQKEpsM8pUpAdLKSxDU7SVVor2
ok3Lpd02KsLqqeWl/6eIIqKo/B7O7+HDb2bunZk759wpau7Y3J6RUqpEJi5Y
ShcxFT8530LexWzMwT70oJWxMeQO3NPYIpzDeUzBD+acIE+iAF85X0euQIbm
7MYISlGGvejALOb+x3OOt+IPx+PJdlRajOWQTXiPcizg2lqyAv9SvPMmavTu
v+jmeKXF2idhO15gIUpwB7Vau5HXcQPTtIb7ZL1qk0k24wMWo4prB8kDuMRx
FlmHnRZz52IDqpGtZx7DUXxh/gTyCNZYHOejDZ+wFJ+Zs4rcj1yMVS9eq/be
kwrVKEc1qCIPIQ/j0IdbmK4a95IbUahrZ3DW4tu/M36KPG1ejJS+pVjrcUzW
mqu15nx901Vcs+jV7xS97latveeXcUVr+cX4bfXQe1eob1ttUTv/xgEMYgaW
MaeV/Igl6Of8mWrktZlPDqkn3ouZ5LDFPT53HvkET1GMdymetUtr8Weut6ix
19b/gcdotHi23/MADRbPKrL4N+rUW/9HHuKRxnwP9JObLNbi3/AWb/Ru3/Nd
FnvQ995EHLb4J8rUM99bLeqF77Hl6NRc78krvFRtfA/7v7BNvSrX3tmjXvge
GgWaEGQF
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0klXDQAAhuGbIuyc1hZWrdtTxi6S4TaouIYbUmkkQ6aSoUipqBRJlIhu
GRLSyi/wC0TI1D9wjueeY/Gc8y2/xbsiUhEqjwsEAlEWENtLSWI5yaSwkiAh
whRTQz0t9DLMBB/4yCdm+MwXZvnKN74zxw9+8ovf/GGeZY7spo5znKeMt2zi
LBvJ5CYd7OIJQdpp4wYFHGGaUh6TzxDDPOIVZ3jBS55TwmlqSaeVFq6TRzHv
OcwgOxngIQ8Y5ySnKOINGzjBerbQzDVyuc86JjlEDvfIpp+DjFHDcQ7wmrUc
Yw0ZXKWJLPpYTSNXuEyIQqaIcJcd9HCHXqIc5RmjPGU/1VSRxiUu0sB29vGO
vdxmG51008UIFVSyhwlSiQW4is1coJ6t3CLMXz0sYTGJLGIhCcT/7/YfVYpY
pw==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "1.2000000000000002`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "3.9999999999999996`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "1.200000000000006`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtYlFUex8HKx7ARxXRpymyRdNYbWI4apT+NAhdBRg1bNUdzsUDUNs3c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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxVmHn8l1MWx59LJLJUyt4mQnsokhYloVTSohChmChZs48lxpKIbC0qSijr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            "]], PolygonBox[CompressedData["
1:eJwt01lLlVEUxvF3R5cZJkVlx8wmlAbiVBTHQxhaaGLCgboqtCSHJivSY2lh
5dQADRipOJWWkiYNNmOZlkahXdVt38DP4H+xn4sf+5x3WHvttdabdrwydnZB
EAR7sBCvXBBUYglWoRflyEA6RnEOu7ELFejHJmzGDcygAAd17yS26JkTOIpk
rEc1fiAbOehEF1KxFIO4j8XYimc4hQSswF9cRSJiiKMGy7EPrXios9gzRzCg
WCvxHEPYhrzA53pZsS3nR2hDSDUZx1fMWc1YP+MilinnMXxx/t5/nvnAegFR
RHAX97S3neEbqrAXWXiBYRwOfE4vcQUl/N/B+hhP1ItFXLvE+lS1349u9GCj
cqrDNHJxQLV8oNpbTX/hN7Zrz++sDShUTiM44/zeYZRZLlijPe6o59brdbiG
fziEUeI1KQfbOw3vUY9852foD2ZVK5uZn2hWL/I0G3H10makz/kz21kzdLZa
55/NVe5Tzs+SncFmrVF728wVowVrkYI3aEcSdup3BzboWqneSdE1e/cYVivG
adUorBoW4bVihdQ7m9GYeniL9SbaAh/jk2pmtYqqNh+RqRpZrW+rtlbzCUw6
Pys2g29Z3zn/LVrM887PXEQxrBfXnf+WrCfztThn5g==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk2FgAABeDfPLZ2LC08QA/QC1i26RykzFQyVCRDoiJjGgiFShQapcic
lCRCrL2BNyjff2rxnXNXd3NvUlbx8fMhgUBgnFCC+QiJJHOUY6RwghxKqaWF
HkaYZJkt9jngD38D/0pDCCWMcCKIJIpoYogljngSyOE3l6lghXK+cp0vXGKJ
ZT6zxQKLzDLPHL9oY4NNftJAKy1kk88A/Vxkhiwe8ZA+LlDPHtf4RBlTlDJN
HR8p4T0fmGSdWzRzlR0yaeI0efTSwwTvOMUDuumimLdkcJ973CU4Yi271PCG
Il5xjtf8YI1xXvKCMUb5TiOrVPGNam5yg5PkcodOnjNCOrfpoJ2zDJPGNlc4
wxCFPKOSpxQwyBMekxrc3l3iiCWGaKKIJIJwwv5/9RAI+Fhl
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "1.8000000000000003`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "3.3999999999999995`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.600000000000006`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mGto1mUYhzcRTHNpfihYZXgoV46oUFBRJmlqS3MZfQmbIVPMrQwtST+E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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNl3n8l1MWx59rKcIvqShJJbRZSqkoSiVpVRImQtnGUiRLDGMZDWOIKG1k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            "]], PolygonBox[CompressedData["
1:eJwt1OVyk2EQhuFvGU6EAwBKCy1QCgxWWoIVdyhuDe7u7u7u7u5OcXd3OAfu
nX1+XDPv5Es2eXefTbnidFFJmSRJUiiLk5Ykp9AFVXEaZ9AV1XAZV9ADebiK
a+iJmjiKY+iEbFzHDfRCLZzFOXRDdZzHBRQjFxdxCd1RAwswFnXQEodxBB1R
BZuxRc/KYz8OoD2ysBf70A6Z2IptaIUK2I09aItK2I4daI2KOIhD6IDK2Ild
aIMMHMcJdEYOFmIc6uo7/qoHfvfReG/RY+/tEEzHO51TWI85aK4eTMMbDEYj
rMNsNFPP3uo35Og9HzUzn9VQzMAHnRvjtWbksxmEKXiBNAowFa/0rBCfNTOf
1TBsxDy00MzXYhaaaqbLVbNAPVuhmoWa2Urdye/iGVmGyWiomW3AXBRZZGwp
JiFfM1yMCaivGazBTDSxyOhq3dnv6hlegolooBmvUs9TmtkmzEdti4x6rU+6
q9f8bZFxz/Yo1XqEAar52CJjmXqt1CJDnp2+eGqRSc/iQNyxyKBnr49Ftm/r
7Bkfj3voh3q4b5G5DL3m2bqr2p6xhxYZ9uz2V28e6Ow98iz9wEiLTC3Sd3ht
z/gtix3y3emNnxY7nqfPvLTYOd+1tGbzS73wGX232Fnf1RH4h5uqNcYiq9/0
zDPrWfmC4RaZ8dk+UW98xs8tds53rcQiG8909ox8tfjPyFUNz+Ifi93yTP4H
rImcPw==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk3FAAAx/EpJSLTX0ATUvH6D3pP905duzl2yJlQaRtlacGkTYUZRVqn
FW2TNi0aIlqnovXQf+Dj6fB573f6nb6hsvJNWxcEAoEYC5nby8ljHevZyGa2
UEGYCFHiJEiS4l9g/iRILnmsIMRK8imgkFUUsZo1rKWYEkpp4DRDPOIPv6mn
nQQP+cVPDnCKB9znBzPs5yT3uMs036njBIMM8I2vhDlOP3dI8YV9HOM2t/jM
J/bSxk1u8JEP7OEo14nznil2E+EaV5nkHbto5QqXmWCcWlq4xEXeMsZOmunj
AqMk2cEReunhDSNs5zDnOcdrXlHDIbqJ8ZIXVHOQKF0M85wqmuikg2c8ZRuN
nOUMT3jMXyrZQFAeOSwjmyyWkkkGS0hnMYtI+9/lLA5TX3U=
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "2.4000000000000004`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "2.7999999999999994`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "5.995204332975845`*^-15"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtU1NUWx9GMZdqYcrtog6mQ2SzzAcUQWbq1UUMzmbC4XtSJWlrWeL0+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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXf819Mexz/nR1ZZlVBIJImipGRlNJCZVVYoSqmMFCorRVlde9yujMi8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            "]], PolygonBox[CompressedData["
1:eJwt0+1rzlEcx/HfuRqyMLJ/YI/9AXMvG2mGcRkSW8NoazOSpJQotQdjGnJ/
L+ammdEw98y9EGWeeOCBZMxabuYmw/vT+Tx49b3O+f1+5zrnfL/fnMUr0jWp
JEnykIGbIUmGMrGJmIfj+IgyLMJWDOD5KmID7zcQBzJeTWxhfIr4ELMxHo3o
xhKU4wqG8P564lj04DQmYDquI4vnGz23Gf0ZrySOZv3LxMGM1xFH4RDeYQEW
4gjuYRZG4j2O+t2puINhfF9LnIzfOO/fM332G8RPSbyDHchkbg3xF3PtxLso
QC7a9K7vZgPP9xLrUYg0dmIQ368lDscB7PJ/zcE+bPPZdWf67++o9B7uEx9g
GsZhP7ZjBop153jitSZhD7b4rLqDOrzGfGSz3gXiQczFFDzFM4xBKc9fEF9i
Ip4zfkR8jCLk4xU6/O0Ir7Ub87zmsRDvIO01lZvDKHGOzvgMxf6PZvxEFarR
hG+o8B38w1/nvsRnaUWNz5TibkMq1t5Sxp14E2JtleIzukKs1TLn5oOfKUe3
vIdqn/EHep3rCu/tHJZ7j7r7L1jmHHzF2xB7RXOq9ZMh7kU1fzXEHih3Dvux
14xUrAWtqVq+5LtXTavWVcOqXdX8nxBrLtdnVu+o5lRr6iH1yjXnSj2jWmtx
Lajm1JvqSfWielS9e8K1pB5WbZ91blXjF9EXYi+pxtUrt51r9cx/xm2GEg==

            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0llXTWEcwOFzmudTnO65c2Eqw40v4KYbN7qzVh8gvkLXCpWhCUlKxpwo
KkPmTKUiUxkSISUijgxPqy6e9fuv9333XnuvvZcWbN1UGAwEAp3EMDdns4wN
5LGFbRRRRh0RuuhlmHGiJLpBmCUsZwUrWcVqcshlDWtZx3o2spkKDtDCb87y
mEd0keUhr+oIb4gQZR/7ucsZ0pzbqwPEmeP5ZW7mJ6e5Qqr1PXqHbk6RYm23
9hNr/qEzTHOS71wi095lfc0rvvGVcmo4zhQn6OMhnYRcd1FfMswxvlBGNbdp
Itm5Uu0laI5h0nyUCRrpIMn6Lr3FTRpItLZTe4LzH3ZcP/ORI3ziAhn22nWI
F3xgjB1UcZj31POA+7SR7rrz+pxn1PGOEiq5wSESnCvWe/zlH6PU8paD/KGV
JzzlOteY5RyDbCfsVfJ1sS4ii0xCZJBOGqmkkEzS3D9JAvHEEbvwr/8Hnppq
LQ==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "2.4000000000000004`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "2.7999999999999994`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          "1.199999999999994`"}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtU1NUWx9GMZdqYcrtog6mQ2SzzAcUQWbq1UUMzmbC4XtSJWlrWeL0+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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXf819Mexz/nR1ZZlVBIJImipGRlNJCZVVYoSqmMFCorRVlde9yujMi8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            "]], PolygonBox[CompressedData["
1:eJwt0+1rzlEcx/HfuRqyMLJ/YI/9AXMvG2mGcRkSW8NoazOSpJQotQdjGnJ/
L+ammdEw98y9EGWeeOCBZMxabuYmw/vT+Tx49b3O+f1+5zrnfL/fnMUr0jWp
JEnykIGbIUmGMrGJmIfj+IgyLMJWDOD5KmID7zcQBzJeTWxhfIr4ELMxHo3o
xhKU4wqG8P564lj04DQmYDquI4vnGz23Gf0ZrySOZv3LxMGM1xFH4RDeYQEW
4gjuYRZG4j2O+t2puINhfF9LnIzfOO/fM332G8RPSbyDHchkbg3xF3PtxLso
QC7a9K7vZgPP9xLrUYg0dmIQ368lDscB7PJ/zcE+bPPZdWf67++o9B7uEx9g
GsZhP7ZjBop153jitSZhD7b4rLqDOrzGfGSz3gXiQczFFDzFM4xBKc9fEF9i
Ip4zfkR8jCLk4xU6/O0Ir7Ub87zmsRDvIO01lZvDKHGOzvgMxf6PZvxEFarR
hG+o8B38w1/nvsRnaUWNz5TibkMq1t5Sxp14E2JtleIzukKs1TLn5oOfKUe3
vIdqn/EHep3rCu/tHJZ7j7r7L1jmHHzF2xB7RXOq9ZMh7kU1fzXEHih3Dvux
14xUrAWtqVq+5LtXTavWVcOqXdX8nxBrLtdnVu+o5lRr6iH1yjXnSj2jWmtx
Lajm1JvqSfWielS9e8K1pB5WbZ91blXjF9EXYi+pxtUrt51r9cx/xm2GEg==

            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0llXTWEcwOFzmudTnO65c2Eqw40v4KYbN7qzVh8gvkLXCpWhCUlKxpwo
KkPmTKUiUxkSISUijgxPqy6e9fuv9333XnuvvZcWbN1UGAwEAp3EMDdns4wN
5LGFbRRRRh0RuuhlmHGiJLpBmCUsZwUrWcVqcshlDWtZx3o2spkKDtDCb87y
mEd0keUhr+oIb4gQZR/7ucsZ0pzbqwPEmeP5ZW7mJ6e5Qqr1PXqHbk6RYm23
9hNr/qEzTHOS71wi095lfc0rvvGVcmo4zhQn6OMhnYRcd1FfMswxvlBGNbdp
Itm5Uu0laI5h0nyUCRrpIMn6Lr3FTRpItLZTe4LzH3ZcP/ORI3ziAhn22nWI
F3xgjB1UcZj31POA+7SR7rrz+pxn1PGOEiq5wSESnCvWe/zlH6PU8paD/KGV
JzzlOteY5RyDbCfsVfJ1sS4ii0xCZJBOGqmkkEzS3D9JAvHEEbvwr/8Hnppq
LQ==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {-1., 1.}, {1., -1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{1., 1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "2.4000000000000004`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          "2.7999999999999994`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          "1.199999999999994`"}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.475512410103286*^9, 3.475513026084838*^9, {3.475513116888154*^9, 
   3.475513140298944*^9}, 3.475513214730487*^9, 3.475513319379352*^9, 
   3.475513407539993*^9, 3.475513486985782*^9, {3.475513540120868*^9, 
   3.47551364015868*^9}, {3.475513692303374*^9, 3.475513700643968*^9}, {
   3.475513810900306*^9, 3.475513821927451*^9}, 3.475513855562814*^9, {
   3.475513902631835*^9, 3.475513926968819*^9}, {3.475514532009151*^9, 
   3.475514561109425*^9}, 3.475514595274813*^9, {3.475514669936828*^9, 
   3.475514686625019*^9}, 3.475514737045718*^9, 3.475514946674297*^9, 
   3.4755150352938*^9, 3.475515132370029*^9, 3.475515304482757*^9, {
   3.475515468052548*^9, 3.475515512443143*^9}, {3.475515553897341*^9, 
   3.475515574899493*^9}, {3.475515632987642*^9, 3.475515681275096*^9}, 
   3.47551571582815*^9, 3.475515749565559*^9, {3.475515816404495*^9, 
   3.475515852203864*^9}, 3.475515903134798*^9, 3.475516048846046*^9, 
   3.475516113551708*^9, 3.475516179248454*^9, 3.475516247302876*^9, 
   3.475745470838958*^9, 3.475747747854645*^9, 3.475747781963418*^9, 
   3.475748560395823*^9, 3.475849913257377*^9, 3.475849975244875*^9, 
   3.475933210897724*^9, 3.475933268821764*^9, 3.475933339278514*^9, 
   3.475933369391196*^9, 3.475933473057797*^9, {3.475933664741933*^9, 
   3.475933675513819*^9}, 3.475933711253465*^9, {3.475933846579833*^9, 
   3.475933875272395*^9}, {3.47593391981946*^9, 3.475933928233936*^9}}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.475514667093384*^9, 3.475514669472936*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.475513074838314*^9, 3.475513105446588*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["XOR dataset", "Subsection",
 CellChangeTimes->{{3.475746862542107*^9, 3.475746871499506*^9}, {
  3.47574784649638*^9, 3.475747847922993*^9}, {3.475748711381857*^9, 
  3.475748726896686*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"dataXOR", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "XOR", " ", "*)"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475501593815835*^9, 3.475501687474803*^9}, {
   3.475505162283058*^9, 3.475505173395196*^9}, {3.475505403960305*^9, 
   3.475505411837414*^9}, 3.475509606611276*^9, {3.475514830097188*^9, 
   3.475514896464199*^9}, 3.475515026785462*^9, {3.47551610746383*^9, 
   3.475516107734338*^9}, 3.475516209669685*^9, {3.475745122132626*^9, 
   3.475745203103704*^9}, {3.475746516548525*^9, 3.475746516694583*^9}, {
   3.475747861964593*^9, 3.47574792411769*^9}, {3.475747956155514*^9, 
   3.475747971421078*^9}, 3.475748109805069*^9, {3.475748580089679*^9, 
   3.475748582893721*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"dataLists", "[", "dataXOR", "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", "Large", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.475503238168935*^9, 3.475503300937775*^9}, {
  3.475512123833643*^9, 3.47551214999443*^9}, {3.475512326845075*^9, 
  3.475512328449447*^9}, {3.47574789052221*^9, 3.475747890778593*^9}, {
  3.475748566959162*^9, 3.475748570948076*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointSize[Large], PointBox[{{-1., -1.}, {1., 1.}}]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
    PointBox[{{-1., 1.}, {1., -1.}}]}},
  AspectRatio->1,
  Axes->True,
  ImageSize->{204., Automatic},
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{{3.475503252727648*^9, 3.475503267985722*^9}, 
   3.475503301900576*^9, 3.475505177803545*^9, 3.47550541555852*^9, {
   3.475509593812786*^9, 3.475509609555326*^9}, 3.475512150786878*^9, 
   3.475512329463365*^9, 3.475514900457445*^9, 3.475515029512887*^9, {
   3.475747887216535*^9, 3.475747914965781*^9}, 3.47574797380527*^9, 
   3.475748113200636*^9, {3.475748571787848*^9, 3.475748584904093*^9}, 
   3.475748649372296*^9, 3.475850131251267*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"showClassification", "[", 
    RowBox[{"#", ",", "dataXOR"}], "]"}], "&"}], "/@", 
  RowBox[{"learn", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", 
      RowBox[{"-", "100"}]}], "}"}], ",", "dataXOR"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.475748037233324*^9, 3.475748052753374*^9}, {
  3.475850198230653*^9, 3.475850212664764*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1l3t0jHcaxwWrboNVS8w61K7VOTSCJuqS9KFDXYIODWmD6DppNzIihJNj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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXv819Mdx8+JKVKREKpfF0krpUiF/CohKqFUmKExjGlk7kkqpRByK8k1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            "]], PolygonBox[CompressedData["
1:eJwtlFdPlUEURefgFRER4XJVLC/+FsQOKrYgVuwN7D6o2BtW7L13RYnxVxhj
jDHGGGOMIcYYY+99nZz9sO7ZX5uZM3vP7VffWNOQl1KqhAxMtJTWwmd0AXUy
rIevXBdRJ8E6+MJ1IbUFBkKO67dQgV4J79CUdIufSsiiX8M49Ap4hf4LO9G7
4E2Kd8ail8NL9B84gp4A+dARxsAyaOfZbxiBXghP0N9gJHoRPEV/h+HoRnic
oodh6PnwAP0JqtEN8ChFTzXoxfAM/QOGoufBffRHGIKeC/fQH1KsbY3FWL7G
0bAUXnD9C0ahl8Bz9E8YhJ4Nd1Ls0WD0HLiLfg/b0Tss9qoUxqNXW8yVR62H
TRZry1LroMlibRnqAYtv/F3T2g9r77yHfdRaC3P+pejlIHRQT+eoU6EEumkv
z0Op9vSQ5szomxPKhGehMyyA49IPU/S6V3N5z773R6GTPDhmkbkC3XMvz2pu
9/QMdQoUQ1d5eVraPb2gPclqje7lSegiT08pw0W6dxNmQV/oo6zdkPbMufcX
oUwZmEndZpHF3tqbjRbZKtFYzRZZ9jHboL+Fd55x93a/vHCPp1O3WGSjB/U2
DPD5UpwB73WDRZaL5dUqi2y4Z9Ngs0WWctTdsMfi7PkYVyzm8LG7wyV9k1NP
nsXLeuaZ9KxehZ4WmW216Nl77QUzYKvFWSu3OHvX9czP4DW9U64xqpQB997/
Q/4DOaqH3g==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl0llXDAAYBuCZ/8AP6C7/gQunkNBGslWMmRYtU1JNpGilVfuG9s1W0VBa
FJKf5Znj4jnve/me831JoWhOZTAQCEyRoiT6SU5xhmwiNNDLLHG+8o0ttvnO
Drvssc8PDjjkJ7/4zRF/OOYvm8zQQ4wwWZwmmbNGnZA35AUGeMwr+olznk0a
6KOXL5zjMzF66GaDVNapJ48uilnjE3Vc5yVFfOQDteTyggjveccjrtFJmFVW
qOEqHdxnmSUekkM7IRZZoJps2rjHPHNUkUUrd5llhiiZtFDING9JHDWD5xTw
htdUcIVn5DPFJOVcppk7TDBOGZdo4jZjjPKAdJ5yixGGKeUijdxkiEFKSONJ
8P+f/QMNWFA7
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", "3"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", "1"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "100"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1VgtQVGUUxnybV8gE8VYihrkoFMywhpadcvORgqxmZjqugKjEFjS+pqWX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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwBxgI5/SFib1JiAgAAAOcAAAADAAAAYF8+BwIDQAIGa2pCCwUGaQUKDAYH
RQgPEAgJEgoLEQkKEwsMbA4Wbm1HFw4PLCAhGA8QGhESGxITIhcYShQeIBUW
HxQVJBkaLSEiJRobcXBMbx0oKR0eKh4fKx8gGRARLiIjTUodCxMSTyYzMCQl
NCYnNigpNScoNykqOCorOSssOy0uOiwtPC4vPz4CPS8wQ0AFAgcGREIIamkJ
BQsKBgwLSEUOCBAPCREQChIRIRYXSUcUbWwVDhcWDxgXEBkYERoZEhsaLyMk
IxgZFB8eFiEgGCMiFyIhGSQjTkwmGiUkcG8nHSkoHiopICwrHysqIS0sIy8u
Ii4tJDAvUU8yJjQzJzU0KDY1KTc2Kjg3Kzk4LDo5LTs6QUMFLz08Aj4DVj8C
WlJABUAGckEFCEIJV0QIW2RTW1NFSFtFFEcVdEYORkgOXFRKWEkUHUoedksd
JkwnWU4mS00dXVVPfHtnMk8ze1EyQFICRVMISlQUT1UmUlYCU1cIVFgUVVkm
Q1pAFSAfTVxKUV1PPl8DX2ABYmA+YGEBWmNSDkUPLjw7XGVUvL1hb3YdxYdR
XWZVZ3sydHVGdXQNbHQOaXIFcnNBe3xQoI9BzM1kxp1iyMlj3oNJm8RQwYJI
v39D0NFlpJNG3IBEd3YceW0NdndLcngEeXRsamsEfGhQeHJpFWwWJ28oenZv
R20VbW4NCWkKQmoJeGoEbXlsdnoccHpvdHkNanhpc3IETHAnenAccHEcubpe
1NVm4IZOlt5JvpBBhIsc1q9ZjKsxgYoNfokEx55SiLgBy6JTfbA/wJRGxJxQ
gLJEwphLlaVHkaFCg7RJmalMj75BhrZOk8BGw4VN0q5YyqxWiqMNi6cc2JtQ
2n0/l8JLmuBOqJdLktxEaHxnUXtQ06pVaGcxzq1Xjto/z6ZUiZ8E19lonQHN
cg==
            "]], 
           PolygonBox[{{182, 153, 76, 78}, {175, 154, 78, 89}, {165, 221, 110,
             71}, {172, 142, 63, 86}, {180, 149, 71, 73}, {161, 219, 107, 
            66}, {157, 187, 96, 98}, {176, 141, 62, 63}, {169, 223, 113, 
            76}, {178, 145, 66, 68}, {174, 150, 73, 88}, {173, 146, 68, 87}, {
            133, 181, 92, 77}, {159, 225, 115, 4}, {171, 215, 104, 49}, {163, 
            226, 117, 13}, {144, 191, 67, 65}, {217, 216, 80, 104}, {148, 193,
             72, 70}, {167, 227, 119, 28}, {141, 198, 98, 62}, {135, 183, 93, 
            81}, {130, 179, 91, 72}, {127, 177, 90, 67}, {187, 188, 97, 96}, {
            189, 136, 1, 97}, {186, 140, 49, 94}, {170, 214, 89, 85}, {183, 
            212, 102, 93}, {213, 211, 85, 102}, {219, 126, 4, 107}, {177, 200,
             99, 90}, {158, 202, 86, 82}, {162, 206, 87, 83}, {179, 204, 100, 
            91}, {205, 203, 83, 100}, {201, 199, 82, 99}, {226, 164, 70, 
            117}, {152, 195, 77, 75}, {209, 207, 84, 101}, {225, 160, 65, 
            115}, {223, 132, 28, 113}, {221, 129, 13, 110}, {166, 210, 88, 
            84}, {181, 208, 101, 92}, {156, 197, 81, 80}, {227, 168, 75, 
            119}}]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], 
        LineBox[{95, 1, 184, 136, 189, 188, 187, 157, 198, 141, 176, 125, 218,
          142, 172, 202, 158, 199, 201, 200, 177, 127, 191, 144, 190, 143, 
         160, 225, 159, 137, 126, 219, 161, 145, 178, 128, 220, 146, 173, 206,
          162, 203, 205, 204, 179, 130, 193, 148, 192, 147, 164, 226, 163, 
         138, 129, 221, 165, 149, 180, 131, 222, 150, 174, 210, 166, 207, 209,
          208, 181, 133, 195, 152, 194, 151, 168, 227, 167, 139, 132, 223, 
         169, 153, 182, 134, 224, 154, 175, 214, 170, 211, 213, 212, 183, 135,
          197, 156, 196, 155, 216, 217, 215, 171, 140, 186, 185, 94, 49, 103, 
         50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 48, 37, 27, 19, 12, 
         7, 3, 95}]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", "11.6517`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "6.488300000000002`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "9.670299999999997`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1V3lUU1caR6nWcoiIg9tzaUUFpHYZNW5VP2xKdTyMTam06rSBOuAWl4pU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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHmYzlUUx89NCmlkiAwyk+wzZGeIKEVKCCEKWWIYorSn0k6K9n3TnlSU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            "]], PolygonBox[CompressedData["
1:eJwtk/tPzmEYh587FTo5hWStNTOHUOTUSETOx5zLsej0QyFyGtMYY6zGWMZq
Nawsjb8tfnd99nm399p7ve/3+T6H+/48Fa29TT1ZKaUGyIaySGknPMZ7YBde
B3zSI6hAGmAAvwWleDf8xltgNl4dftYBOfhpGNaz5Hf3wLPkOZrxi1CIP4fA
N4TXvgkr8H3wAr8NlfhRGMLvQSt+Hcrx17AZXw138fuwCj8Ib/A+WIMfhnfJ
Y9bjx+ED3g8n8FnwCf8IJ8N70l703xk8G9rxz3AOPxs+m850Bb8Mi/GXyWOr
oDf5ne34uvBaD5NrkxueSzVaie+HV/gd2IqvDZ/1AezG6+EJ/hTKw//JtUYT
fkpnSB7TiZfAL3wK5uM14Vp0QyG+KbxWl3qG/+W7Fn7CMX4vg2n8PRzBl4Sf
DUIbvhC+49/gKj4PxvExuBFeU2tpTLtqA5P4BBzCF8EP/C0sCM+puSrhEp4H
nfioMoHPZJ7pnWvhM2jvWrMFLwiPHUnu/YFwNpQBZXU5/EnObFF4z9qrMqSs
7Q1nUZnTXdgRzr7uRH54Dc2tHnfh/3SO5Bqd5/dc+Ip/gaxwppQl9eRC+I7o
bmjMnPA7Gqs7oL3VhrOhPSrrqrlqrcwrG43hbCkjyrJqqNop0+r1tnBW1PPi
cM0nMj1V7beE74Z6sDSckanMGXQX1HP1WndCtd8YvnvqwX/HtmFL
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0ltbTFEAx+GZjCGi06CoUUpqonSgKYcGpSGUiHSYmabQQSXu+kIu3ftO
UShF6N0PF+9ev5v/xdrPqs2vjCyHQ6HQB9YIusfnh3OdG/om17hONYtU0UKY
YQ4wRAE7dp95rEfoJcVZ3hCnlQhPifKEg+zafWFUP+MWt6lliRouc4gxCnnO
YX7abfBCj3OHPuoILnmONo4wSRETHOWX3SZTOkM/dznPCvW0c4wcxWQ5zp7d
V6Z1ngHSXOAtDXRQwixlzFDKb7tvvNTl3OM+TazSSCdXOMErYvyx+c5rfZJB
HtDMOxJcpYsK5jjFX5st5nUlD3nEJd5zkSTdnGGB0+F/D2PbMcFHJoN/RYYs
ueD+5JlhlvHgDZAmRZI2EtQTp5IYJRRRSJQInyj4/y73ARbLN54=
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "0.6980603700000005`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.8597936300000002`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.43460383000000014`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mH1ck1Ubx8EyrZwvRBRgQmo6rQyLpaJ40ini+7RUUlxJ4oNOH833qamV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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXn8l1MWx5+rFMKEUkklTWmxRErRQqRNoixjj2zZ1xDZyjJZk31E9iXZ
Kkv2fd+pRmMfM5hhzL6bOe/O+3l9++P8zt3v+dx77jmf5/vrfNCx445Zqaqq
6fGnSegfQ/4b8n7IOqWq1g75IMprhjQPWSVk42hranmVKH8UemnIkpCVQ1qE
bBrtm4T8L8prhDRz/uqOod4hZG32CemobhWyTck16noL5w2K9oEhnULWdV3s
+lXIT0LahWwbfUNCOof8MuqrhqwVsr6a/QaXLLcPae3arNXJ/WjbLMZ0Cb15
yLpRbh3yaZR7ajf2dg1p677d1OuFbKRm/VYlx/w0pId2ML+7/dS3sk7/Bu4P
vrYxt03I59gRundICdlYWxm7RZV2sn4fNXZtqcauXtrLnH7ax3597afe3/3B
N0DNvK3V7Lll7N0npEnIeiHtQr6M9h3cmz23iLbNQg/hLqos9w4ZZj97DvVc
sX07+6lvbxtr7ehY7O0baw4KvXPICM8Le9eP9vYhX0V5lHZj71bR1i9k5ZBJ
Ud89ZI+Q4a7H/LFVrjk4ZBc1Nu+6gu3j1Ng4Xj3U9bYX9xqxx7ehvw7ZU5zY
/jM1e+6lHqEdOzhun5CR2r63/dR3cx/2+G3I6JD9wRx7jQk9AZxRHhDSIeTA
Kts5n4PU4DvctbB3om1gPUSc4DvYNuqHiZM5h9o/Xpv6e75HiAGsd4ZcETIr
5Cgxg/WkkAO08xixgfWbkH1DjgNb2D00pGvI0c5j3IliZf52JcsnhJzl3keG
nK1mz1PEDL5T1WCaXOW50DdFzGA6XQ3WM9Sc08nay5wzq/Qb9ptqP/XTXJu1
znF/bL/cdVlvesixYrxIO7Dx/JDjxXKBGqwXqjmz85zHuBnaxPyf20/9avc+
VznaM75U+8B6mRqbLvFc6JupjVO9t6linaXmjC/WXuZc5Vmz35X2U782ZJpY
r1Nj+/VqsN4gTvD9wjbqt2gT9s62H3w3qsF9q/3gmOM5YtdN9lO/2TbWus2x
3MO9Iddo4x1iBuvdYgDTXWKmfo9tnCs+hV/jx7e7HvPnuR5Y71OD9X41+B5Q
g/tBNfjmiw3bF7kudi0UGzgeVnM2j6g5gwXOY9xj4mT+o/ZTf8h92ONx1+Zd
PilOcD9hG/WnbAP3MyFzPbOXtJv1nrUN3M+LGazP2Ub9RTEz5wX7H3Dtp9x/
rns8HfKqeMD9mhrc72of498QP/jeVIP7LTXn97rzGPeOmJn/tv3UO5nfyf3w
BfgEeX9xlVwG/rG23AQe8mGVfAf+A5eBx6zmOLhBC8etYf097QXnx1XyjJZV
8ps1HQf3gSc1dz68Aj5Tc4WujiPPt7af/EyehrswDk4Dl4GvwCdqHgNv+KxK
3tO2avCnmk91cBzrkbd7aXe9D1ymlfymrbbAG76okuNsWDV4TDf3626ddXtY
Z70NVrCbfWp+1NNxv66Sv2xaJZcp8gO4DByrd9XgLjWXQW9eNbhI/6rBafpo
U1/rNUcZoE3k9prj9HNcD9eg7zdVcpaBrkUuJs/Ca+Aug92b/FtzE/S22rW9
fXWuJV+0kxMN0qZhrsveO1rHluHWsWOEdewaab29nGUn9yAPk39Zd6x71nyF
es1XqMN3+soPar5S85dxjuOMRrkfOHZ3D+wj7tXcZA/7ah6zZ9XgMdTHiHuC
du9tHzwIvrKfe+xjHzwF7kJO72BOh9O8XGW8mS+eiZ4p8X1OlbEPu8m3B7s3
OfdI8ZG7DxXD4daxe5L1cfYfIgbm1fzlCMfVvOEU9zjN+u+q5CvkcjgKeXlf
8ZBvybvgIHeTy8F2knXO5WTrezn2KLGxT81NJjsOHgTXOV5bp2gH88mJF1YN
vnK6NpFzp4mB3D1VTGdZr3nSWZ7FVOdjC7yh5i/nOK7mDZdWDZ40pWrwlfOr
Bl+hfrxt54lhhrZO9v5miPVi68c5drrY2KfmJpc4jj0v1w5snWm95iszxUPe
rjnLLPuwhfx7vXiuchz4rraO3Tc4ruYuNZdBX1M1eMx1Yp3tHGwi394qNnzz
Rm0nX9d8BD1HfLfax/vEtyZWDa4zW2y3uy7Y7rAOnjutg+8u6+C52zq2kqPn
uh5v6KGqwVHmVQ2Ocl/V4Cj3i3We82c7r+YsDzqO87rH/cC6wD1qvlLzl4X2
1dzlYXE/av0V5y0Q52P2gY1cXXOiRfaBjdxac5YnHEfO2LbKmIfdcJRnxPGc
9V5+ixF/fh/yxypz+BLrlMnV31XJDcif31eZZ/8T8u8q3z0x7A9VxijG/snx
P4T8pco4QF77Z5W5DR4Bn+B3FHgEv580dS3WJI5g179WWPvPrv9ZyN+15Rv3
YP01S/4Ww3p8zzYrmbOamSO2qZKTsDccYyVza+cqf3upSvIZ9lyr5J7Y9WN2
VX8LaVkSH2uu7vqVvGgl11ytJB+gvblr7qQN5IGm/FZTMr//lbMsedb8VtDU
dnjFP6rkFh+7N/fwUPQ/WPI3pLEluRq8a4OSv/XA404Juchv/N1CTyxp/5Hx
Z2pJPndn6Ls8rzEl7SPfHBzyvPeyf+jDQzapct2BckLiNmMnVJmbBpin2OcO
93o5/sws6U8fiROfGh9t44zdx4Q8UPJ3MM5zK8+on2XOljjPdy/+SU4Zasw/
NfQXJbkJvAu+B+fasOTvWfDBXUN2kQueHDKjJI8Z4hj454Ghb3GdPUNfX5Lz
MneIYzpbZp+BnjNnPiH0JP2Kt4YvLf9dpqQf4ANt9VO46Qf6fDP1Op4zeDgP
8gacCF41WB//3vnU4Vq85Z4lcS6rEh9+Ac/tEuVP3HPnkufdQt/5Tv/pUdJX
lroOvtXSdu4JXJ/4xlgHW7bUJ5taxsbhJfkoGOHtm+rnlWXeA2N2LA3Oit7c
98cc3uBI8bL+sJLtTXxHnCNnulFJbK1W8A/eEQJ/g+ONDj2qZJ01R5Q8r96u
g52rei+dfeO8b2JL92jr6HshdvJ9xXcSMfU96zuUjCvEqJW9S+6x/u7iO+xx
5/FdRUznu4vvtkfsp77I/rc8zya+r0HePfcMVyGukf+JhT9YJ1Z3K/m7Wf2N
x96r67+8F97bYm0kh/EtSqwnJhFTOAfO5nN9lvshxvANMcr3gS3EJ+I198J7
5ZzgbuTCF1yXN03cws/IVXyvkrvq71Xq5MUXnUOefMk6+fNl6/OdR514ybcl
PrBHlK+z/nroK0rmlUNDnx/SRiwj9Z/PrVP+UjwD9RHKg2wbbXsf526hT43W
fxaHXF7y3HlXxD7i3mehD/BcBvmOeC9TSsZc/IeYdKD3cVXoq0vmLb7j2up7
33qX3OPyb5eS3y+9fVe8k/624+PE1zG2vRdycUnffSH0mSXv4L7Qd5d8f5v5
7pZ/F/oWuOtPve8N9edhpZGbxmjD+/bRjq8Re7u63nDn8o3OGN7CJq5DG35C
fCdW813W3TP5hDb9r5Vvefnv+5a5x/mhjysZ04jNxLeWvgH2J0YyljnEp4Wh
T7DcTRvhAAtC71Uyrn1U0ofwH3xnlv6zrGSs552cXTIPEQ/fDv1IyTgxLeRY
7eHbnxiE7cRx8gG5ABspw4WInT1cp6PYOc+9S/orGDnLbp7PNaGvLcmN8KMe
+tIy12VNMPTUht1L5mbyxddiBu8FnI3n8HDofUrG7i7a3Mb1enqel4Y+Xd97
JfQ5JXPDG6HPK5lviLlt9FXukf8ZkOOOKnmmH7p/L7EM0x/wgXdDnnD85JJv
hvfyTujHSsY6fL69Y/gdYD3bZ4d+s2Tew5YrtYe4A8+AYxxd8v4We860wwlP
Kuln+Nj0kniYe1voJSXjaHN9l//BTdLWbXxfW3tfH5Z8t7xZ3sQA25eWvDPu
65DQ53pH74f+oCRfPCzkLc8N35nv3RE7+D2N35zgbORm6peVjDXEGe5woffY
UXvABv96x/P5yj7w0t9R2/AfYhR8mxy/i3cN76G8lm272j7EMv03htxUkmvC
bcZq277iAQuxf5x3vbNj8NVFoeeWzGNPhtxbksfB0YgD2ynM5Q6XOH81z4My
/GS8c/YzhuN7xKsXQ79Ukh/zLk8s+TaXihm8+PLT+jP5s51n1V0f43yeDf1M
yf87PRdyRslvBXjuvJJv6lPfeRc1/7/k7fCGWltezu9KcplXQ79W8nvgS/2Y
/NLFGMfvc3NC31zym4fcQo4h7/wficgofA==
            "]], PolygonBox[CompressedData["
1:eJwtk0drllEQhWdCMCYxFgSV4Cbg1l/g0qU7UbDEQsCNHRsqdsVeUUSNvWA3
UYLYG3ZRwcRuYomKiL03xOc4A9/DnLn3fe/73TMzFVWjeo4sMLPuUAgr3GwE
3EF/hC3oBfAU/RNOoSfCS3Qr4lS4D+2hgbVJxMnwAt0DtqLHQ7PFO8fRE+A5
upR4BqrgNXkZcQrshL/krYkX4Ty8IW9DXA9XoC18Y20scQ8UQDHMhGvwib23
MA19yeMuOqMafcHjrK/kc/XfoAt0JL9OnAPv0N9hFXqInrdYW4seCvXo21CL
PgQt4R55DXG4x14R8SD0gQcWz6yDYemVPD6NPutx91fk84mPoAM8tvC+ETpl
DWYRZ8NDi/80HT0jv10MR9Dj4Bm6hLhI70HnrMlCnQvlWZOrxMseXsnTMXAY
npA3WXirM0vS46NwDAqhK/u7iL2A3/+a7UBsh9/oPxZenfOopTxbQlyad62E
u+hl8MHinf3oAzpM3yPs9vC0KNfUK9vgl0XPDEBvhB8Wd97k4aG801p/9AaP
WupOqkV11l416Zs9pV5qhJUenspL9dAg9GaP3lfPrvG4g/77FxiNrvN4VzVR
7fplL6mGmo3eeRfNyD6PGdLstIC9HjNRmp6egJO5182i9pVQYdEDqt3A9L48
azs4n1WNF6v34DP5ewuv6qFdetZAvOWxp7UbcNNjdvSN5eolj7upJqs9Zlqz
rDM1K/M8ekMz8w9fEpzi
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kkzFgAABuCvmQ5OHTvX3S/oJzg2SESSLZVP0UIl2SlaCCXSSmihkiL7
vtOKUunoL9SMx4zD8857fA/v3oTg/vQdgUCgh/9s9afiKOG00MxFhkjjDpGs
cIKXPOMFzxkmkQiWucRx7nKAVU5yk3FyGWGMUeqJooNOXrE1Mo/LVHGLaa4w
wRST3OMgb8jgNUEKyCeJaoqYoZBZGoihi9O85RQl/KWYZKL5QSn3aSSWNbLo
ppVM3jHPHCkc4idlPKCJw/zmLD208YH3LJBKHL8o5wwPOcI65+mjnY/0ssgx
4vnDVc6RQzY13OYL11jiM594RAIDDNLPBSqpoI5avnODr1znG495wj8f2iBI
AbW00c8AgwwxzAijjDHOBJNMMc0Ms8wxzwKLLNFHKzXkk04MYewjlD3sZhch
7Nz++SZ07HSA
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "0.03744003324300005`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.26451164264299987`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.4889572948629999`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHt4zFcax0Pprq0hLqs1imqIEUJaGcriWHmEqsvoVhAMmwaVUbpUGGVX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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXnc11MWx783bSq0F1KKUjKlUNEuWxgiS8hStlIpUdZIQtmXLNl3iSRb
9n3f92EY25gZs++LGWbmvJ339/X44zznLueeez7nnnvP+f6e7pNn7nl0o6qq
To8/awR/OagENQ5aNxqdg76N9qtByDULGhLUO6hPUOug5kFrBr0R1CSoVVCX
WLd+0H+j3amkPmTeDmoR1C5og5KyHYI2LDnWFfmgtYLWDuqoPvrdQqZrSQM7
O78OdsqxZb2SNjLXI9rdgxoFvRf9NtilbDPt7qYt7bFBjj2baQvzP0Fv0CZB
G2kf+28sZ/+escfG4Az6kevQt1HJPfFVXzCrd2vHNg3qp2z3oF4l9xlkv4M+
2Bw87t/fuR5SR20a4Dx2DdZezqk3OoOaBv0UW4O2dO8u2rSNfWycGLRT0Nig
YfoCTH1Krts+aLhj2D5Cjl2jtBVbfhY0MGhM0EjnmdvDPrI7aMtW7jlI28fK
ibUdnWduF32HvbvKhwb9WI69fcPOTYOaB+2urdi4m/P0xzmGHZ8HjQ7aK+jZ
oLuDVgbtq+3b4YOS7X2CDtS+nYMmOI9P9pODqR9xENQi6AAxgG9/53fU3r76
9yD1ga9/SVumBE3WbnBMEif9g5XFB4c6D6bD5Pj4EOdZMyB0bs59C/p59PcM
OsI9h+jTqfpg76BpYsUHR4sN22eImf7lQacHLQg6TpvYc1aVmImjY+T4bKY6
mJujLJiOFyc4Tgs6yv1PCjpcO09wHnxzXceak50/MugUOX6b7Z749VSxoXee
8/SPdR6757vndDFNF+u57oeNZ4kH3QvFA9Yz5cyd7Ty6z3Mdti9yDD+dI/65
7rOvPr0g6ERxL9EX8/XvDM/hIjGD9UJl6Z/hPDZd7DxYL1MHmC7VF+i9xPlT
9Qtnznlf4X7oWx10U9DNQVeLH3xXiZn+lcouVPZ8cVwr5sVB18nBfY06Fqn3
AnHcKjZsv0s70H27tmL7bc7Tv8V1rFnmPD67Qw7u692TM7yzynhF73Ln6d/g
PGe1wj2XVvkGLBXrw+6HjfeJB92rxAPWe+XM3e88uh9xHbY/GHSjfnpI/Le4
z0J9+qiy4H5aX2DXSm3hHB4XM1gfU5b+Pc5j0xPOg/UZdYDpKX2B3iedp39z
vAuvBn0T7efcD30viBN8L4kffC86Rr+peYG8Qr4nX1MHvFll3dC0yhqCnEsN
8VqVdQb1BjUCOZv8Tj4mh69TNeR18mtlbUDd8H6VNURb9SFHrqcuoJ5o7/7k
RHIn9Qv1R3Pl0FfXF52Ue6fK2qVl0IdV1grrV1k3kB+pG8jt5PLeriHvkoPr
uqGb+3W3j+6NlEMHubVP1VA3MNfYXP99bVEy95PnyMd9XYMcuZS8SS1DnbSB
+5F/6zplM9e0c66rdvRT7tMqc/8W2oS+uo7or9zHVdY6vaq0i/xLzq1z2wQx
kCuGqGNUlTkUW7dxDjuG2mdv8u2wqqFWGK69w6qGnE1OI099UWXdsG2VOZya
g/xKfO2gLc3NxQO1j7y6Y9VQN+ykfTvb76+NI6qGuqGuI3ZRrq4hdtW+3bXp
+SrvAXfgqyprhfHqI8eO06799VELczf1BPmfumFv9x6n3u30ZV1fwHl7e2v3
YPEcoN46rx+qveSrul6AHyjmia4BwyHKgWmS/bHKTtQO9NX1xWTlflFlfUDe
pVYgt1IrUDtQl5BfwUPOmFo15PhZYpjmHJim28cv5KYZ4plpf4JjyJGHeMMv
0cbZ6gUDOfNYMcyxf5Bjs7WdPDtXTCfYBwP58UT9Msu961qhrh1OVo66YJ5z
U7VpnnhOs4/d5LsFVUOtMF8cC+yzx0LlsI98d5b2LrJ/jGN17XCmayaJo8a5
2DXz9M3FYiNf1bUJ/Bx9PV9bwUxuPV9sF9qfo+xicaKvrikuUm4v8U9R1xLP
BmzkzMvERq6s64UrnKvz/bXiWaoc+K6yP18dS/QF+aquL65WbpE6rtHe69Vb
5/hl2kr+rOsI+E364wbXgOlW5cB6m/3zlb1RbOira43blVvsGczR3uXuDVby
553ay/uwsmqoG1aIYaV9MKxSDpvIn/e5NzXBA2JjrK4j7nXN5e6zXHtXu4Y+
+fsJ8VBn1HUK/CH9vkJbwfOocuB7zP7Nyq4WG/rq+uJx5dj/KfdD19P20f2M
fbDxVta1A5xvqY7k9qAvo7128O+CvyI+aogXxP2S/VWOoevPQb+qsoZgLXUD
NcOQkjUAue4vQV9Xmb/XifH/BX89aMuS66gRBpWcb6UMdQk1yZ+CflllLfLX
oF9Xqbd1yJSgt6I9sOR8Y8epFagT2kR7jaB3oz3C72py1N+DfltlHkWGeoVa
pW20mwR9EO1hJefJse1K5t1eylB/UHv8I+h3ld/rrmW8ffA1gz6J9rYl8xH3
9W9Bv6mydhlVMoeSW/4Z9Psq+9v4O0gX9VATUA90KJl3ybn/CvpDlXoZbxn0
mXY2C/qoyhrxj1XmCXyNz5voR/zJTzT/Vo58criyR4gHXD09s69d+7b+b+F5
c+6NtBv7B6qDfclHn+oj9L1prLDuNc/1ZTGAhVz8jrHCnu973m/rL/xGjfex
58fZfKhP37PPmVKnfaFPsesr/cU+xd+lsH9d45xYJf6ofak/ifvvxIXP/it2
4rj6Qe3KOPVpF+OZWOUesR+1x1vux15N/M1pPX39jX4iNqlfwdXNeG7p/t9q
A3HQyHqSWGxsfdvD2CZu31UXej5wP/Zq5u9JnGMrf1sgr37kHOPEZQvrn97G
D3FO/FLDcaaf2Kfd19gmJond5tZ++IJvBOp3YpGY5Ex5V9i7/i2jlTb0M26J
5wG+P+ONDd6R+hxor6G+FurE37wRTY0r2q8bP61Lg+9b609iqY3vAPHTzjtC
/LQtDT5r6/3FB+30A7HUoTRg6qDN+KC9fiDO23vfvxTznsZeR9/VrUq+d/iI
OON7h99atyj5fnXyPNt4ppx/Z2WR6awf0N1RX31nHNey6yrDG8e5b2Wc8v22
lryLfhtc8s3dwPhlHNmtS77dGxrrzHcw9rs6Bpb11cNYN/08WJmW+r+b943Y
RR/fO3yj9dTP4O3hHehuu23V0Gfd0JJvYv1dB++jnd2VR2ZjdTa2jewYY368
59vTe4hf+I4b5Fn39p4ML37jVcl72x5ZMn/wnUN7U88d3td2c8e5CxCy3/8G
WzKX9PLeIN/cO0CtPsX7x3cIdxDie2Qfz3AT7R2tDLEH72ebcXLJ9799lsw3
6G2pTAvX863CNxD+GKBPLgy+tOR73UeMW4p9uDbzho4qDd96I0uD7Eixr6XO
VmIdrt820zbeiUeCzyyZM8gHI1z7WPBjS+YYZEf/AONocZ0ZdGjJ+7U6+K4l
79ZVwR8umUtWBt+p5J1eFXxsybt+cPC7S97xScHvKXn3Dw9+f8l7fXrJOcZn
l7QJe7D3Ym0+KvhDJXPnkcEfLHmvpwW/yPGjS+JE/urgj5bMeaybpsziknt/
5lmM8bx66btNvCvcwfr/L9xTcg5jxD0xT87jXhDz3R1nHfeD8S7eTe4kOp4K
OrlkHn0g+C4l37a31YvO80tiA9czwU8rmVOfC35GyZpgkDq542/Yp/1E8ONL
1gfcv6E/sGWodpKjhxkbn1cZq+O9B7TJRbyRvC+8LbyV9MnPrzrX1LeTN5N6
jxqCdv07FWvXc34Lxzvb7uQ+Y9yXmLrXuLov+M4l3/Jrgj9eshZZEXzHkjnk
peDnlqxXxgU/rmR+3zP4KSVz7h7BTyiZi4m1ycbVC8HPLlknvVLy7nHv7gp+
UMncRJweYqwuDz6xZC67LfiEkjlxWfD9S+Y74vcIY2l88Pklc/qdwXcomQ/3
Dr6o+L+T4AtL5nFwHyb2GcH3VT9xPcUY2Cf4eSVz2e3BtyuZn48Jvp823Bp8
atB/qtRxm3rmBD9A+5FdpvwdwbcvmbdPDH6g2OeVvKtg3z34rJJ113XBny5Z
5y0oGYvE4W7Bp5eskYi7S429G4I/X7LuJGYvV/6Ckn7H5+eUPEvO8abgL5es
ETnbKx0/qeSd4b5wb5bY5k5cVvJenFryntCeW/IOYAPv2SUl3xC+LfnG4huM
87/CGLg2+JMla9yzSsYH49cHf7ZkjXtj8BdL1rL46S59hV+X69v/A1hIHu0=

            "]], PolygonBox[CompressedData["
1:eJwl0llLVVEYh/H1it545613XvgB9BsIOU91HJCQCAkRMSdUKjIsUlQq1LJy
KIcUERGJEBERkYjQFMVQCkUxJKdSszK1G5/FH85z+LH3OWuv/e4dkVcSKA5y
zkVRMBWZczdpFvvjTTiV+LjvVAEqaRGHUgtOpxC8QxO4mLbxL5rE5aZzx9SM
00xr+9+U4jKad1pjHBearnVET/Fl07V2aQpXmfybnuErFIb36CGupTUcTR/w
A/qBT+g5zqBIp2M1+D59dTr2Ht+jffyXUnAvneItSsY99A9vUh9+Q2f4nHLw
AM05zTAWd5hmsUDx+JVp78v0Amea9vqTLuF20737NRJxl2kvq5SEu033sk4J
+DX9wV/oLq6mFRxOrThgsr+nq3jQtBc/8zz81rS2n8F1PGJay69xA78zXcvP
9BoeNu39M+XjUdMsNqgAj5lm9Y1y8RAtOb0zt/Bt03/9M5vGd0zPzt/DDG6k
A6eZf8R1ptn4mb/EWRTj9JtH+LHpWgGnd7Wf/ju9s218ZZvOHVI9bjDt1a/x
CT8xnfPPMA53mt5Vv+cL4GR8Ng==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk2FQAAxvHrnDZ2bVs6pxfwBhYRSbipRBPdG5KoFJpEaeIqlbGSS6EM
med5uspz9BLa9HNOi985/923+RIKy4M34wKBwASHOOi/lIhvZPCWUua4zjxd
HGOAXPo5Rxk3OEUL5SxwMLLIR5L5Th6DnOcWFWTyjjsscZtlPpHCEBf4QT53
qSSL91Sxwj1W+cxxRrjEMBepoZpsPvCANe6zTjep/OQKo1zmEQ8J0kotGzxm
ky+kMU4hYxRQxxNO08ZTtqhnmx5OMEmICa7SwDNyaOcFOzwnRpR0prnGFGFe
8ZIzdNDILq/5RS8nmaWYGYqI0MRZOnnDb5rZo4+v7PvIH8LUECHKNDPMMsc8
CyyyxDIrrLLGOhtsssU2O8TYZYoemqgmRDZJJHKUIxwm/v+H/wFTkGKP
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "0.005542414306932253`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2690132951942723`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5439291489638143`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mH1U09cZx9E6t3rG1B6rNb4FQfyBSEETRKtebNRR9Nioq6fDNrW+b1jt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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmGcYVcURhs9aUAFRaSJFBAQpCop0GyjdhmDXoKBYAcEaRQXBBvaKvWHs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            "]], PolygonBox[CompressedData["
1:eJwtk/tPz2EUx5+TvorWWr/6zQ/+Af9BP5Mo1C9uXSSWZrllGE2GuV+7iBah
WWuYmcklmVlSTLFazVxySS5jzczE673zbL12Xs+n73M75zkzCyty1yaFELIg
Ga5YCGXwDE8Q10Mz/GCcSrwMRfCY8T9ow0vgCW7ETfAcMqCXb9eIa/QNTyFu
gD5Ig26+bdRekA49jPcTl8AM/DVsxgcgE54yfkjcYv6/z1CIt8AEPgn5+Bn4
ir+CxXgjfMGHYS5+BN4Hv8MhfLn5/d/BLrwGhmJOuvFqeBt8jR58t/lvtccO
fCe8xGfDQXyZuWtOE34WvuHf4TxeAPyFn8Fze87cleOWmGPlVneqN8+B7j4G
tTHHyu0nyMVPmbtqNh8/AR/xPjiAL4VZ+BuYhx+DD8FrdtK8Bsq95izCT8M4
PggL8QbzXL+APLzO/Cyq6fFYU9VSaz7Ct5vvpTX24HthRGeFXnwfjAbPSQd+
27x2eod38LtKDiQI94idkATTGa8j3jSvpWp0H++CZL0RxpXEW+a1155V+FWY
CtNgJVyE38HXXAWX4E/wNVZDK/wNPudo7IHU+GaKiRfgV/Azaq56JhHX0Fy9
+ZS4hn6rHrE45zBxhXkulAO99QfxbHrzOls7TIlnrCDeMK+F3ph6YUG8a2bs
neyYK/VQOVw3r1U/bMW3mbvegHpvjnmu1YPq1ZyY24y4d6n529EZ/gPRw5iN

            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk2FgAYx+Gvc9rYtW3ZOW6gO7BPQqlkSCIaUGSMQiqJTM0yNBkiMs/z
2KBQtO0SuAPPd47F8553//8dS86KzjwUCARG2SP4v3PO85EPvOc2DdQTzgaX
6eYTyXxmmiliOcFvcnlGIxFskcoX2kmhh1lmuMBJNsnjBc+J5C9p9NHBFXqZ
Z444TvGHfF7xkmh2uEo/naTzlUUWiCeKbQp4w2tO84/rDNLFNQYoZIkEqrnD
MkWs0MQZhslgiBuUUEwiNdxjlbus8ZYYRslihOBQZZRykafc5xvlfKeZs4xz
izFu8oAKkqjlET94yE9aOMckOUyQzWMquUQdT1inil+00saubv6TSiE1wY4Y
ZuSgrzHGmWCSKaaZYZY55llgkSWWWWGVNYZoo5oCUogijOOEcpQjhHD4oOt9
iU9rTg==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "5.9808137848893494`*^-6"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.27263184838195476`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5457307674937741`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQ1NcVxzFpO7EjedWxDfXBS10REQ0oMabXZtUYtYbUaqZpuvHZmODU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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHkc1/Mdxz8fQjqkS+hS6VKKbql035HSgUK5QqWQe3JT7hyh5JxjldbM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            "]], PolygonBox[CompressedData["
1:eJwtk9dqlVEQhfck0Wg0QYOEcAgSL3wB38AHsMXexUtLYk/svfcuiiV2RIKI
iKix96ixxxh7IyIiIiKiRr/FDJyPWfucs2f//5q1u4yuKCvPSin1gBzYbSmN
Aj7pE2xDLIan6A+wE73L/LdmmIXeAR/Rz2E4ejO8RzfCfvRxaAXfWV+lXoPW
0JX1SOpW895NsBddo/PhK+vr1BvQBrqx3kc9BtnwjXUf6nJ4ib4Dq9Bz4Tb6
FaxBz4O76NewHb0EniV/5r7oleb/rYfH6AGQQRdTB8JaeMP6IfRHrzbvdR8G
o9fDW+2Fk+hKaEC3pZ6C6eZetKNugoXwiPW75O8y0bxXdng12fwseXYCppr3
zqUOhY3me3XGBvQCeJD8GU6jZ5p7mU89CuPNvfkH69Dz4V7ydzqCHgt16L/J
vXkBpeGRZlFh7o1msgUWwZPkM1Y2mqBzZES/NUJJ/KeBOihmnaEeNPdI3vzk
u0Phkbz5lbzXMOievOcUOAA/kmdmWvTQXmWiTrOG9lCmDFB7gjLdgVplfoZ6
51FnwGH4nXzPbPNMK8sF1DnmPbT3Ft+No1bDF3SLMoDuBx3RRfIFeivfrAup
5eYZVnZ1iSaZ3wFlPyeyqT2FkdEJ5plWlrOoY2APfGb9RxnTe0EeulN4O8T8
Lsjj83DB/Cz9R3s1U81SPWrR58yfXc94EX3J/Cy9g7KjzBdHhpRNzSwTGVVW
9M5FkZnqyJSyJE9WhGfySnfwDPqs+bNrBsrSiJhNaXivjObHDHpRlypzyTN4
U73MZ6UMaPa6A7mRgWUxs4LYo7stj+SN7vhl6hVzr3WH/wO4sa/7
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kk3FQAUwPHXOTbtbFs6xxfoG/QJiCShZGqQKUNRGYpmmkiaRKG5yPge
zzwWjVQK276G3zvH4nfP3d27+MdkFSUW7ggEAiH+E9kfG0d4ShtPqOIqV4jn
Cyd5TTt5vGKUETKJY5lqrnONBL5RwFs6yOcNY4TJYi9fqaGBG+zjB0W85xmR
598xwTjZJPKdWm7SyH5WOEUPzynmA1NMkkMSP7nAbW5xgF+U8pFOSuhlhmly
SWaVi9zlDgf5Qzn9dFFGH3PMcpQUflNHM02k8ZczDNLNaQZYYJ5jpLJGPS3c
4xDrVDLMCyoY4hOLHCedf1yilftksMk5QrzkLEGW+MwJDrPBZR7ygEecj9zW
US6VNNLBAIMMMUxwu7sRRgkzxjgTTDLFNDPMMsc8C/TTTgMV5JDAHnYTyy6i
2UnUduNbxc9vZg==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "0.00003317145475478789`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727456101102099`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454744594027259`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQ1NcVxzG2neq4NUkZJyU+eKkrUkQCikpyzaD4rME6ph2TbHxWG5xK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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmGcYVcURhs8KARFBEAEpFnoTAtIEBBUBsSuCDQtiAQURewFEokaxxIaK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            "]], PolygonBox[CompressedData["
1:eJwtk0drVVEURveOzyiPIDEEB84c+Af8B04c2PNi7CNB7InGgphgghp774ol
NkRERERE7D0JamKMvXejIiIiYl+f+8Bb7HXuve/cs8vtMaYiV55nZn0gA8Pc
bBO04w9hM74Q7llc24kfhF/4J7iGD4SueAFxFmyHD6yfQD98BbzEm2ElXgvP
8VdwHJ8Jj/HOxDLYAO9Y34cR+BZ4b/HMAI899N+bsBVfBA8sntmNH4E8+Mp6
G3ExPLI401p8PrTibyzu3YFu6ZklxJHAz55a7FUBdy32LIV18Nbi2mF8CtzG
LdVmgsfZVKND+CS4hf+B9fgCaLPY4yg+zSPXDHEj1OlMFjUowdd4nFXvUK5t
UJxyVm9aoSj1aDVxHrTgr2EQvsrDdQbt3QKF6R3HiNM9ep2fznYDuqQz9iUu
hxfqNczBq6BJ9YAT+GyPWumZC/hF1Q96sr5CvAodobfF3oOhu8U7VPvhkLPo
gXIbmp5VjhOhHj6z/g37PGZGs/KD9XiPmdQs/oTJ+C74gv+FJrw/ZPEscYbH
HvpvJ2Il7IXvFmecCnvgG+sOxHKPmdIsKadLcNnjXi+uLSOOVn4WM61eDEn3
itIs7YCPMR7/Z0/fTEGawbnEGrhuscdJvBqeWXwzS/FRHrXWtQa80ePsqpl6
rRyzqefniOc9cleNx+EHPL49vUO5quf5KeexxP0evVVPNRu51LvCVEvNuKWa
niGe9eiFvvlT+GmP2qvGqp1mOpNqqN7pG9Dsq4f/ADHMpK4=
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0klTDgAAxvHXTJdurh2b6Qv0DTonUcjWQoskSRuVqJCKQkRRUWhVKO37
+rZQKOHkE/gQfs10+M0852f+4am58VcOBAKBcULY2/+4brziDLWUME4xE9QR
TTcZdJHODUo5y31uMkkZU9RziF4y6eEC5dwikQdU8ocKHnKYL2TxntdcpI8Z
pkkihg1u85hHHGGTbAZo5xL9zDFLMrF85Q5PaCCOb+TwkQ4u84EF5knhKFvc
pZGnHOMHuQzyhr2zP7HEIueI5ztVPOcZJ9ghj8+85SpDrLDMeY6zzT2aaeIk
uxQwwjvyGWaVIKkk8JNqXvKC0/ymiDE6KWSUddZI4xS/qKGVFtq4xl/9ZFBC
PR2MMMrYfmsTTDLFNDPMMsc8CyyyxDIrBFlljWHaqaOYdOKIIpIIwjhI6H7b
/wEdj2qP
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "1.2672038099958982`*^-6"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727285598573813`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454536870219303`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtw1NUVxxfacahDCiLDMAFRHpWVOgg2D4qPS4kyoTA02GmHAboixZIS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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXnc11MWx783bSq0F1KKUjKlUNEuWxgiS8hStlIpUdZIQtmXLNl3iSRb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            "]], PolygonBox[CompressedData["
1:eJwl0llLVVEYh/H1it545613XvgB9BsIOU91HJCQCAkRMSdUKjIsUlQq1LJy
KIcUERGJEBERkYjQFMVQCkUxJKdSszK1G5/FH85z+LH3OWuv/e4dkVcSKA5y
zkVRMBWZczdpFvvjTTiV+LjvVAEqaRGHUgtOpxC8QxO4mLbxL5rE5aZzx9SM
00xr+9+U4jKad1pjHBearnVET/Fl07V2aQpXmfybnuErFIb36CGupTUcTR/w
A/qBT+g5zqBIp2M1+D59dTr2Ht+jffyXUnAvneItSsY99A9vUh9+Q2f4nHLw
AM05zTAWd5hmsUDx+JVp78v0Amea9vqTLuF20737NRJxl2kvq5SEu033sk4J
+DX9wV/oLq6mFRxOrThgsr+nq3jQtBc/8zz81rS2n8F1PGJay69xA78zXcvP
9BoeNu39M+XjUdMsNqgAj5lm9Y1y8RAtOb0zt/Bt03/9M5vGd0zPzt/DDG6k
A6eZf8R1ptn4mb/EWRTj9JtH+LHpWgGnd7Wf/ju9s218ZZvOHVI9bjDt1a/x
CT8xnfPPMA53mt5Vv+cL4GR8Ng==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk2FQAAxvHrnDZ2bVs6pxfwBhYRSbipRBPdG5KoFJpEaeIqlbGSS6EM
med5uspz9BLa9HNOi985/923+RIKy4M34wKBwASHOOi/lIhvZPCWUua4zjxd
HGOAXPo5Rxk3OEUL5SxwMLLIR5L5Th6DnOcWFWTyjjsscZtlPpHCEBf4QT53
qSSL91Sxwj1W+cxxRrjEMBepoZpsPvCANe6zTjep/OQKo1zmEQ8J0kotGzxm
ky+kMU4hYxRQxxNO08ZTtqhnmx5OMEmICa7SwDNyaOcFOzwnRpR0prnGFGFe
8ZIzdNDILq/5RS8nmaWYGYqI0MRZOnnDb5rZo4+v7PvIH8LUECHKNDPMMsc8
CyyyxDIrrLLGOhtsssU2O8TYZYoemqgmRDZJJHKUIxwm/v+H/wFTkGKP
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "1.4724338626148636`*^-7"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272143661098`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454543934866217`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtw1NUVxwPtONQhBZFhmIgogcKWOgg2D4qPyxBlQmEw2GmHAl0pYEXC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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmHm812MWx7/PjXtvV0p7SpuKSkk3LZRWRbaSJUtZCmNJJbukJMmSJUtU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            "]], PolygonBox[CompressedData["
1:eJwl0llLVVEYh/H1Rt541213XfQF/AbeOGRZmpWIiIhIODWgUmKSUqJi4Ww5
ZKVURIiEiERERISIoSiJYiSKZGqWmkOSQs/rH84DP/Y5Z++137VOZF1JLjwS
Qoiio/TJQqikVbxNZ/AT2sHzlI8LaAT7/2LwQ/qNRykWd9A6HqN6fM702+/0
Fhea7L85jR+bnvWNnuHntI//UZ7pmvuAruJr9BlHUALupi08S6fwI/qDpyke
d9Em/kIv8Fnic/iMONBJG3iCEvFT2sWL1It76C/eowacZHr2EtXhe7SAk6kI
F9M4jqQs/Nq0linKxgOmtc5QEz5Px/AyZeJ+01onKQP3mdbm90zHr0yz9Rnk
4EHT7L5SLn5jWruvaQTX0lrQO93AN0339mdexkOmvZ2j97iEfgTNrA1fouig
ewzjKvoZdCbaTXvke+NnoBmn0HG8QnfwXdPa/Ix9xOWm73zPWvAFOhl05m7j
CtNs/No7fN00a9+jD7jUNCvf4zT80nT2/Ew+wKmmvfhFZfiWafa+plF83/Sd
72krvmham79TNa4xzcLfudHvZdpLn8l/f+qA6g==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk2FQAABuDrHBu7ti07pxfoDVoVSbqKSppEqESDORoomVKZU3GjOYqu
a7rm4V70Gh4iq757jsX3n3/1r/5D+WVZd5ICgcAEeyT6J5HJV77wmVu8ZYBj
fCeXb1yglNuc5hVlzJMYjzLIcX6Sxw8ucpdygrzmPgvcY5F3pDLOZca4RAUP
yOINVSxRyTLvSeM3V/nFFWqo5gxd1LFCLat84AST5DPBNep5yFm6ecQaDawz
RDphCvjDdZ7wmGx6aGSDp2wyzEki3GCKQp7RRA69NBPjOXFCZDBDMdMU0cIL
ztFHG1u0ss1HTjHHTWYpoYN2ztNPJzu85C8jjPLPP3YppIYOQkwRYZoZZplj
nigLLLLEMiusssY6G2wSI06YYdqppoAgRznCYQ5ygBSS9//7H+IoY8Q=
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "1.330675369892731`*^-8"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272627918911`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545445861949`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQlNcZh1E7He24jTGOTQkqN3GDiJdwiyE5TlDqbQw2TdKmdmO8NEac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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmGfYVsURhs+iYgEkdBFBEOlVepNiA8SCFQs2bCgIiD1GQUTFggULChpL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            "]], PolygonBox[CompressedData["
1:eJwtk9ePjlEQh2eWz9q1kbUREXcu/AP+Azeu1NW5W73tIsKqQRC9d6KXiIiI
iOidKMtaq4SI3oWIiIgoz89M8j2Z53zved9zzsyc9lU1ldVFZtYZmsIAN9sI
7/FHsAPfD3/xr9AfXw/v8AewCz8ITeA745Ee/8mLiFthG3xh/BmW4bVwHX8J
XfHF8AK/AYvwIVCJP7dYe5jHM+2hO77U4906GIhvgg/4E9iCb4aP+CfYjg8C
fv/3sAKZAjfxV7ABnwGNFmc6gI/w+Lbns4fQNuf0Ia6GN/hdOIxXe3hx5mIU
3LbIySEYA3cYF4jrYDo0MH4LR/BxcA8vIfaClfDa4p1++FqPuZqzBp8G9RZ7
mIvPg8cWOdOzRmidc7TWfWiTa/YkLvc4u/a4Cp8KtyzWPIpP8KhtC+Ud5sAz
ixzX4fM9aqMcz8JnK0d4J2jAe0ApXqHvQhdQj7UkXoGreg4d+W+fx5pa6zfj
ydkz6pWyPEsltLI40wk4CX8svlmPd4MCXk4cDbvhh/o5z94b2lnkYKhHT6uX
9Y3xHnvQ2qVZ677QwaLmNbAXfjFuThwLe+An42bEhTDY4+zK0RKPM5RlT58i
nlbz5R4nEo953C3lbKdHz6nXvjG+RpwJTy3u4AK8KnOl/4Z7vKO5lrVTziuy
htqreqok96xeV47Ks+cnEY973BX1jM6iHi7OM50hnvW4u6rhOeJ5j1yqBheI
Fz3OrpxeIl72yI1yVps1V611x1UL3YFC1uQfMlWgew==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0tlSDwAYxuG/GSedOe3QjBvoDrqASkVKKkkJURKppEUL0U6RtY1QJNr3
vdCqsh24At2Dp5kOnm++43d+h1OyojMPBAKBEXbZ+587p2jlJS+4QTX3CWed
c7yljTTeMMYoCYSxRh611HCUTc7TTTvpvGOCcRKJYIN86qkjii0u8p4OLtDD
FJMkEcl3CmikgWPscIleOsngAzNMc5potrnJQx4Qw0/2hurjFZf5yByzJHOc
HxTSTBOx/OYKn3lNFp9YYJ4znOAXt3jMI+L4w1UG6CKbfpZYJIW7FLNMEV9o
4SRDXGOQHEop4SxVlPGV23zjCfGMkMsw16mgnFTucYcVKlnlKc/4p5+/pJFP
DW0MMMgQw/u9jTLGOBNMMsU0M8wyxzwLLLLEMv20Uk0eqUQRSghHCOYQQRzc
7/s/O+xthA==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "3.5201785930638607`*^-10"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272726837945`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.545454546322976`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQ1NcVxzFpO7HjNo86tqE+eIkrIqIBXzG9dta31pBak2lqNwa1McGp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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHkc1/Mdxz8fQjqkS+hS6VKKbql035HSgUK5QqWQe3JT7hyh5JxjldbM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            "]], PolygonBox[CompressedData["
1:eJwtk9dqlVEQhfck0Wg0QYOEcAgSL3wB38AHsMXexUtLYk/svfcuiiV2RIKI
iKix96ixxxh7IyIiIiKiRr/FDJyPWfucs2f//5q1u4yuKCvPSin1gBzYbSmN
Aj7pE2xDLIan6A+wE73L/LdmmIXeAR/Rz2E4ejO8RzfCfvRxaAXfWV+lXoPW
0JX1SOpW895NsBddo/PhK+vr1BvQBrqx3kc9BtnwjXUf6nJ4ib4Dq9Bz4Tb6
FaxBz4O76NewHb0EniV/5r7oleb/rYfH6AGQQRdTB8JaeMP6IfRHrzbvdR8G
o9fDW+2Fk+hKaEC3pZ6C6eZetKNugoXwiPW75O8y0bxXdng12fwseXYCppr3
zqUOhY3me3XGBvQCeJD8GU6jZ5p7mU89CuPNvfkH69Dz4V7ydzqCHgt16L/J
vXkBpeGRZlFh7o1msgUWwZPkM1Y2mqBzZES/NUJJ/KeBOihmnaEeNPdI3vzk
u0Phkbz5lbzXMOievOcUOAA/kmdmWvTQXmWiTrOG9lCmDFB7gjLdgVplfoZ6
51FnwGH4nXzPbPNMK8sF1DnmPbT3Ft+No1bDF3SLMoDuBx3RRfIFeivfrAup
5eYZVnZ1iSaZ3wFlPyeyqT2FkdEJ5plWlrOoY2APfGb9RxnTe0EeulN4O8T8
Lsjj83DB/Cz9R3s1U81SPWrR58yfXc94EX3J/Cy9g7KjzBdHhpRNzSwTGVVW
9M5FkZnqyJSyJE9WhGfySnfwDPqs+bNrBsrSiJhNaXivjObHDHpRlypzyTN4
U73MZ6UMaPa6A7mRgWUxs4LYo7stj+SN7vhl6hVzr3WH/wO4sa/7
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kk3FQAUwPHXOTbtbFs6xxfoG/QJiCShZGqQKUNRGYpmmkiaRKG5yPge
zzwWjVQK276G3zvH4nfP3d27+MdkFSUW7ggEAiH+E9kfG0d4ShtPqOIqV4jn
Cyd5TTt5vGKUETKJY5lqrnONBL5RwFs6yOcNY4TJYi9fqaGBG+zjB0W85xmR
598xwTjZJPKdWm7SyH5WOEUPzynmA1NMkkMSP7nAbW5xgF+U8pFOSuhlhmly
SWaVi9zlDgf5Qzn9dFFGH3PMcpQUflNHM02k8ZczDNLNaQZYYJ5jpLJGPS3c
4xDrVDLMCyoY4hOLHCedf1yilftksMk5QrzkLEGW+MwJDrPBZR7ygEecj9zW
US6VNNLBAIMMMUxwu7sRRgkzxjgTTDLFNDPMMsc8C/TTTgMV5JDAHnYTyy6i
2UnUduNbxc9vZg==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "9.284839563861169`*^-11"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272727845709`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545454937987`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQlNcZh1dtOzXjVmMZJyVeuKkbpEQIIF6SYwYlGq1BHdOMpsR4qTY4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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXn811MWh+8lklSqSdOmEhKlTVlDirKTbZQlIZEl+xKSZex7yJJtDCEN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            "]], PolygonBox[CompressedData["
1:eJwtk9mLzmEYhp9nGEkSDp3NgX/AfyBHdj7Gekayz9gSQkP2fV+zkyRJkiT7
rsE0xr7vuyRJ9uue+3dw9V7v7/stz3s/z1cxpLpUVRYRnaAp1GTELKjDW8Bm
fAE8wD/CEnwQlOPPYQu+EB7hn2ASvjXtT6ALvhxe4TdgKT44/e4X0B/flH73
YziEj4W7eLB2h5Xwhm0DdMVXwGu8Hlbjc+Am/hZ64qvSfhvW4/PgDv4eDuKj
07/9hd74GngX/uZafC7cCl/rg69LP3s//Fut6i/u0bevQvOihsOs1el7y1iP
wHh4qHyLs8xOn11nqsQ3wIfwPcqyAdoWmSr7emhd9GAj63y4F35GZ7sOLYsz
6rc6aFXcc4J1ZrpXyuwoPjGddTPW7XAAfrP/AovwAdkYfTwNf7svdAzXoNr6
QSlco7LoAe3CmZyFc/CPfXs4iZ+CX3ibcG0l6BCu8TScgT/hd+xJ16jafrLf
mZ4JFfSNZUe6h+rdVxiO70/PgmZ2GL4vPWvXYFe6J+rFd/a7i56oFz/C2fVK
16oMp8OM9LOa8fP4BeVR1Dwu/Q4924S1MyyDl+xr4Tg+DZ6FZ34xPlDfD1+b
gk/VzISvHcMnp7PWO4bie9Pv0j2arW7p7DRjE9IZKZty1stwJe3qSVX6zDqr
ah6TzlDZqSej0hkqO2U+opgB9V49uohfSp9NPdcsbIPPbkHjrIxM/xc1M/8B
aEKgGQ==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kkzFwAAxuG/GZduro5mfAHfoKulbAlpsSZFtFoqUShbIVosRYlSWu37
TkJJdfUNfAaPGYdn5r2/v7DMwoTLQYFAYJRgDvYeN4xXpFBHMWPcZJxHRNJP
Fn1kUkoJqdRziwnKmOQxUbwnh3dkc4fbnKKBu0xRzjRNRPOBXAY4TyUVpNHI
ff5zj2aO8ZM8BunmAh+ZZYbTxLBOFU9oIZZNLvGZHi7yiXnmOMNxNqimjVbi
+UUBX3lNPl9YZIGzxLFFDc94SiLbFPKdNxyc9I1lljhHAr95wAuek8QOVxim
lyKGWGWFdE7wh4d00E4y/7jGKG+5ygg/WCODk/ylli46ecl1drWTQymN9DDM
yGFjY4wzwSRTTDPDLHPMs8AiSyyzwiprDNFNAyVkE89RIggnlBCOHHa9D9aY
aSo=
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "1.5547563236850692`*^-12"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272727297805`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.545454545450929`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtw1NUVxxfacahDCiLDMAFRHpWVOgg2D4qPS4kyoTA02GmHAboixZIS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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXnc11MWx783bSq0F1KKUjKlUNEuWxgiS8hStlIpUdZIQtmXLNl3iSRb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            "]], PolygonBox[CompressedData["
1:eJwl0llLVVEYh/H1it545613XvgB9BsIOU91HJCQCAkRMSdUKjIsUlQq1LJy
KIcUERGJEBERkYjQFMVQCkUxJKdSszK1G5/FH85z+LH3OWuv/e4dkVcSKA5y
zkVRMBWZczdpFvvjTTiV+LjvVAEqaRGHUgtOpxC8QxO4mLbxL5rE5aZzx9SM
00xr+9+U4jKad1pjHBearnVET/Fl07V2aQpXmfybnuErFIb36CGupTUcTR/w
A/qBT+g5zqBIp2M1+D59dTr2Ht+jffyXUnAvneItSsY99A9vUh9+Q2f4nHLw
AM05zTAWd5hmsUDx+JVp78v0Amea9vqTLuF20737NRJxl2kvq5SEu033sk4J
+DX9wV/oLq6mFRxOrThgsr+nq3jQtBc/8zz81rS2n8F1PGJay69xA78zXcvP
9BoeNu39M+XjUdMsNqgAj5lm9Y1y8RAtOb0zt/Bt03/9M5vGd0zPzt/DDG6k
A6eZf8R1ptn4mb/EWRTj9JtH+LHpWgGnd7Wf/ju9s218ZZvOHVI9bjDt1a/x
CT8xnfPPMA53mt5Vv+cL4GR8Ng==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk2FQAAxvHrnDZ2bVs6pxfwBhYRSbipRBPdG5KoFJpEaeIqlbGSS6EM
med5uspz9BLa9HNOi985/923+RIKy4M34wKBwASHOOi/lIhvZPCWUua4zjxd
HGOAXPo5Rxk3OEUL5SxwMLLIR5L5Th6DnOcWFWTyjjsscZtlPpHCEBf4QT53
qSSL91Sxwj1W+cxxRrjEMBepoZpsPvCANe6zTjep/OQKo1zmEQ8J0kotGzxm
ky+kMU4hYxRQxxNO08ZTtqhnmx5OMEmICa7SwDNyaOcFOzwnRpR0prnGFGFe
8ZIzdNDILq/5RS8nmaWYGYqI0MRZOnnDb5rZo4+v7PvIH8LUECHKNDPMMsc8
CyyyxDIrrLLGOhtsssU2O8TYZYoemqgmRDZJJHKUIxwm/v+H/wFTkGKP
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "4.903855099769316`*^-13"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272727270308`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545454541703`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtw1NUVxwPtONghFZGhNPIQksKWUoQxGyg+LkOEAWEw2BcFuiKPioRR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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHfcVcURhs8CIgKCUkUQpH8C0kVEVFQEsaLYxd5QUbFgVxAr2Cv2HksA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            "]], PolygonBox[CompressedData["
1:eJwl0t1Pj2Ecx/HrY3XSmVNnHfgH2vwBjjxTIVIza9bMKBajVUujlWE9eBaK
FmbNzMwMa82sWZIxpjFNMylJCE3z9P7uc/Ber9+v+3ff9/W9ruyS8vyyOSml
BZRB5UppBw3gTGrGaygLj1ITXi3/7z2V4cck6ufzdv520S/8j3rwTvnaKarA
u+hJ8j334L30DM+lXrxbftYXWoU76Dt+S/vxAXqNc6gP19E4nqajeB3NT/6u
Fu+joeTvVuJ2+do3dAyvl+/1kR7gGhrD3ygXX6Af+B114ov0E8/QZZwX68ez
tBS0yWt9SmfkGcVsPtMSfFr2IFXhanqB59FifJIm8SNajs/RV/ySluGz8mye
J8/6kvzsmPkKfF5+91dUhK/Qb/yHWnGB/KxY40NcL689ZrwF35JnEzPeim/L
sx+mu/iefK84N6fkPY+9jnfehu/IsxqhjbhbXmucqTgri+TfxplpobXy3n+g
TfiaPLs4IyX4urzWOCOb8Q15FjGzE3gD5eNP8Qx8RHbs0XFcSAvxRPIsrtLf
5Jk04EZ5bXHNIXxYfve4Zz8+KP82zkApvinPNs7UfVwpv3vsUdy7WN67eMZ/
0aKI6A==
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0sk2FQAABuDbOTZ2bVs6xwt4g3aJJjdSlCSUhIQiVIoG7q1MqVSuKY2U
4Zq5rrFBT9E7sOxzjsX3n3/3b/6kgopg+YFAIDDOLnt9SGQwwgeGKeMVPaTy
l/N85iO5fGKBeYIcYZu9gTe85ihfyeMLF7hBBad5zk0WqWSJXtIYJZ9vXKSa
KjJ5wS2WqSHGW9L5TgFjXKKW22TRzh1WqCPOO44xTiE/uEwD9Zyhg7us0sga
7znOJMVMUMR97pFNJw9Yp4kN+jhBlKtMcYVmHnKWLh6xSQtbRDjJDNeYpoQn
POYc3bTyk6f8op9TzHGdWUoJ0UYOL3nGb8L8YYBBdnzkH0XUEaafKaJMM8Ms
c8yzwCJLLBNjhTirrLHOBptsMUmEELUUksFhUkjmEAdJJGH/w/8BcT9lFA==

         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          RowBox[{"-", "2.853273173286652`*^-14"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272727272484`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545454545522`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztPAdYFNfW48KCooISxBaKipDEGBBjiZqIJYbfEvUFG0XEigUUElHsYiOo
qLGLJYIiNjSYBAFDl2VZUNGnxlhiQU1EpAkrBDz/vTN3dmdhdneWxfx5/3O/
b5blzrnnnnv6uffOjPL5xneGn883s6f52H4R6LPAd/a0r22HzQ9ETQZNKIr6
CV3HbSn8G9BP8vUToA+6qeFPR/qPGdS8yIGzu/3BzrwrzN99FnJe1AD9Kc8B
716TIae8Fl5kroUJI3xh7fbtsGbOFFibUgQIimpG4zAVgAPg1f1omO8eAKHf
hUGg5wKIfvCqGSGB55ZgEsSEBO043hgJenLBpBEE0YSR6bv0HwOAklRwsXWB
1BKgRHQborGmGC4nXIbimiq4fygIwvLL4TW6Vf1gD/R1/AauVQJlIqR/9TM4
O+ojmJxRQvcvzfQGx1Fx8KwWKGMathVArVoYIXQY6oJGPTmNRI2+TBHUX4NQ
iGzNuWhaMXYuor8N0CRptDSEiGe4pnSbGF4XnoMBnV0hA8MyeHBvQTgYoSBM
5VJwd+gPJ57W0sC1T09A//c8IOcxjY9BZ8JFp75LORiRkTiUkZGMNXUjFGqG
MRYAwzc+n8CE0MTXrykPfg3GyngzI6h+cg7Cj1+CwooikIUPBvtRx+DJX7yq
qKAMtQ3u5ALJxYTpxb+AS6fBNIyxABgDzUMLGUb095DSUC7w9dPCcK2iEkP1
vUMw7cgPEL09DDbvPw+3K15TzTVqUA54vjcATv7BatBxpEGedTRWPYyBhnHF
AvqL/gY6Gjp/9RLiH0dURzzFKXW6GSD0ceCz7RagcE615IFTkFVbCOdGO4F3
Jvbgr6EkYzI4fskNa5phDHjGE9JP9AbHb+h8TQTyk8FFMklDlMBIICrECxwd
XCG9BFjTguJUcLW2hq4ODuDg8AEMWHAJUCbUTFMvMVQ9PAELpyyEzTs3wtde
gRDzoIokWvz3DDWPpgmt4ZsZsgETNGkQJ4mTEprz78ABmol7FJv+6pN7Mppn
SNcd5IN/E65ym9lb5J6BShdRg+AbA8dbGnXHUU/cRKH0TXbfKtN/IY3qlEmv
akc156b1ih7HkofENjxtFvrCGWoxCy2ppwEP3q08bYbaRuBPnfikJwS9lpTA
SDe0GmOk2oCnI2voqCfCd7YqfhlxbumI6R8F/nZa/yF0WpK+T56UQdwPN+DH
czfh6dMyd9Jc9qQIbvyQBTfPSaDsaVE79ePqudrIZ/eMWzOiaRo6eD8M/HQv
fQ0begASE36bSG5j2vYPXgh7Pw2grwNDg+C3hNy26mnVd+mMz9CJv4WCglKW
WPQf840J/uNpOQ0xjsCVFhSyVKP/mG9MefnTF5zJ85LfwPgjZK1I08x+QOpB
RIBwMTPDomHh3Agc1hciCwTHzAzLqA4+oYIRsoRCk01jZIk9e+Z6PWLPxdUn
9vqZi/WJjVMSa67ArCFkCllD0MTZhw+KYcigCBWdwTr0+HGpis4UP/gTIgZ9
o6IzWIdKHz/XpjN8gVJIzc1HNmuXZ2Kvs2TTFyYZKQRrl9djM1lq6QtTivRA
g102oDTl8xusT8NsxUqLL2SWrE/DXMQ6ii9khRp82tsQ0YCBNxOA2tpaRZvm
ATYybSCXyyEvLw8yMjJ4M3YNg35Lf4uhoqICZDKZ85ETEiPJpVK4fPmyVlT0
/ENJM0aAaHA6ejLbOCuvRETlXpOjZoSHnYiWyawjiPBkLl265HjsVI5R9uUy
Q1VEAriyhiCqrKzE03GMPiVtiigy0hnRaiWinlHHszAizJumOiNaqcojPDVM
kYl2RDSLV3C6Ixk5RZ+k6WihM4uX1keEZWWqkY7G2FHlc4bBSu5+HBmTyXK3
lUZimFJQ7y1APnoWqaqNE6LHWHKpxFwjPbwZhV6bZcqIjH7Gx8fDokWL8EUF
0t+GEBgYCN7e3gdHjZm80WvKAotQ72lfo+aIiAiK81Hhl167M2RfgMsrCAsL
g5kzZ1JIG0JD0eAhISHbJ7jP3jbRY+7SOX6r2izyC1hLiQ98OdYbgoODuXyr
R1gDdyT4FpAWL14MGzZsoOZz1ByZ20fHTudgSbalJSneMGXaN+Dv76+RKh0X
5o00UONXnxrs19prp0aPtWo+obEEtWS71jyGo5/bQf/ho2H06NEwcswcyCuD
ifz0dtROr9JjMUxSjGhKJiK/HQmrI65AOTbH2ipAIqfGk+HKy8s/joq5SLsB
NJwVPZwBdziqfrzln6BiZ7v6IRwYZAufLNgBJ5Juw8uKm7CybycYOG8DnPpd
LiIjAxJw+bXvYeWqY3Dj5euedHN3ffwd/XktfwA/75oLXVp3hcAj/4ay2obB
u7lOD3PzCTw+znXk0Fn77lM51yr6p0Su+nHYZzPmzVkSvnP2RC+XOQefoHY5
1U6gkDQyDqld9T3Y1rsHLLshh5qSa5DyUzR80qEH7LrzEM4F74VbcrZQYrhX
nDoLnEcdhEfVZFtZe53Vlf7W25EzVJhwiwr00QLeSgW8oqIYflzl7eYenmYk
uVxmnZ24/Up3hwXNjueWTjm3NvAj/9OFlOyanNMubxQ2m6GvMsh2d4D+R5/Q
WlB9fz8MeOdd8Mopg5LMuTA97k/UXgWPTu2BzCIEUZQAA7v8D2SUAvW+Wj7r
GH0MldHnsQymWYkV50eaO8Gu+9WM5WkBbebgOnV3FrZbikn8DCxkGafvOr07
zGy/BP3H09ZoPKyBx1F9ocvYdKCn/LoYUt3toffeB/AKxZLPh0VCwV818PzC
Spi+PAIit8wAt+BkKKplc1mhuiokiNqpCaI18Cx5F8RiD6KiqKAR/tjNIpfI
gzsef2Dp3GZXeilmWPvs5NPjAzdlm1yQPQmICnKJs3aJNDx/RW27UC7zeW0x
8QYvL82Cru8Hwb8riUbJZkMfjywoQxXxkPfGQXYZUL1ZFmkN5134wjmDuOY5
pO+OgTtPUlRZxAOPglPvqOif166Yuc76VOJPv/fs+JnZPqRVaLadss/v8xgd
enLeuiXrpwWsjjM5I6tU295e7zCDvOVfLyD7zAHYErYHrpeTuVQXQp7sKVQh
11VUWUP1YfmjY2LBjGEBtcXZsCf8O+hpo+QLB65uidJKlpUesCRo8/33Oyj4
0k6Wcsr/y8VXKck1OTFIbhMlNMCr4cbnzD0NyYqdumSFfFAUlq0Ax46DlM4L
wX9uZQXWNja/d+jQ6TtHjwwq4xo9G3RVfpwRs6TA3nIgO8NWuVmJD/q1t/rV
2tb+Vxvb97c4eWVjeHXterqgSfQ9JlHKzc11IplLd/2wTuBgJbUixuqohyGP
IyhfvnwJOTk5uETHStJDD93/ioMSz51U/T31m/tYDlZO6tlLP6yjlVixjXSP
iZWJEdY+jZDQYjPPPrkcPrD4AFaczIbCaqD6keHoOvJ4Fp4EHu4TPbhtRt9T
XTr9RKkntOUTPekvtKxo8AlrTZWXwMzbgGc+TNrdrd6Ih24W4eWBftFHDsmG
d5vUIlL6cnzCpoGF5q1tiT3b51vbjzM9lI19wPNDUWPsltj7My6N8RNvDr6D
0IpS76PPmuo53bN2Vc4bcds0pEF29LeFylReVlT4RIQMT7X5eFOz+LwSg9z8
P4ZF75UapOTLm8tyZPsD/hXaIlpKx9+msrwHoqx8zMUy/7jFzrs7j5diL8wk
jCZvCFywiPQ/nqxdRthtCEn5yUcpow/Uiqh+tj++a18ITZBhv2MluXD4pmOn
icho5IYkB5dmnF+xYO5e06PZFWxe3kGa/H2SS9+d4h8vK3P1xoLTRQB6HkVW
WTojnGcZR7gvpFjAYnkG6QcDofd79DaKUAPpQrwfCjSDIg/sKOhm6Wy5I62U
pCbx93p2dMGpipjmSFMzmSQtym/kbLvVP73ABSbxPiUzzq6a+uH8M0WGjQrW
QTX80EwS8RqBfieNNRmBLgUFEw5M2OQKJ7bmksyUm8M79Wv7bWoFSWiPIO3G
IUHOLO4bdL8YuzDH/sMQ4zN5crYSFedevhPyre/eprjNsJHhBKziCVlTFHJo
WFAIEFCKONOwLXB+wk2y8EREufkFZ7cMcuw/MvIPpESVA1IPe/xgP+iUKCmf
lAx2baWpsQF+QVlN0q7KzWWZcXecrVwt9mc8dNh/7hmrd50l8XvcJ337G5V9
Tf6m4QXk8NqXUTXe42X4p/Q9etVSwUSUUjNqI7aSJB09NHlMwJyApRsiPUf5
W69PLCUqZYcC16XdS8Z/tWhiwNb1gdPdVnw+N9U4Ne+WZMlHnW51tKETjls2
NjY3zDsHNjuRK3/T8HoWQf0JI9jV4pjTMqxNI/RIrjmZLd6lYhPoUXok0H0I
SlKusOIard/ceykJRSn4Rbb4Hqsf1p5KWjFWltav9OBoDyWhOJd2IoSO07sk
wYA1UJiwGNwX7YRdi90hOKEQJzAdVGXIlpwT9GONYtCq2xDaqzeE362Cqrvh
0Kf3t3C7Ctqpcg6XRHjfpxszzRYy6U3zE5m0o2N9eWvpxUstzkrpcELZ60cc
A2KmrfZhOpVmgGuXgZBQBCqrupbKGSgEhVRfpKBPbW3SIleamTPyQw8UDMuH
Je1dctB1zKLZgcs27Zk5zmPorIgCSqp+28A8JzMhxtd1ZPC4+Zu3+nu6feUR
fg/5VsF1EJPQGLeRpp+JnTzEr/3mZJrJ7bJTTsV6DpnfdktqOfF+zVvnXMz0
3bx8bpGVmZ3vpOUnWkdefInv2EgSDh+dNMLPzy94fZTHSD/rdYkl+i4RKwWi
tS6iBTKcRyBCl4ib1nEFuBpH+s5wpqu6YoUtl1qmSKXXJtj1tA1KoDlnLU3c
fvXDrnNNjsnU7kH0S4uavqHfNHohq2POLweuftTVF8ELLrsoJmUSo4B7OtZr
iH+PsJMxWFrttqSUkXvNzXIlidylVZQfPIrb7NJ9wIjDOD+Q90+L9Iyzd6Hz
A0rA9qpaB6UQlZDyqOoObOzdh2P8Ydj4yfO0Ch/f71jUnmLnluzjsMVUS8U0
FHsU3NqFUVBj09zs5DsDrPq12ZJOs6+NLP3kXad3XU33Z/PvYzBtxu/IMs7c
7fHuFzQcatFaFxmTDDMzNui5bSuH7lNji0hbPbYj28741dX2k3ahKWzie5Qt
6wjbG+bElWwXuomyDLyCd8PuYE9YmvScPtoh1ELIkwFs2slGhObM8Yq65Qsj
oZbIQB5Fbxn+XpBzQJpJkuxR0KGAAcdtvzhhgBRO3ZYHka5hk9yrxZPPrvsy
ymHkSQwvElYocc3CE5nFRu1mgf+/16vjZ632ZLHr0IpiT7BZqBER86igsJrp
HaUT4ialpmprmRaIR4X+xxZPjHF2/XpO4NKNR6eOGBA4bKFElJ7Pu1/CdBMj
5U6aui5k+4aAaT6TvdZdaZJ5VWEcAksrY0tpmvpoIVZrCJnqKkDWeNBYBW7f
hwcXdm79vtuM8HTxhct0X+xrvaPW+qHI03Ws99YHuHgg4+gZYYSVXeYc4bAp
KArtLWkKjPjKHuxKyGoX8kqpt12s+1luTKMnbilLO3HHyWqk6cFsnn0dc5Tq
5E5fvUoiSs2XI2d15raz9QgMqmtxZSAwcyLBHel9Qp1wobacpJhTdAYqIjbg
aTPST0Q2hO24UKOPvDGprxnDdr5iCTONmaQNNg/fmOWzwkb4rJu5aOW2jf5T
Jvn9K1jaJP2q2k0l49y8W1vXeroFj58fviFw2lchg32TRMxyqE51GUVO5aGM
KW15yDz3X+1th5lFSFg3xltiEl9U3LMlccGmKmGP3OaIqPLTlMN+2/p5rF24
MHDec+tWdr7uy+MNk67IhRoGXzC3UtV0tixyp1E248kpns49tDSiw+nkhDpC
b1hQ68gZnrO+4cmjWyJF8JHMXrFsx/1uzG6pAJVrvEOR/JNor4yW+DAiOwkv
hmDk4x75RKzxv9mtE0cnsBVW9sg4ufKRQ9uBAufRqOcp+afSlkwF1zRRMYp6
dr4OK2c6vu9D7TqwhSop7FmzAKFro417iJJl0Dscquiijzne+7UuDGq8Q5T4
aKeXlxfVmv+46UL6uKn4qOuICVqPdjboEKXKs6OQmpraipwxXbNmDcybN2/L
JM95S+b4r15MnzE1hMjISC4RjXV0UvVssBkREXdTHoloCWN3Wg9wm3K6cw5w
L1PtTpGPhgPczZWqwhw5YA5wr9BORx1EzTgUcVLFVTojMuZBhEwqRGdEYn5E
awWymC0v6pj2egEsbqqicfiD18kQEjZZCBUwGSMVJPn5+ewEwgR0VtH53oej
Mza9oU6ccI170B02CmDR30bg/+2s2jCdOmWlPpl5fnfa9PN70m3Rb3fSnJha
OHPH7vzpO/dctUW/22ikrFEe66xHoQWTt2LKXu0bpHh0szJicJBn4gHJRHIb
UfhqyCDFg5+VQwfv99x74LqFRoob5+HOeiS/w0RXu4vJBSzJ7DN4mGybrLSn
NARZjbY7n/yMpZ19pg/Tb5OU9pypbnSehPDnN9URPyt+V1rdpx2xDNi0mnIj
cNt35dd9ehILQwHXuuHEC9z4VliAcjiD2fE7U+uSP4OH/Nnf7bxSl/wZO/jJ
pzifRnnCUx3vHTIvPKre56Ly8CZWpM4XUx5zFcch/sKf1YNdVB4GxYrUOSHl
mS6K06DnPNUZ6pz4nSks8fjChGPFIYY6Z9vOKyzN+ML0Yn3RbKgNftpTncPD
LMYqji9sp8ThYY5ijcYXNkvNDu8f4L//f0alf9Ss3rLiP4IVb+g9YNoHfgPv
i2rYoGpfGqSK/LOI75M2dfz5l7sIuVQqFYhcyKt+yMuJCgoKSKWDftH/teFp
s9AXTtjLiTQtA7x9R9d/FY1aX/gm5MVQ9V89qOurnw4wnXnfbkg1+V/wuxoE
\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQ1NcVxzFpO7HjNo86tqE+eIkrIqIBXzG9dta31pBak2lqNwa1McGp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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHkc1/Mdxz8fQjqkS+hS6VKKbql035HSgUK5QqWQe3JT7hyh5JxjldbM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            "]], PolygonBox[CompressedData["
1:eJwtk9dqlVEQhfck0Wg0QYOEcAgSL3wB38AHsMXexUtLYk/svfcuiiV2RIKI
iKix96ixxxh7IyIiIiKiRr/FDJyPWfucs2f//5q1u4yuKCvPSin1gBzYbSmN
Aj7pE2xDLIan6A+wE73L/LdmmIXeAR/Rz2E4ejO8RzfCfvRxaAXfWV+lXoPW
0JX1SOpW895NsBddo/PhK+vr1BvQBrqx3kc9BtnwjXUf6nJ4ib4Dq9Bz4Tb6
FaxBz4O76NewHb0EniV/5r7oleb/rYfH6AGQQRdTB8JaeMP6IfRHrzbvdR8G
o9fDW+2Fk+hKaEC3pZ6C6eZetKNugoXwiPW75O8y0bxXdng12fwseXYCppr3
zqUOhY3me3XGBvQCeJD8GU6jZ5p7mU89CuPNvfkH69Dz4V7ydzqCHgt16L/J
vXkBpeGRZlFh7o1msgUWwZPkM1Y2mqBzZES/NUJJ/KeBOihmnaEeNPdI3vzk
u0Phkbz5lbzXMOievOcUOAA/kmdmWvTQXmWiTrOG9lCmDFB7gjLdgVplfoZ6
51FnwGH4nXzPbPNMK8sF1DnmPbT3Ft+No1bDF3SLMoDuBx3RRfIFeivfrAup
5eYZVnZ1iSaZ3wFlPyeyqT2FkdEJ5plWlrOoY2APfGb9RxnTe0EeulN4O8T8
Lsjj83DB/Cz9R3s1U81SPWrR58yfXc94EX3J/Cy9g7KjzBdHhpRNzSwTGVVW
9M5FkZnqyJSyJE9WhGfySnfwDPqs+bNrBsrSiJhNaXivjObHDHpRlypzyTN4
U73MZ6UMaPa6A7mRgWUxs4LYo7stj+SN7vhl6hVzr3WH/wO4sa/7
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kk3FQAUwPHXOTbtbFs6xxfoG/QJiCShZGqQKUNRGYpmmkiaRKG5yPge
zzwWjVQK276G3zvH4nfP3d27+MdkFSUW7ggEAiH+E9kfG0d4ShtPqOIqV4jn
Cyd5TTt5vGKUETKJY5lqrnONBL5RwFs6yOcNY4TJYi9fqaGBG+zjB0W85xmR
598xwTjZJPKdWm7SyH5WOEUPzynmA1NMkkMSP7nAbW5xgF+U8pFOSuhlhmly
SWaVi9zlDgf5Qzn9dFFGH3PMcpQUflNHM02k8ZczDNLNaQZYYJ5jpLJGPS3c
4xDrVDLMCyoY4hOLHCedf1yilftksMk5QrzkLEGW+MwJDrPBZR7ygEecj9zW
US6VNNLBAIMMMUxwu7sRRgkzxjgTTDLFNDPMMsc8C/TTTgMV5JDAHnYTyy6i
2UnUduNbxc9vZg==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "1.7763568394002505`*^-15"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.27272727272727315`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545454545479`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQ1NcVxzFpO7HjNo86tqE+eIkrIqIBXzG9dta31pBak2lqNwa1McGp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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHkc1/Mdxz8fQjqkS+hS6VKKbql035HSgUK5QqWQe3JT7hyh5JxjldbM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            "]], PolygonBox[CompressedData["
1:eJwtk9dqlVEQhfck0Wg0QYOEcAgSL3wB38AHsMXexUtLYk/svfcuiiV2RIKI
iKix96ixxxh7IyIiIiKiRr/FDJyPWfucs2f//5q1u4yuKCvPSin1gBzYbSmN
Aj7pE2xDLIan6A+wE73L/LdmmIXeAR/Rz2E4ejO8RzfCfvRxaAXfWV+lXoPW
0JX1SOpW895NsBddo/PhK+vr1BvQBrqx3kc9BtnwjXUf6nJ4ib4Dq9Bz4Tb6
FaxBz4O76NewHb0EniV/5r7oleb/rYfH6AGQQRdTB8JaeMP6IfRHrzbvdR8G
o9fDW+2Fk+hKaEC3pZ6C6eZetKNugoXwiPW75O8y0bxXdng12fwseXYCppr3
zqUOhY3me3XGBvQCeJD8GU6jZ5p7mU89CuPNvfkH69Dz4V7ydzqCHgt16L/J
vXkBpeGRZlFh7o1msgUWwZPkM1Y2mqBzZES/NUJJ/KeBOihmnaEeNPdI3vzk
u0Phkbz5lbzXMOievOcUOAA/kmdmWvTQXmWiTrOG9lCmDFB7gjLdgVplfoZ6
51FnwGH4nXzPbPNMK8sF1DnmPbT3Ft+No1bDF3SLMoDuBx3RRfIFeivfrAup
5eYZVnZ1iSaZ3wFlPyeyqT2FkdEJ5plWlrOoY2APfGb9RxnTe0EeulN4O8T8
Lsjj83DB/Cz9R3s1U81SPWrR58yfXc94EX3J/Cy9g7KjzBdHhpRNzSwTGVVW
9M5FkZnqyJSyJE9WhGfySnfwDPqs+bNrBsrSiJhNaXivjObHDHpRlypzyTN4
U73MZ6UMaPa6A7mRgWUxs4LYo7stj+SN7vhl6hVzr3WH/wO4sa/7
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kk3FQAUwPHXOTbtbFs6xxfoG/QJiCShZGqQKUNRGYpmmkiaRKG5yPge
zzwWjVQK276G3zvH4nfP3d27+MdkFSUW7ggEAiH+E9kfG0d4ShtPqOIqV4jn
Cyd5TTt5vGKUETKJY5lqrnONBL5RwFs6yOcNY4TJYi9fqaGBG+zjB0W85xmR
598xwTjZJPKdWm7SyH5WOEUPzynmA1NMkkMSP7nAbW5xgF+U8pFOSuhlhmly
SWaVi9zlDgf5Qzn9dFFGH3PMcpQUflNHM02k8ZczDNLNaQZYYJ5jpLJGPS3c
4xDrVDLMCyoY4hOLHCedf1yilftksMk5QrzkLEGW+MwJDrPBZR7ygEecj9zW
US6VNNLBAIMMMUxwu7sRRgkzxjgTTDLFNDPMMsc8C/TTTgMV5JDAHnYTyy6i
2UnUduNbxc9vZg==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", 
          "1.1102230246251565`*^-16"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272727272728`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545454545455`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQ1NcVxzFpO7HjNo86tqE+eIkrIqIBXzG9dta31pBak2lqNwa1McGp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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHkc1/Mdxz8fQjqkS+hS6VKKbql035HSgUK5QqWQe3JT7hyh5JxjldbM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            "]], PolygonBox[CompressedData["
1:eJwtk9dqlVEQhfck0Wg0QYOEcAgSL3wB38AHsMXexUtLYk/svfcuiiV2RIKI
iKix96ixxxh7IyIiIiKiRr/FDJyPWfucs2f//5q1u4yuKCvPSin1gBzYbSmN
Aj7pE2xDLIan6A+wE73L/LdmmIXeAR/Rz2E4ejO8RzfCfvRxaAXfWV+lXoPW
0JX1SOpW895NsBddo/PhK+vr1BvQBrqx3kc9BtnwjXUf6nJ4ib4Dq9Bz4Tb6
FaxBz4O76NewHb0EniV/5r7oleb/rYfH6AGQQRdTB8JaeMP6IfRHrzbvdR8G
o9fDW+2Fk+hKaEC3pZ6C6eZetKNugoXwiPW75O8y0bxXdng12fwseXYCppr3
zqUOhY3me3XGBvQCeJD8GU6jZ5p7mU89CuPNvfkH69Dz4V7ydzqCHgt16L/J
vXkBpeGRZlFh7o1msgUWwZPkM1Y2mqBzZES/NUJJ/KeBOihmnaEeNPdI3vzk
u0Phkbz5lbzXMOievOcUOAA/kmdmWvTQXmWiTrOG9lCmDFB7gjLdgVplfoZ6
51FnwGH4nXzPbPNMK8sF1DnmPbT3Ft+No1bDF3SLMoDuBx3RRfIFeivfrAup
5eYZVnZ1iSaZ3wFlPyeyqT2FkdEJ5plWlrOoY2APfGb9RxnTe0EeulN4O8T8
Lsjj83DB/Cz9R3s1U81SPWrR58yfXc94EX3J/Cy9g7KjzBdHhpRNzSwTGVVW
9M5FkZnqyJSyJE9WhGfySnfwDPqs+bNrBsrSiJhNaXivjObHDHpRlypzyTN4
U73MZ6UMaPa6A7mRgWUxs4LYo7stj+SN7vhl6hVzr3WH/wO4sa/7
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kk3FQAUwPHXOTbtbFs6xxfoG/QJiCShZGqQKUNRGYpmmkiaRKG5yPge
zzwWjVQK276G3zvH4nfP3d27+MdkFSUW7ggEAiH+E9kfG0d4ShtPqOIqV4jn
Cyd5TTt5vGKUETKJY5lqrnONBL5RwFs6yOcNY4TJYi9fqaGBG+zjB0W85xmR
598xwTjZJPKdWm7SyH5WOEUPzynmA1NMkkMSP7nAbW5xgF+U8pFOSuhlhmly
SWaVi9zlDgf5Qzn9dFFGH3PMcpQUflNHM02k8ZczDNLNaQZYYJ5jpLJGPS3c
4xDrVDLMCyoY4hOLHCedf1yilftksMk5QrzkLEGW+MwJDrPBZR7ygEecj9zW
US6VNNLBAIMMMUxwu7sRRgkzxjgTTDLFNDPMMsc8C/TTTgMV5JDAHnYTyy6i
2UnUduNbxc9vZg==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", "0.`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272727272727`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545454545454`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], ",", 
   GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1mHtQ1NcVxzFpO7HjNo86tqE+eIkrIqIBXzG9dta31pBak2lqNwa1McGp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      "], {{
        {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
         EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmHkc1/Mdxz8fQjqkS+hS6VKKbql035HSgUK5QqWQe3JT7hyh5JxjldbM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            "]], PolygonBox[CompressedData["
1:eJwtk9dqlVEQhfck0Wg0QYOEcAgSL3wB38AHsMXexUtLYk/svfcuiiV2RIKI
iKix96ixxxh7IyIiIiKiRr/FDJyPWfucs2f//5q1u4yuKCvPSin1gBzYbSmN
Aj7pE2xDLIan6A+wE73L/LdmmIXeAR/Rz2E4ejO8RzfCfvRxaAXfWV+lXoPW
0JX1SOpW895NsBddo/PhK+vr1BvQBrqx3kc9BtnwjXUf6nJ4ib4Dq9Bz4Tb6
FaxBz4O76NewHb0EniV/5r7oleb/rYfH6AGQQRdTB8JaeMP6IfRHrzbvdR8G
o9fDW+2Fk+hKaEC3pZ6C6eZetKNugoXwiPW75O8y0bxXdng12fwseXYCppr3
zqUOhY3me3XGBvQCeJD8GU6jZ5p7mU89CuPNvfkH69Dz4V7ydzqCHgt16L/J
vXkBpeGRZlFh7o1msgUWwZPkM1Y2mqBzZES/NUJJ/KeBOihmnaEeNPdI3vzk
u0Phkbz5lbzXMOievOcUOAA/kmdmWvTQXmWiTrOG9lCmDFB7gjLdgVplfoZ6
51FnwGH4nXzPbPNMK8sF1DnmPbT3Ft+No1bDF3SLMoDuBx3RRfIFeivfrAup
5eYZVnZ1iSaZ3wFlPyeyqT2FkdEJ5plWlrOoY2APfGb9RxnTe0EeulN4O8T8
Lsjj83DB/Cz9R3s1U81SPWrR58yfXc94EX3J/Cy9g7KjzBdHhpRNzSwTGVVW
9M5FkZnqyJSyJE9WhGfySnfwDPqs+bNrBsrSiJhNaXivjObHDHpRlypzyTN4
U73MZ6UMaPa6A7mRgWUxs4LYo7stj+SN7vhl6hVzr3WH/wO4sa/7
            "]]}]}, {}, {}, {}, {}}, 
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0kk3FQAUwPHXOTbtbFs6xxfoG/QJiCShZGqQKUNRGYpmmkiaRKG5yPge
zzwWjVQK276G3zvH4nfP3d27+MdkFSUW7ggEAiH+E9kfG0d4ShtPqOIqV4jn
Cyd5TTt5vGKUETKJY5lqrnONBL5RwFs6yOcNY4TJYi9fqaGBG+zjB0W85xmR
598xwTjZJPKdWm7SyH5WOEUPzynmA1NMkkMSP7nAbW5xgF+U8pFOSuhlhmly
SWaVi9zlDgf5Qzn9dFFGH3PMcpQUflNHM02k8ZczDNLNaQZYYJ5jpLJGPS3c
4xDrVDLMCyoY4hOLHCedf1yilftksMk5QrzkLEGW+MwJDrPBZR7ygEecj9zW
US6VNNLBAIMMMUxwu7sRRgkzxjgTTDLFNDPMMsc8C/TTTgMV5JDAHnYTyy6i
2UnUduNbxc9vZg==
         "]]}}], {
      {Hue[0.67, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., -1.}, {1., 1.}}]}, 
      {Hue[0.9060679774997897, 0.6, 0.6], PointSize[Large], 
       PointBox[{{-1., 1.}, {1., -1.}}]}}, InsetBox[
      TagBox[GridBox[{
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(0\\)]\\) =\"\>", "0.`"},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(1\\)]\\) = \"\>", 
          RowBox[{"-", "0.2727272727272727`"}]},
         {"\<\"\\!\\(\\*SubscriptBox[\\(w\\), \\(2\\)]\\) = \"\>", 
          RowBox[{"-", "0.5454545454545454`"}]}
        },
        AutoDelete->False,
        GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> Center}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], {0, 0}]},
    AspectRatio->1,
    Frame->True,
    Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
    PlotRange->{{-1.5, 1.5}, {-1.5, 1.5}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]},
    ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]}], "}"}]], "Output",
 CellChangeTimes->{{3.475748039568465*^9, 3.475748057162164*^9}, 
   3.475748589598294*^9, 3.475850138925832*^9, {3.475850199181432*^9, 
   3.475850214698821*^9}, 3.475933602014897*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["MADALINE", "Section",
 CellChangeTimes->{{3.475906074698186*^9, 3.475906082177202*^9}}],

Cell["MADALINE built of three ADALINEs and majority:", "Text",
 CellChangeTimes->{{3.475910759251669*^9, 3.475910820228568*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ADALINEs", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1", "+", 
     RowBox[{"2", "x"}], "  ", "+", 
     RowBox[{"3", " ", "y"}]}], " ", ",", 
    RowBox[{"1", "+", 
     RowBox[{"3", "x"}], "  ", "+", 
     RowBox[{"1", " ", "y"}]}], " ", ",", 
    RowBox[{"1", "+", 
     RowBox[{"1", "x"}], "  ", "-", 
     RowBox[{"1", " ", "y"}]}]}], "}"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "list", " ", "of", " ", "three", " ", "MADALINEs", " ", "with", " ", 
    "\"\<random\>\"", " ", "weights", " ", "and", " ", "threshold"}], " ", 
   "*)"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475906976331273*^9, 3.475907009305389*^9}, {
  3.47591083514565*^9, 3.475910882977783*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{"2", " ", "x"}], "+", 
    RowBox[{"3", " ", "y"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"3", " ", "x"}], "+", "y"}], ",", 
   RowBox[{"1", "+", "x", "-", "y"}]}], "}"}]], "Output",
 CellChangeTimes->{3.475907014714924*^9, 3.475933102512278*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lineEquations", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Reduce", "[", 
     RowBox[{
      RowBox[{"#", "\[Equal]", "0"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "&"}], "/@", 
   "ADALINEs"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.475906841846944*^9, 3.475906864059334*^9}, {
  3.475906942670844*^9, 3.475906942817729*^9}, {3.475907032984956*^9, 
  3.475907070018*^9}, {3.47590710916751*^9, 3.475907111957211*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"y", "\[Equal]", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "3"]}], "-", 
     FractionBox[
      RowBox[{"2", " ", "x"}], "3"]}]}], ",", 
   RowBox[{"y", "\[Equal]", 
    RowBox[{
     RowBox[{"-", "1"}], "-", 
     RowBox[{"3", " ", "x"}]}]}], ",", 
   RowBox[{"y", "\[Equal]", 
    RowBox[{"1", "+", "x"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.475906851511444*^9, 3.475906864593204*^9}, 
   3.475906943428907*^9, 3.475907034632543*^9, 3.475907070735659*^9, 
   3.475907113648732*^9, 3.475933102655953*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RegionPlot", "[", 
    RowBox[{
     RowBox[{"Majority", "[", 
      RowBox[{"Sequence", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "<", "0"}], "&"}], "/@", "ADALINEs"}], ")"}]}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"lineEquations", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.475906158699741*^9, 3.475906306487654*^9}, {
  3.475906347952045*^9, 3.475906455174059*^9}, {3.475906489719705*^9, 
  3.475906513661484*^9}, {3.475906567149831*^9, 3.475906579123296*^9}, {
  3.475906662625581*^9, 3.475906693120173*^9}, {3.475906906079686*^9, 
  3.475906949345047*^9}, {3.475907177680588*^9, 3.475907210376598*^9}, {
  3.475907242298275*^9, 3.475907246933902*^9}, {3.475907328221331*^9, 
  3.475907382087645*^9}}],

Cell[BoxData[
 GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJx1WHtQ1NcVBmNxVFYdtcYwDKmUmC1qRAs+iPHS2ehYY+OGMSYq3ZhWrbqj
yWhiusZnIhuCGhVXaUhiWI1GfIHPJLp6QkRl0diFARc3iMA+eEtKtRrbSOO9
8x1mroP/3Pn2d+853znnO+deHPKXN1LndwsLC5sXHhb2cPWfXXWpo6ONsGYs
+OHOEWcL4xF9k+MspkbGZV/9I9UQDDJ+Z+7ddS57HeNx/Q9ZvOZqxu/9ddGZ
JIeX8ZUTQwc7vB7GwyKLGwNJRYzvne612d5+gLripa/gBwx+wOAHDH7A4AcM
fsDgBwx+XeVJ56Wv4AcMfsDgBwx+wOAHDH5d1UnPi85DX8EHGHyAwQcYfIDB
pyud6HXR86Dz0FfwAQYfYPABBp+udKrrQq+Dngedh76CDzD4dNUXug71uut5
1+PW/eor/HfVh7rudZ3pddbzrMep+9VXve/1PtN1retKryv8A8N/V3NF72P4
A4Y/YPgDhj99TrkUFrAPDPvAsA+M89GKL58Hxnlg7C9S+eT9wNgPjP0rVV54
PzD2A4MfMM4nqLj5PDDOA+M8MPIHDHvL1e9sDxj2gGEPGPaAYe+q2sf2gGEP
GPaAYQ8Y9n6nzrE9YNgDhj1gnN+gzvF5YJwHxnlg7d4T2j0jtDkvtDkrGqWu
TpNPrk0EvE7Ws57qJC6hEqmPGsY35Oqjp6XOyh/5HXbQX8Bxcn+AwuS/Iy7Y
BYbfy2o/8wXG9yeVXwF7FcqvgL2LauXvq9Q5xtdUvBw/8oQ40LeIT58n4At7
6E9g1He0xCeo+/zdr7ZHNZFd8rhEIZn/m7RS2ivj3xPkueuEcy+eeu2k2eKn
XdJ+jsgzhH/gdIWoUMb3rcD31G9K29zWBlEu81VBHvWd/vt6QozNEKSByh7H
O0bGd4vnEvCgM9IPRS4cuN1qbON8IC7kAVj3g3xhxRwHfk76uUrgmdtryzRj
fi3HBx2WKb+cz9+olfsPGOenqjywPhJVPKwfYPBMc5niTbZWtgf/yA/6CHU4
2m95YVRJM+cD51A38NDjRn0RN/QJP8CoA3SBOiB+zBvUe6/SgQAfxI36AKM+
0A34oU/BExg8oUP0AfhmyrxUcV5QL/Qn+gh4ptIl6xX70b/YD4z9y1TeuJ7o
b2D9/sF31Neo+LN+9Hmg3zf4jjpWqzow/lSt7B/zA/6B4f+w0gv36xWld8bg
h3q+p/LKGP597od2kx95l4xOq7oRuNNE1fFjajo6jj7yDoqdeW9hu6+Gqpbl
jjHZLj7y7kpJecnT0fFLXzdkTTT9VMrnroa7S6My63ie4dzFpPML2qOy2M+Q
GaNTjPnFnL+477IXe7fWi9+uHDHQ8bif519i8pI5hmABFfXyLvAWNNIH95+9
7W6+QAt6hvzuYTfp/sG5n9mPlfLv+/9UKIxtldQ/IviKIXiMYkfNzbNm1FF4
weoIh/eACB0qctizQlQ6dnBtx9pC0SfNcT7pdh1lDfisNlDRICaGJn5ptmyk
K4Y/Os3nbtFST1yO1XiQdbp1W58RFtMJOtCw8FLU4gband3uNFvOkavH/OGW
PQHKkN+LuC+T9kX+uT3nEo2+0HOveVcVibw12db9V2jmY93e8ParoHfvur8x
V3t4LiSH3x5m8ZdT4pbTO6z7z/L9F5B1OEXvyzgruJ+ORFRnOjcFaF1o9gbn
hK/F1LCtiZbHOu9D6MvT7W2/20oiVfrtvA9nVC/KN58LUYmsW5m4by++0fGa
n9YV9H7bNfm62DXy6cj88BrKUauYW3B+tmFSLWX2G/altdgvUG/cjzh/KKn3
emd0k0BePh3UN9ribxVfXMgeYDOc4Xcv4oiftXiPtSHIukLcyMsomUcvz58X
Ms4MNdmINv18+BnTTz7WNeYQ6oZ+XdQ6699u6ylR2f3ZSEd2Pb9v0Y/n7Ov3
WY1F/B3vWXxfrurU+Z570brROaFcgDfmz6rDHyebxgd4vvB9rviz3jco3pw/
zB/0HeYLdHRzxvQwxyvV/B3vUXyPpqcSLO/XsX+87+B/uNRfizgu83+Qnmly
zvP+2EQ+GUcRxQTOtgUqaihO2vfQ7//+t2Z3cwnZnxg/wdjmI5wrzwrbbs+q
pyXuuCnGkUUC/WVMLPMHdtSLnwe9/KbX/AVNiezX3TG2hUbsyYm1bf6OxkUM
3+KMrqNpUp8eXge+/q+d1ntVdG1U0nTjyFzaN/rjyca+QYqTea0Q0364+5a3
oJZ8PQ5PNuytErDTp/+8543TQwJ9gTq1NOQ/OOL8ilJ67nJHxddT9c6K2sDJ
YtaF/6UbF6KmuskS8VaeOcbHfVr5ZN4sQ3CbKLbOOmyd0vn+y5w9Z6htSQ1F
9G3vmf+HWhF3/v4a1z4/z+vA0f/ddV/206BfX1vjTGsWmHN4D/kqH+6Lp3Gt
Az43P2ijTVKXn9CJZl+4451Wxr02H0ptX9nK86VbZvJg25IG1jnqOFn2x2ka
Wj8y3uIP0lqpy29pd/A/m5xpfsboQ8yfOpU/2j7Efz2Q9D330TapwxKKl/PX
Sy1SZ1cpVuqpjHGZmg90ZctHrxrSO+dpVV7qbEN6LX206IXF7VG5YmfspN75
62to6aZ540y29M6/11Rfiw1yrjTy++yTU2kpxuwGmrf0OZsrdFEg7irlV6y4
mnbQurCW32sr0rekmK7XUIzSHetjt9IN42nbLt1x9w7yPJrhGJ9geqJJlD71
YJXrYoDfc56qhP6Osb/c52Ofj7HsaRHQ39fjVp+Jim9jPDf74GLX0DbhWXq5
PvBy598/rfL+dPJ7zyjvw0J+3+2cNDjdvuyfj/x/xuS9P651ug6IFY/HD3Lc
reX3GfrMvnH5yaTbnf2JuNGfqFv3OYZY240yCsg6FNL2402/yv/QT7eGvDm/
3XdMTOtRmWt+UE3lu9dMMuan833oUX0soKc1GeHvukJBtuuTc9BLifKd0Nn/
w1Wfc/8DRytenM8ydZ7rlXF8dX7SjGrGxUpHvL9yx7LvOz5vEeCxQs6xcp4v
wxUP8X+qN7W4
    "], {{
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNl3mU11MYxu8NSaQypEbbVFNSM5VqSvtOmkoTZYukRSYJUdbsKbLvRPYY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          "]], PolygonBox[CompressedData["
1:eJwtlElsTmEUhr9Tc6mxphqSbrqwMc9zglI2qMTY8pPYCLG0QKmYp5hpQypK
CCIiEYlEmkgsLEiIoOZ5qKmGslCeN+csnpz3/N/97/3ued/v5mdWzFielVKa
DE3hB7yFg7ABullKGbiD3gEPYCb9BWoufIS+9Eepx3Qf9L+4di98gTx+208t
g88wiL6KehzqoDv9PuoaGIb+Sl0Hu6AF/XyoQZdDF/QiuI3epj2j58G1+M9A
9CfqWtgJWfRz4Wr81gc9Bk6iN8I3GE5/gloNtVBMf1HvBb/gD2yGSngGs1m/
rOvgL0ygP009A49hFv0laiG0RS+Gu+gt8B1+xmwr4AXMYf0KdSU0QY8w38tY
eAdPYQ8cgjfwBHbDAWiE3lx/hLodEnoKnEWeg47oJXAPvRXaoUvhJjoD082f
oXufh1702bAJfRh6mntQHpnoii4yv/cqaI0ugRvoEvgAL8N77akzaxPNZ7MM
mpnPoCLeoaX5jCvjHX/D+3i2Zt6J9YVwC70UXsOjyIYydR/6mWcvG17Bw/Be
mRrAWn/zrCqjyopmrNkqM8qGQUHyjAxFDzH3viq8aYzZyqNR9CPNvVVmnsN4
+lO6d3Kvc8xnK8/roYe5V+vj2nHms9J/CtGTzL1XhpT15ubZqomsNURWlbkF
9K3Mn3U9+VnUGdLZ0Zkcbe6pvFTG9W6Dzc9aQWRbZ7Isecan0U+F1ckzo+zW
x16VYXnbxjy78ljZaW+eJWVIWdGetBdlRt8KZUTZ0DdD3uWan1V5qLOrTCgL
OsPKZgdzb5XR/9Hrke8=
          "]]}]}, {}, {}, {}, {}}, 
     {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwt0ls3lGEYgOEZI0L7UkqSdlIUiXayLbRBSZHdZHTgJNbqoIPiL/k9aack
RCkqqZDrXXVwrftZz7vWvDPzfXmJodbBaCQSGSWJMGeQyQHyKeY81TTSwl3u
002cfgZ4xGOe8JRnDDNCkw+/wU2uRf9ddp09JMjiFEX8DXfpe50N38W8Fu7U
CT2qrdTTwBVW7a9qJn3sppCTrDjbpQ/YyRG285Ad/HG+TeNs5TCb6WcLv51v
0l4yqKOaGt45q9U0ekgnh4/2y/xiiY127YybZ7htvkwlJ6jip32HvtVDmkI3
qexn2v47P/jGBrt7vDFPkW1eDM9HX2ue3uISFVxgwf6ixugimQKO8zU8a32l
H9hn/qJt+lIPagvlnOMs8/ZlGqWTJPI5xmdnpfpCJ9lr/qR3dExztZkSznCa
ufDO6XNNJy38d6SSEn4zycT+v7PreQRCoQ==
       "]]}}], {{}, {}, 
    {Hue[0.67, 0.6, 0.6], Thickness[Large], LineBox[CompressedData["
1:eJwt1Ps3FHgcxnEGERUqOmNjSgg5Su0O6fLRRaFYZkktxWg3rYi1Cqsmwoku
tFFZlS5GUdalmwgfxkxT0oUxbhMxjLnUzDdkwzprp3P2h+e8/oDnnPfSsGjG
zxQNDQ1v9b7qCKaKmRmCOSXmLgEBQoieXJYxOUVQfrNH/5aPECoeONmMjROE
/Mu9qu1CWG3rHTb8gaDytHFqhqsQnI3Telo6CXpG6rx+ShOC2+BI85/lBGcc
lfstFe3AOPXq3poQglEPa7MJqx3i36RFhder0BODpJnFAmhvN1A0MpUY/czQ
5a/OVjBviF7ovPgjJgUoeAXWb+HRIa6OYa8C6TSmoe1EC4SedfrUfVKOu452
C0nwC5i4kJSBIMONvQWm/jM8KJzXR80bGEa95b75F/dw4KqXU6wgU4Ifz1Ua
1GXWwclIZoKd5xCGKoM7T4keQ5LW3fhYpRiXWDf4mbmWAzP5jVVH8QA+KZvq
vfTgJlysk+RdjejH5C1eNlxuCtS8t51TatmHnyg7WScGc3CZkdtm/wIR5vnf
Ldi47w7et8+IEA92oVUWrGWP38f3vMoldHoHlron/WBmVoMSh4ur8bEAXx/O
qr3HbEBjVgndUbMV5YG/zYn6twkd6MShaKwFXZwMxH/s5WPqVuXb6gQ+Fi+v
iuvWfokm/mXn9yzi4Cj/zHXqldd4/2+e4XOrGnQpnV3cN/kWi0SSc/K0MtRN
7ezb1NyGe/0WPxTtz8WRVlZXR1I7VusnCTlHcoB/xNVCZtWB34k1LVJ2l8NK
22SO/mgnLvv0dNKVUw0VjOt2ITe60bOw+5XPbg5wzngQbqwI3b3na40/4kMj
dZbmnfW9mB3SmbyqqgV6aNeENdI+5PuYz/Wd3wqbzUK0Y4L6UbnUhNWWLwB2
aPCJK2sG8EjcCma2aQcca92/JF1XjJ3vjBgHnnfBVc+KmHj1D6GJ66W6O0XQ
fPyXWxTuIDatcD7dpNMHbtXhqZdKh9Bmdq2M7dEP3Io296Z0CZrXHnLXyRiA
+rbtjmU/DqPGFKUkViwGjWnNZzc3SfGLX90+nvUQfD9gC45UGYq+DfnGOk0C
0le54U0UOcYEGhlbvhuG8SH9x6YyOVJzh3Zrm8vA6IlSQqlXYFnQjTtjCXKI
u2DC+1L0AQM3nPB4XqeAIdu76emsj1i5L8rSdfoDNMs9IlsZSpzQ36JVHaCE
qUoHis1aFTJa19HN81RApx9PXGBEUH+dQWPtNRXMagteIVhAsJHdsyO4UAUd
Uet7LywiuCohkXmlTAVxRf+4zacRnEerOkvlqeDhwt/1jB0JvohcPWgyqoJV
Y0cvz9tJ0E3P7rxasK+IeTQ7g+DErxNmZX4Epnb4hr84Q7BcxC/yDiTQLF1J
zcwmaFF+4OnZMAIHaeSY3mWC0wHsYf1EAsVZUVt1bxOsKqRtUAtWURECbS7B
w3MJ//Y9Ap/1vNK5fII28fWMbZUEuGw757SXBHO99h5MryUQ9k6WryUgGDuS
n6MWbuwID6OICdoHRVgUdhGIkW5byJEQHOCuLdncR8At1eZZipygb15XvVro
r5HYaY4Q1KMUey4lBCp28UQNnwniofh2tcAaZZ9LniB4VLgtJHSKgE9WGrhN
E/y/X2Bh/9PI1479B3Qdo9c=
      "]], LineBox[CompressedData["
1:eJwt1Pk/1HkcwHFHklHzRY1dapSjeSS2BzajRb2tzTWOrSnRo3JtqSham1yp
WIp98Gi2tKu7FpVqR0qHwucT46gHDzHjHIsZxxoxn4mJacjs7uOxP7wez//g
ZRkVzz2go6WlFfhv/7kBTMc1GoIEYZYDGo0G4j9Z53xSE8SacQ44odLAoyeO
rOmPBOXkcyonFBpwWhcYNfqeoICqny72SDTgYpzV29xFULtZg8+TOg14DH14
e7mMoEFRzKPocxrgnmt58HU4QfOciowWugaSWrOOHqyRIycXH5urzAUQiQzH
X0dOoi3IeOAPk3lg4vgVLqsmkP2tuze469XwNFagR/01jni37+T85q+CiDxH
RU+mDPG4nDHvrTOgupCWg2AMHd9bGXAzXAlF9H6zQskoUjJaWPu5U3CN45gg
zB1B48TPrjpIAZlHIpNt/YbRWS+bwyfFE5Cmez8pYVKKjtEWokOaxiDyTKtN
5z0JssmIi8tUD8Ol6pHCazGDCG8qf9sBEng5sG7pQ6t+5HAz1WbRoV6wNvLw
3HlDjA454Ib53nZ4vD4nRjrUjRy0HE8HhdTDQH35Gja7Ew3m3TdaziiBEftL
TuiZEHmMaN82iH+CjE+Vsjdot6FCQ/0X46o3yJ5N7Eumm1HNhsvuORdE6Oet
k+8qkxuRu9k1b9nbPsTYyeft/qIWKTzShSfjpOjxTD3VZPMSpdcx1BudRlGJ
eCRflsVHbaP7nVf4jKN921dViH8oQOGhzINFpnJUSUvrqE28CBkCbatsmQI5
S7UtMkLLwPmrd+YBiilkrXj1ybW2EhZvFtJjRUrkV9TTEhRaC+7XHfOZkhnk
FWii+/FpI6j7WBK3YRU6H951xuF5M3TWbXN4LFCjxiDmsm0mbcCY6zCoaplH
k5aMU+1XhJDQc76fWbGAEo/bRZ437YSH/scEib5auKvPiBvd1A3vuA1hLH9t
HJHi/rd+gBiy/nw2k+mug+vsXH6p0+uHw49EO2w9dTHLoGqs2HcQ+hbn89PY
izCzKtZLL0cCpi1GSl2WHtZS65QmSKVwxq12ocN2MZ7dXh1Wv3YYUj4v09+5
Sh+LN4avXJs1AsUHz4lWWi/Bx0KMjK36RqHg2+Y8s7UG2KxgOHQRcwyWxz/w
rGPQMH/PrbvTyTKo3fqi+pm5IQ7ZfNq3qXoctOPC2bvoS3F52FEr1/n3oKff
ftnu81Kson2nWxk8Ca6+CbUcLTrmtrmxmYVyWOh7OMaYomOam+Hrquty8D3S
xAucoePXxb3+e4vk8Ovc0KZsNR07JKdEXuXLwcZ8Za5Sh8L01c/zzOrlwAnJ
tRUup/CbI05DjCk5/N52IIbnTGGPJbY8egABhwaLCVoKhVU/qsz52wmkBrsW
eKZTuEzcWBIYQqBuONg9NYPCFmXRr/KiCOzSzc+T5VJ4Prh4lJZCIN1jzr7p
CoWfF63erH+HwJuXXUezqygct4w03nlAwIQzzajGFGYl1XC9ywns7aHXKAUU
LuDsO5RdRYDMetH3t1A44cOVi7pCAqbOFXzPfgqv3xNjUdRNIELQuitVSmGJ
4JtSz34CpTveL5SPUnhbYXdNhoyAe4LV95aEwkt07vlZEgJntbfMhk5TGMUm
ibCSQCtv903eLIVPdHiHR6gJfLkm0adpjsL//wuiynhEo6HwP8mUg6w=
      "]], LineBox[CompressedData["
1:eJwtlHs01HkAxT3qEOV1Uk01ynPzqJWtsaW6tiREm0mHTsVQqfSSzWK1Le0o
FXGiXYVWDSLtTF5ZGb7yiDpKDEbRYAx5zs/7lfzWnrN/3HPv59x/77n6PhfY
J5QUFBRc5vWfb8CyPpqmyHysL+09sePCtGHk9Mw82630b2PY4VnuRpPR8XlO
SUjKZbjBap2LT3f/PL8T5yQzjsNam/uxRkyRsOOTxXcYl2DbOfzmnmC+t7y+
K5rBBfv626zvvChSqvvjtZuMeATVcs+dLJGTWNXcb24wUtHQoN730nuQcA49
FAwN54FZemGp9eoBsoIOP7JHjyD/TMVCzU99xMJV3lN+qwKcqI1DH672krB3
W5Aw9hpTd0IjCXrI2jxtiaJiLXgaEkZCRzd5Id1VU7utHklOGwNEN7pItV/y
qkMDDbh61jvY1FFGZk22a/59ToxQ5SdBAYNSojadpbXK+CO8w2qNmjI6yA6a
8/wAvxV3i7sSkvzaSRN307tXZm140bZu8VMDCTGM7Z/OlLfDUMt2p9uDFiKf
bJM0WkqRYxbpJ+1sJo/7it5o3O5EW2X2WhariWgxH1MymQxdFnetyHMRuX06
3zfFqBvaVzJZGxTryJRtluzUb59hwaIs0kZrSKBVRd6y8h78bjf4vjC4irTx
K27V6fdB140fe2h5Gfni15Bo+ks/ciYqNauNXhCzH1TmfIsGkNbSFd3L5RP7
R/ons5fLcdR1dV7LsXgSyPQy6DhCoVAttLEsMA7mAwfVxS5D2CxV1Av3EEBH
c0i1YmYIhkNF01vLCqFEEgWGScNw5H14u8+jDKc3FX1YtHcEu110lMfzq5Dp
6JNSMjGCGC9xmGVBDUb6V2p1/zGKqn3MJft16pBzYI9yvN0YBvV1r9TfFyHU
IeKvvO4xBF4y945Z1gTmJ6dmXsQ4xK1abN/qZrCsufEMqwlwQrZ9VnFugYde
7bSiaALl5tY3yxdKMPwmWuofPgmTRcKeVId2xC3wvMQ2mgJTeGb3wsgOaEjy
HylVTEFhRikzQCqFwq/hblsuTmPStdiz0liG2QxPgVRnBi2bvFYZc7tw/r4g
WqdsBv7uWtoGrd34xzxSVfv8FzDiZR4LmD1Y7BRgcVVjFvzDKY9Hg3shXv9e
FCKchfv23xyqi/vw9AGMZJ5fke15zmDrbD88BCxt5txXTKntUi48OIjLEQ/D
W5/MgV1nw2ImyJHZw0zUcKahZqP+UpgsR0RyBEeyj8bL1I97j/Dk4LAHjfmu
NCyDQ7wT+XKsEAqfubjT0FhTEMWolON6zOFXUT40Xp+16tQdkeM4696wWggN
W1XTWA1nCmu5Sx1U0mlMXZxayXelMPv95SXiDBqClqo0F3cKzYOd9elZNPQE
vkVRPhRi3HOP2mfTmD2Y2q0WQmHOjP1ThJBGAW/NdpV0Cq11MQ+URTTOL6Gq
0rMoFFybPCZqpGESVMK2z6YQZ+NlymumEe909FSEkIJT2oa8nRIaAcP345RF
8zsLfvs6vJeG2WE/PV4zhbvrN8e4DtDoqNiSuVNCwV+a5KZP0dif0FwS3kth
nfPZttIxGqpKGY76FIUFig2psZM0yJmghtIxCu35Nn6cGRo/N9p7cWYoFPnx
vrX8SuP//8Kfa9THaZrGv2vGijM=
      "]]}}},
  AspectRatio->1,
  Frame->True,
  Method->{"TransparentPolygonMesh" -> True, "AxesInFront" -> True},
  PlotRange->{{-1, 1}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.475906297273041*^9, 3.475906307218635*^9}, {
   3.475906362199343*^9, 3.475906407019316*^9}, 3.47590645093731*^9, {
   3.47590649559246*^9, 3.475906514156545*^9}, 3.475906579997999*^9, {
   3.475906670640606*^9, 3.475906693454169*^9}, {3.47590693830664*^9, 
   3.475906950521864*^9}, {3.475907182585576*^9, 3.475907211405709*^9}, 
   3.475907247844657*^9, {3.475907344702625*^9, 3.475907382913036*^9}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1024, 694},
WindowMargins->{{0, Automatic}, {26, Automatic}},
ShowSelection->True,
CellContext->Notebook,
FrontEndVersion->"7.0 for Linux x86 (32-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 165, 2, 73, "Section"],
Cell[CellGroupData[{
Cell[757, 28, 101, 1, 39, "Subsection"],
Cell[CellGroupData[{
Cell[883, 33, 441, 11, 32, "Input",
 InitializationCell->True],
Cell[1327, 46, 4163, 76, 251, 1623, 33, "CachedBoxData", "BoxData", "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5539, 128, 109, 1, 39, "Subsection"],
Cell[CellGroupData[{
Cell[5673, 133, 646, 18, 55, "Input",
 InitializationCell->True],
Cell[6322, 153, 3198, 61, 241, 1278, 27, "CachedBoxData", "BoxData", "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9569, 220, 93, 1, 39, "Subsection"],
Cell[CellGroupData[{
Cell[9687, 225, 283, 8, 32, "Input",
 InitializationCell->True],
Cell[9973, 235, 1392, 28, 70, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11414, 269, 164, 2, 39, "Subsection"],
Cell[CellGroupData[{
Cell[11603, 275, 1550, 40, 91, "Input",
 InitializationCell->True],
Cell[13156, 317, 2142, 40, 342, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15347, 363, 173, 2, 39, "Subsection"],
Cell[15523, 367, 331, 10, 43, "Text"],
Cell[CellGroupData[{
Cell[15879, 381, 338, 9, 32, "Input",
 InitializationCell->True],
Cell[16220, 392, 16033, 268, 241, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[32302, 666, 206, 3, 39, "Subsection"],
Cell[CellGroupData[{
Cell[32533, 673, 655, 20, 55, "Input",
 InitializationCell->True],
Cell[33191, 695, 6350, 108, 241, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[39602, 810, 99, 1, 43, "Section"],
Cell[CellGroupData[{
Cell[39726, 815, 98, 1, 39, "Subsection"],
Cell[39827, 818, 1231, 24, 55, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[41095, 847, 111, 1, 39, "Subsection"],
Cell[CellGroupData[{
Cell[41231, 852, 2086, 59, 77, "Input"],
Cell[43320, 913, 2835, 62, 450, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[46204, 981, 148, 2, 39, "Subsection"],
Cell[46355, 985, 1341, 38, 32, "Input",
 InitializationCell->True],
Cell[47699, 1025, 145, 2, 31, "Text"],
Cell[47847, 1029, 663, 17, 32, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[48535, 1050, 463, 9, 32, "Input"],
Cell[49001, 1061, 701, 15, 370, "Output"]
}, Open  ]],
Cell[49717, 1079, 108, 1, 31, "Text"],
Cell[CellGroupData[{
Cell[49850, 1084, 651, 14, 32, "Input",
 InitializationCell->True],
Cell[50504, 1100, 620, 10, 31, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[51173, 1116, 108, 1, 39, "Subsection"],
Cell[51284, 1119, 3042, 72, 231, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[54363, 1196, 170, 2, 39, "Subsection"],
Cell[54536, 1200, 611, 12, 32, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[55184, 1217, 96, 1, 39, "Subsection"],
Cell[55283, 1220, 278, 5, 31, "Text"],
Cell[55564, 1227, 762, 17, 32, "Input",
 InitializationCell->True],
Cell[56329, 1246, 133, 1, 31, "Text"],
Cell[56465, 1249, 3007, 71, 143, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[59497, 1324, 906, 18, 32, "Input"],
Cell[60406, 1344, 225076, 3873, 789, "Output"]
}, Open  ]],
Cell[285497, 5220, 92, 1, 32, "Input"],
Cell[285592, 5223, 92, 1, 32, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[285721, 5229, 196, 3, 39, "Subsection"],
Cell[285920, 5234, 1438, 38, 32, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[287383, 5276, 514, 10, 32, "Input"],
Cell[287900, 5288, 800, 16, 213, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[288737, 5309, 407, 11, 32, "Input"],
Cell[289147, 5322, 312184, 5359, 990, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[601392, 10688, 93, 1, 43, "Section"],
Cell[601488, 10691, 128, 1, 31, "Text"],
Cell[CellGroupData[{
Cell[601641, 10696, 728, 20, 55, "Input",
 InitializationCell->True],
Cell[602372, 10718, 324, 9, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[602733, 10732, 498, 13, 32, "Input",
 InitializationCell->True],
Cell[603234, 10747, 579, 17, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[603850, 10769, 1366, 34, 99, "Input"],
Cell[605219, 10805, 22231, 376, 364, 12756, 220, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
